package MainLibrary;

import Octree.*;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import com.threed.jpct.SimpleVector;

/** TODO IMPORTANT!!! 
 * Every time you add a new AbstractDomain specialization, you have to define the appropriate
 * addWrapper3DDomain() method inside Engine3D, that instruct the engine 3d to draw the object3D for that specific domain
 */

public abstract class AbstractDomain {	
	
	public OctreeRoot rootTree; 		// Octree
	public boolean useOctree=false;		// Octree
	
	public short ObjFor1Check=0;	// Check Collision by Octree:  (0) All NanoObj TYPES, (1) Only NodeObj, (2) Only CarrierObj, (3) Only GenericObj (10) NO carrier control!
	public short ObjFor2Check=0;	// Check Collision by Octree:  (0) All NanoObj TYPES, (1) Only NodeObj, (2) Only CarrierObj, (3) Only GenericObj
	
	
	public float boundingRadius=0;
	public boolean visibleOn3D=false;
	
	private static long countThread=0;		
	private final int maxThreads = Runtime.getRuntime().availableProcessors();				
	private ExecutorService executorThreads = Executors.newFixedThreadPool(maxThreads);	
	//private ExecutorService executorOctree = Executors.newFixedThreadPool(maxThreads);	
	
	public List<NanoObj> genericObjList=new ArrayList<NanoObj>();
	public List<NodeObj> nodeList=new ArrayList<NodeObj>();
	public List<CarrierObj> carrierList=new ArrayList<CarrierObj>();
	
	public List<NanoObj> undisposedGenericObjList=new ArrayList<NanoObj>();
	public List<NodeObj> undisposedNodeList=new ArrayList<NodeObj>();
	public List<CarrierObj> undisposedCarrierList=new ArrayList<CarrierObj>();	
	
	public ArrayList<NanoObj> exceptionList=new ArrayList<NanoObj>();	
	private ArrayList<AbstractCollision> collisionsList=new  ArrayList<AbstractCollision>();	
	
	public Random rr=new Random();	
		
	private LivingObjObserver livingObjObserver;	
	public Map<Object, Object> exportString;	
	public String ID="";	

	private MobilityModel mobilityModel;
	public AbstractCollisionDomainStrategy collisionStrategy;
		
	public List<AbstractDomain> childDomainList=new ArrayList<AbstractDomain>();
	protected AbstractDomain parentDomain;
	protected float[] center=new float[3];
	public boolean export=false;
	
	/** Orientation Axes */
	private SimpleVector directionP=new SimpleVector(0,0,0);
	private SimpleVector directionN=new SimpleVector(0,0,0);
	private SimpleVector directionO=new SimpleVector(0,0,0);
	
	
	public ArrayList<AbstractCollision> collisionsList1=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList2=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList3=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList4=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList5=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList6=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList7=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList8=new ArrayList<AbstractCollision>();
	
	public ArrayList<AbstractCollision> collisionsList9=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList10=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList11=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList12=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList13=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList14=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList15=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList16=new ArrayList<AbstractCollision>();	
	/*
	public ArrayList<AbstractCollision> collisionsList17=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList18=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList19=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList20=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList21=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList22=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList23=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList24=new ArrayList<AbstractCollision>();	
	
	public ArrayList<AbstractCollision> collisionsList25=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList26=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList27=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList28=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList29=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList30=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList31=new ArrayList<AbstractCollision>();
	public ArrayList<AbstractCollision> collisionsList32=new ArrayList<AbstractCollision>();
	*/
	
	// Checkpoints for concurrency access!
	public boolean cl1=true;
	public boolean cl2=true;
	public boolean cl3=true;
	public boolean cl4=true;
	public boolean cl5=true;
	public boolean cl6=true;
	public boolean cl7=true;
	public boolean cl8=true;
	public boolean cl9=true;
	public boolean cl10=true;
	public boolean cl11=true;
	public boolean cl12=true;
	public boolean cl13=true;
	public boolean cl14=true;
	public boolean cl15=true;
	public boolean cl16=true;	
	/*
	public boolean cl17=true;
	public boolean cl18=true;
	public boolean cl19=true;
	public boolean cl20=true;
	public boolean cl21=true;
	public boolean cl22=true;
	public boolean cl23=true;
	public boolean cl24=true;
	public boolean cl25=true;
	public boolean cl26=true;	
	public boolean cl27=true;
	public boolean cl28=true;
	public boolean cl29=true;
	public boolean cl30=true;
	public boolean cl31=true;
	public boolean cl32=true;
	*/
	
	
	// debug
	/*
	long moveTime=0;
	long checkTime=0;
	long avoidTime=0;
	long sortTime=0;
	long pruneTime=0;
	long globalTime=0;
	long octreeTime=0;
	long joinTime=0;
	*/
	
	public long localExportTime=1000;			// ORIGINAL
	//public long localExportTime=5000000;		// FIXME DEBUG
	
	
	
	public abstract void initializeDirectionAxes();
	public abstract void handleBoundCollision(NanoObj n);
	public abstract void handleBoundCollision(NodeObj n);
	public abstract void handleBoundCollision(CarrierObj c);
	public abstract String getType();	
	public abstract void setBoundingRadius();
	public abstract void trigger();
	public abstract void initializeWrapper3D(Manager m);	
	public abstract boolean isInside(NanoObj objToCheck); 
	public abstract Map<Object, Object> export();
	
		
	// FIXME GRID - (incomplete creation! Needs further settings after the Constructor calling...)
	public AbstractDomain(){
		setLivingObjObserver(new LivingObjObserver(this));
		setCollisionStrategy(new NoCollisionDomainStrategy(0));			
	}

	// Root Domain
	public AbstractDomain(Manager manager, MobilityModel model, boolean export, boolean useOctree){
		this.useOctree=useOctree;
		setLivingObjObserver(new LivingObjObserver(this));
		setMobilityModel(model);
		setCollisionStrategy(new NoCollisionDomainStrategy(0));	
		
		//if(useOctree) initializeOctree(manager.configurator);
	}
	
	// Custom Domains
	public AbstractDomain(AbstractDomain parentDomain, MobilityModel model, AbstractCollisionDomainStrategy strategy, boolean visible, boolean export, float[] dCenter, boolean useOctree){
		this.useOctree=useOctree;
		setLivingObjObserver(new LivingObjObserver(this));
		setCollisionStrategy(new NoCollisionDomainStrategy(0));			
		
		
		
		initialize(parentDomain, model, strategy, visible, export, dCenter);
		
		//if(useOctree) initializeOctree(getManager().configurator);
	}
	
	public void initialize(AbstractDomain parentDomain, MobilityModel model, AbstractCollisionDomainStrategy strategy, boolean visible, boolean export, float[] dCenter){
		setMobilityModel(model);		
		this.parentDomain=parentDomain;		
		setCenter(dCenter[0],dCenter[1],dCenter[2]);
		
		initializeDirectionAxes();
		
		/** FIXME To increase the performance, the InnerSphericalDomain are never attached on the parentDomain, 
		 * 		  because we never simulate the inner volume of the biological cells! */			
		if (!(this instanceof InnerSphericalDomain)) this.parentDomain.attachChildDomain(this);
		
		setCollisionStrategy(strategy);
		
		localExportTime=getManager().configWrapper.exportTimeLength;
		
		this.export=export;
		if (export) getManager().addDomainForExport(this);
		visibleOn3D=visible;	
		
		
	}
	
	// Octree
	public void initializeOctree(Configurator2 cc) {	
		
		//this.rootTree=new OctreeRoot(getAbsCenter()[0], getAbsCenter()[1], getAbsCenter()[2], boundingRadius, getManager().configWrapper.nodeTreeLimit);
		//this.rootTree=new OctreeRoot(getAbsCenter()[0], getAbsCenter()[1], getAbsCenter()[2], 2*boundingRadius, cc.m.nodeTreeLimit, cc.m.nodeSideLimit);	// OK
		
		//this.rootTree=new OctreeRoot(getAbsCenter()[0]-35000, getAbsCenter()[1], getAbsCenter()[2]-35000, 2*boundingRadius, cc.m.nodeTreeLimit, cc.m.nodeSideLimit);	// DISPLACEMENT
		this.rootTree=new OctreeRoot(getAbsCenter()[0]-63000, getAbsCenter()[1], getAbsCenter()[2]-63000, 2*boundingRadius, cc.m.nodeTreeLimit, cc.m.nodeSideLimit);	// DISPLACEMENT OK
		this.rootTree.setDomain(this);		
	}	
	
	// Octree
	public OctreeRoot getRootTree(){
		return this.rootTree;
	}
	
	public void nextSimulationStep(){			
		
		try {		
			trigger();
			
		} catch (Exception e1) {
			System.out.println("-1- Error on AbstratcDomain.NextSimulationStep() - DomainTrigger: "+e1.toString());		
		}

		try{				
			
			getLivingObjObserver().trigger();			
						
		} catch(Exception e2){
			System.out.println("-2- Error on AbstratcDomain.NextSimulationStep() - LivingObjObs.Trigger: "+e2.toString());			
		}
		
		try {
					
			MobilityModel model=getMobilityModel();
			List<NanoObj> nanoObjList=getAllDisposedObj();
					
			
			if(nanoObjList.size()>0){
				if(useOctree){	
					
					//long start0=System.nanoTime();
					
					try{	
						
						//long start=System.nanoTime();
						
						model.move(nanoObjList);
						
						/*
						long stop=System.nanoTime();						
						moveTime=moveTime+(stop-start);
						*/
						
					}catch (Exception e){
						e.printStackTrace();
						System.out.println("-3- Error on AbstractDomain.nextSimulationStep() - Move: "+e.toString());
					}
					try{
						
						//long start2=System.nanoTime();
						
						try {							
							
							getRootTree().cleanRootLeafs();							
							
						} catch (Exception e1) {
							e1.printStackTrace();
							System.out.println("-Oc- Error on AbstractDomain.cleanRootLeafs() - "+e1.toString());
						}
						try {	
							getRootTree().fillUp_Down_To_Leafs(nanoObjList);  // a little faster than "fillUp8Child_OK"							  
						
						} catch (Exception e1) {
							e1.printStackTrace();
							System.out.println("-Oc- Error on AbstractDomain.fillUp() - "+e1.toString());
						}
	
						ArrayList<OctreeNode> leafs=getRootTree().getLeafList();
						int leafSize=leafs.size();
						
						/*
						long stop2=System.nanoTime();						
						octreeTime=octreeTime+(stop2-start2);
						*/
						
						try {		
							
							CountDownLatch latch=new CountDownLatch(leafSize);								
							
							//long start1=System.nanoTime();
							
							HeapSorter_Domains h1=new HeapSorter_Domains();
							try {
								h1.sort(getAllChildDomains());
							} catch (Exception e) {
								e.printStackTrace();								
							}		
							/*
							long stop1=System.nanoTime();							
							sortTime=sortTime+(stop1-start1);
							*/							
							
							//long start=System.nanoTime();
																				
							for(int i=0;i<leafSize;i++){								
								
								if(leafs.get(i).getAllNanoObjs().size()>0) {
									
									Thread tt=new Thread_CheckCollision(this, model, leafs.get(i), getAllChildDomains(), ObjFor1Check, ObjFor2Check, latch);
								
									executorThreads.execute(tt);							
								}else{
									synchronized(latch){										
										latch.countDown();
									}
								}
							}	
							
							latch.await();	
							
							/*
							long stop=System.nanoTime();							
							//checkTime=checkTime+(stop-start);
							
							if(getManager().currentTime%300==0){		
								System.out.println("check: "+(stop-start)/1000000+" [ms]");
							}
							*/
							
						} catch (Exception e1) {
							e1.printStackTrace();
							System.out.println("-Oc- Error on AbstractDomain.ThreadCheckCollision() - "+e1.toString());
						}
						
						try {									
							if(getManager().currentTime%500000==0){								
								
								//long start=System.nanoTime();									
								
								getRootTree().prune(nanoObjList);
								
								/*
								long stop=System.nanoTime();								
								pruneTime=pruneTime+(stop-start);
								*/
							}
						} catch (Exception e) {
							System.out.println("-4.1- Error on AbstractDomain.nextSimulationStep() - PRUNING: "+e.toString());
							e.printStackTrace();
						}							
						
						
						//long start=System.nanoTime();
						
						joinAllCollisionsLists();
						
						/*
						long stop=System.nanoTime();						
						joinTime=joinTime+(stop-start);
						*/
						
						
						
					}catch (Exception e){
						System.out.println("-4- Error on AbstractDomain.nextSimulationStep() - Check Collision: "+e.toString());
						e.printStackTrace();
					}
					
					try{
						
						//long start=System.nanoTime();
						
						while(getCollisionsList().size()>0){ 
							model.avoidCollision(this);	
						}	
						
						/*
						long stop=System.nanoTime();						
						avoidTime=avoidTime+(stop-start);
						*/
						
						
					}catch (Exception e){
						System.out.println("-5- Error on AbstractDomain.nextSimulationStep() - Avoid Collision: "+e.toString());
					}	
					
					
					/*
					long stop0=System.nanoTime();					
					globalTime=globalTime+(stop0-start0);
					*/
					
					
					/*
					if(getManager().currentTime%100000==0){							
						
						double d1=Math.round((double)moveTime/(double)globalTime*100);
						double d2=Math.round((double)sortTime/(double)globalTime*100);
						double d3=Math.round((double)checkTime/(double)globalTime*100);
						double d4=Math.round((double)avoidTime/(double)globalTime*100);
						double d5=Math.round((double)pruneTime/(double)globalTime*100);
						double d6=Math.round((double)octreeTime/(double)globalTime*100);
						double d7=Math.round((double)joinTime/(double)globalTime*100);
						
						System.out.println("");
						System.out.println("============================");
						System.out.println("move: "+moveTime/1000+"   -   ["+d1+" %]");
						System.out.println("sort: "+sortTime/1000+"   -   ["+d2+" %]");
						System.out.println("check: "+checkTime/1000+"   -   ["+d3+" %]");
						System.out.println("avoid: "+avoidTime/1000+"   -   ["+d4+" %]");
						System.out.println("prune: "+pruneTime/1000+"   -   ["+d5+" %]");
						System.out.println("octree: "+octreeTime/1000+"   -   ["+d6+" %]");
						System.out.println("join: "+joinTime/1000+"   -   ["+d7+" %]");
						System.out.println("");
						System.out.println("Global: "+globalTime/1000);
						System.out.println("");
						System.out.println("============================");
						
						moveTime=0;
						sortTime=0;
						checkTime=0;
						avoidTime=0;
						pruneTime=0;
						globalTime=0;
						octreeTime=0;
						joinTime=0;					
						
					}
					*/
					
				} else{					
					// Without the Octree					
					getMobilityModel().algorithm(this);
				}
			}
			
		} catch (Exception e3) {
			System.out.println("-3- Error on AbstratcDomain.NextSimulationStep.MobilityModel.Algorithm: "+e3.toString());	
		}
	
		try{			
			getLivingObjObserver().killDeadObjs();				
			
		} catch(Exception e4){
			System.out.println("-4- Error on AbstratcDomain.NextSimulationStep.killDeadObjs: "+e4.toString());
			e4.printStackTrace();
		}
	}
	
	public void setCollisionStrategy(AbstractCollisionDomainStrategy strategy){
		this.collisionStrategy=strategy;
		strategy.setDomain(this);		
	}
		
	public AbstractCollisionDomainStrategy getCollisionStrategy(){
		return this.collisionStrategy;
	}
	
	public AbstractDomain getParentDomain(){
		return parentDomain;
	}
	
	public List<AbstractDomain> getAllChildDomains(){
		return childDomainList; 
	}
	
	public boolean contains(NanoObj n){
		boolean found=false;
		if (getAllDisposedObj().contains(n)) {
			found=true;
		}else if(getAllUndisposedObj().contains(n)){
			found=true;
		}
		return found;
	}	
	
	public void destroy(){		
			
		Iterator<AbstractDomain> itCD = childDomainList.iterator();
		while (itCD.hasNext()) {
			AbstractDomain d = itCD.next();
			   d.destroy();
			   itCD.remove();
		}
		if(getManager().is3DEnable==true){
			getManager().engine.removeWrapper3D(this);
		}		
		
		getLivingObjObserver().destroy();		
		parentDomain.childDomainList.remove(this);		
		
		try {
			super.finalize();
		} catch (Throwable e) {			
			e.printStackTrace();
		}
	}	
		
	public void relocateDomain(float x, float y, float z){
		float[] oldCenter=getRelativeCenter();
		float[] displacement=new float[3];
		displacement[0]=oldCenter[0]+x;
		displacement[1]=oldCenter[1]+y;
		displacement[2]=oldCenter[2]+z;		
		setCenter(x,y,z);
		
		// Relocate every subdomains and every attached-objs
		relocateSubDomain(displacement[0],displacement[1],displacement[2]);		
	}
	
	private void relocateSubDomain(float dx, float dy, float dz){
		// Relocate every subdomains and every attached-objs
		List<AbstractDomain> childDomainList=getAllChildDomains();
		for(int i=0;i<childDomainList.size();i++){
			childDomainList.get(i).relocateSubDomain(dx,dy,dz);
		}

		List<NanoObj> allDomainsObj=getAllDisposedObj();
		allDomainsObj.addAll(getAllUndisposedObj());

		for(int i=0;i<allDomainsObj.size();i++){
			float[] nCenter=allDomainsObj.get(i).getCenter();
			nCenter[0]=nCenter[0]+dx;
			nCenter[1]=nCenter[1]+dy;
			nCenter[2]=nCenter[2]+dz;
			allDomainsObj.get(i).setCenter(nCenter[0],nCenter[1],nCenter[2]);			
		}		
	}	
	
	public void setCenter(float x, float y, float z) {
		// It refeers to its owner!
		center[0]=x;
		center[1]=y;
		center[2]=z;		
	}
	
	public float[] getRelativeCenter(){
		return center;
	}	

	public float[] getAbsCenter(){
		float[] dCenter=new float[3];			
		
		float x=parentDomain.getAbsCenter()[0];
		float y=parentDomain.getAbsCenter()[1];
		float z=parentDomain.getAbsCenter()[2];		
	
		dCenter[0]=x+center[0];
		dCenter[1]=y+center[1];
		dCenter[2]=z+center[2];		
		
		// returns the absolute coords!
		return dCenter;
	}
	
	public void attachChildDomain(AbstractDomain d){
		childDomainList.add(d);
	}
	
	public void detachChildDomain(AbstractDomain d){
		childDomainList.remove(d);
	}
	
	public int getActiveNanoObjListSize(){		
		return genericObjList.size()+nodeList.size()+carrierList.size();
	}

	public void attachNanoObj(CarrierObj c){	
		if (!undisposedCarrierList.contains(c)) {
			undisposedCarrierList.add(c);
			c.setDomain(this);			
			c.setLifeManager(getLivingObjObserver());
			c.notifyToLifeManager();
		}
	}

	public void attachNanoObj(NanoObj n){
		if (!undisposedGenericObjList.contains(n)) {
			undisposedGenericObjList.add(n);
			n.setDomain(this);		
			n.setLifeManager(getLivingObjObserver());
			n.notifyToLifeManager();			
		}
	}
	
	public void attachNanoObj(NodeObj n){	
		if (!undisposedNodeList.contains(n)) {
			undisposedNodeList.add(n);
			n.setDomain(this);			
			n.setLifeManager(getLivingObjObserver());
			n.notifyToLifeManager();
			
			if(n.receptorList!=null){
				List<Receptor> receptorList=n.receptorList;

				for(UniversalReceptor rr:receptorList){
					rr.setOuterDomain(n.getDomain());
				}
			}
		}
	}	
	
	public void activatePropagationObj(NanoObj n){
		if(undisposedGenericObjList.contains(n)) undisposedGenericObjList.remove(n);
		if (!genericObjList.contains(n)) {
			genericObjList.add(n);				
		}
		getMobilityModel().getRootDomain().attachOnGrid(n);
	}
	
	public void activatePropagationObj(NodeObj n){
		if(undisposedNodeList.contains(n)) undisposedNodeList.remove(n);
		if (!nodeList.contains(n)) {
			nodeList.add(n);				
		}
		getMobilityModel().getRootDomain().attachOnGrid(n);
	}
	
	public synchronized void activatePropagationObj(CarrierObj c){
		if(undisposedCarrierList.contains(c)) undisposedCarrierList.remove(c);
		if (!carrierList.contains(c)) {
			carrierList.add(c);			
		}
		getMobilityModel().getRootDomain().attachOnGrid(c);		
	}
	
	public void detachNanoObj(NanoObj n){
		undisposedGenericObjList.remove(n);
		genericObjList.remove(n);
		getLivingObjObserver().removeGenericObj(n);
		n.setDomain(null);  //FIXME Under test. It could be necessary to comment it!
		
		// Octree
		//getRootTree().remove(n);
		removeFromOctree(n);
	}
	
	public void detachNanoObj(NodeObj n){
		undisposedNodeList.remove(n);
		nodeList.remove(n);
		getLivingObjObserver().removeNode(n);
		n.setDomain(null);
		
		// Octree
		//getRootTree().remove(n);
		removeFromOctree(n);
	}
	
	public void detachNanoObj(CarrierObj c){
		undisposedCarrierList.remove(c);
		boolean removed=carrierList.remove(c);
		getLivingObjObserver().removeCarrier(c);		
		//c.setDomain(null);	//FIXME Under test. It could be necessary to comment it!
		
		try {
			// Octree
			//getRootTree().remove(c);
			removeFromOctree(c);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println("Eccezione AbstractDomain.detachCarrier -> OCTREE - "+ID);
		}
	}	
	
	public void removeFromOctree(NanoObj n){
		if(useOctree) getRootTree().remove(n);
	}
	
	public void removeFromOctree(NodeObj n){
		if(useOctree) getRootTree().remove(n);
	}
	
	public void removeFromOctree(CarrierObj c){
		if(useOctree) getRootTree().remove(c);
	}
	
	public Manager getManager(){
		return mobilityModel.getManager();
	}
	
	public void setMobilityModel(MobilityModel model){
		mobilityModel=model;
	}	
	
	public MobilityModel getMobilityModel(){
		return mobilityModel;
	}
	
	public static float getDistance(float[] firstObjCoords, float[] secondObjCoords){
		float dx=secondObjCoords[0]-firstObjCoords[0];
		float dy=secondObjCoords[1]-firstObjCoords[1];
		float dz=secondObjCoords[2]-firstObjCoords[2];
		float distance=(float) Math.sqrt(dx*dx+dy*dy+dz*dz);
		return distance;
	}
	
	public List<NanoObj> getAllDisposedObj(){
		List<NanoObj> allNanoObjList=new ArrayList<NanoObj>();
		allNanoObjList.addAll(nodeList);
		allNanoObjList.addAll(carrierList);
		allNanoObjList.addAll(genericObjList);
		return allNanoObjList;
	}
	
	public List<NanoObj> getAllUndisposedObj(){
		List<NanoObj> allNanoObjList=new ArrayList<NanoObj>();
		allNanoObjList.addAll(undisposedNodeList);
		allNanoObjList.addAll(undisposedCarrierList);
		allNanoObjList.addAll(undisposedGenericObjList);
		return allNanoObjList;
	}
	
	public List<NodeObj> getNodeList(){
		return nodeList;
	}
	
	public List<NanoObj> getGenericObjList(){
		return genericObjList;
	}
	
	public List<CarrierObj> getCarrierList(){
		return carrierList;
	}
	
	public boolean isFreeSpace(NanoObj obj){
		float[] coords=obj.getCenter();
		float radius=obj.getRadius();
		boolean isFree=true;
		float[] tempCoords=new float[3];
		double tempRadius=0;
		boolean endSearch=false;
		
		List<AbstractDomain> childDomainList=getAllChildDomains();		
		for(int i=0;i<childDomainList.size() && isFree;i++){
			if(childDomainList.get(i).isInside(obj)) isFree=false;
		}			

		if(isFree){
			List<NanoObj> allNanoObjList=getAllDisposedObj();			
			
			for (int i=0;i<allNanoObjList.size()& (!endSearch);i++){
				tempCoords=allNanoObjList.get(i).getCenter();
				tempRadius=allNanoObjList.get(i).getRadius();
				//check=i;
				float distance=getDistance(coords,tempCoords);

				if (distance<(radius+tempRadius)){
					isFree=false;
					endSearch=true;
				}
			}	
		}	
		return isFree;
	}	
	
	
	// FIXME Uses OCtree to optimize the checking...
	public boolean isFreeSpace(ArrayList<NanoObj> objList, NanoObj obj){
		float[] coords=obj.getCenter();
		float radius=obj.getRadius();
		boolean isFree=true;
		float[] tempCoords=new float[3];
		double tempRadius=0;
		boolean endSearch=false;
		
		List<AbstractDomain> childDomainList=getAllChildDomains();		
		for(int i=0;i<childDomainList.size() && isFree;i++){
			if(childDomainList.get(i).isInside(obj)) isFree=false;
		}			

		if(isFree){
			List<NanoObj> allNanoObjList=objList;			
			
			for (int i=0;i<allNanoObjList.size()& (!endSearch);i++){
				tempCoords=allNanoObjList.get(i).getCenter();
				tempRadius=allNanoObjList.get(i).getRadius();
				//check=i;
				float distance=getDistance(coords,tempCoords);

				if (distance<(radius+tempRadius)){					
					isFree=false;
					endSearch=true;
				}
			}	
		}	
		return isFree;
	}	
	
	// FIXME It is a different version of the previous isFreeSpace(..). I want to reduce the time for checking!
	public boolean isFreeSpace(NanoObj obj, ArrayList<NanoObj> allNanoObjList){
		float[] coords=obj.getCenter();
		float radius=obj.getRadius();
		boolean isFree=true;
		float[] tempCoords=new float[3];
		double tempRadius=0;
		boolean endSearch=false;
		
		List<AbstractDomain> childDomainList=getAllChildDomains();		
		for(int i=0;i<childDomainList.size() && isFree;i++){
			if(childDomainList.get(i).isInside(obj)) isFree=false;
		}			

		if(isFree){
			//List<NanoObj> allNanoObjList=getAllDisposedObj();			
			
			for (int i=0;i<allNanoObjList.size()& (!endSearch);i++){
				tempCoords=allNanoObjList.get(i).getCenter();
				tempRadius=allNanoObjList.get(i).getRadius();
				//check=i;
				float distance=getDistance(coords,tempCoords);

				if (distance<(radius+tempRadius)){
					isFree=false;
					endSearch=true;
				}
			}	
		}	
		return isFree;
	}	
	
	
	public float getBoundingRadius(){
		return boundingRadius;
	}
	
	public boolean isVisible(){	
		return (visibleOn3D && getManager().is3DEnable);
	}	
	
	public SimpleVector getDirectionP(){					
		return directionP;
	}
	
	public SimpleVector getDirectionN(){					
		return directionN;
	}
	
	public SimpleVector getDirectionO(){					
		return directionO;
	}	

	/** directionO is always orthogonal to the other axes! */
	public void setDirectionP(SimpleVector direction) {		
			this.directionP = (new SimpleVector(direction)).normalize();
			this.directionO = (new SimpleVector(directionN.calcCross(directionP))).normalize();
			if (getManager().is3DEnable) getManager().engine.changeWrapper3DDomain(this);
	}
	
	public void setDirectionN(SimpleVector direction){
		this.directionN = (new SimpleVector(direction)).normalize();
		this.directionO = (new SimpleVector(directionN.calcCross(directionP))).normalize();
	}		
	
	public void addToCollisionsList(NanoObj p1,NanoObj p2,float dt){		
			AbstractCollision c=new NanoCollision(p1,p2,dt);
			
			//setCollisionsList(c);
			setToFreeCollisionsList3(c);							
			
			p1.increaseCollisionCount();
			p2.increaseCollisionCount();
		}
	
	public  void addToCollisionsListInternal(AbstractDomain sDomain, NanoObj p1, float dt){		
		AbstractCollision c=new DomainCollisionInternal(p1,sDomain,dt);		
		
		//FIXME Original!
		//setCollisionsList(c); 		
		setToFreeCollisionsList3(c);			
		
		if (getManager().is3DEnable) {
			p1.setColor(Color.orange);			
		
			if(getManager().is3DEnable)
				sDomain.getManager().engine.changeDomainColor(sDomain, Color.red);				
		}
		p1.increaseCollisionCount();		
	}

	public void addToCollisionsListExternal(AbstractDomain sDomain, NanoObj p1, float dt){
		AbstractCollision c=new DomainCollisionExternal(p1,sDomain,dt);
		
		//FIXME Original!
		setCollisionsList(c); 		
		//setToFreeCollisionsList3(c);  // FIXME Under test. The performance will decrease in this case. To test more deeply!!

		if(getManager().is3DEnable){
			p1.setColor(Color.red);	
			sDomain.getManager().engine.changeDomainColor(sDomain, Color.red);
		}
		p1.increaseCollisionCount();				
	}

	public float getDistance(){
			float[] domainCenter=getRelativeCenter();
			float dx,dy,dz;
			dx=domainCenter[0];
			dy=domainCenter[1];
			dz=domainCenter[2];			
			return (float) Math.sqrt(dx*dx+dy*dy+dz*dz);		
	}
	
	public ArrayList<NanoObj> getExceptionList(){
		return exceptionList;
	}
	
	public void addToExceptionList(NanoObj n){
		if (!exceptionList.contains(n)) exceptionList.add(n);
	}
	
	public boolean isToBeExcepted(NanoObj n){
		boolean isContained=false;
		if (exceptionList.contains(n)) isContained=true;
		return isContained;
	}
	
	public boolean removeFromExceptionList(NanoObj n){
		boolean isContained=false;
		if (exceptionList.contains(n)) {
			exceptionList.remove(n);
			isContained=true;
		}
		return isContained;		
	}
	
	public LivingObjObserver getLivingObjObserver() {
		return livingObjObserver;
	}
	
	public void setLivingObjObserver(LivingObjObserver livingObjObserver) {
		this.livingObjObserver = livingObjObserver;
	}		
	
	public synchronized ArrayList<AbstractCollision> getCollisionsList(){
		return collisionsList;
	}	
	
	public synchronized void setCollisionsList(AbstractCollision c){
		collisionsList.add(c);
	}

	public synchronized void setCollisionsList(ArrayList<AbstractCollision> c){
		collisionsList=c;
	}	

	public void setToFreeCollisionsList3(AbstractCollision c){
		//Double checked locking pattern
		boolean done=false;
		while (!done){

			if(!done && cl1){
				synchronized(collisionsList1){
					if(cl1){
						cl1=false;					
						collisionsList1.add(c);
						done=true;						
						cl1=true;				
					}
				}
			}
			
			if(!done && cl2){				
				synchronized(collisionsList2){
					if(cl2){
						cl2=false;			
						collisionsList2.add(c);
						done=true;
						cl2=true;				
					}
				}
			}

			if(!done && cl3){				
				synchronized(collisionsList3){
					if(cl3){
						cl3=false;	
						collisionsList3.add(c);
						done=true;
						cl3=true;				
					}
				}
			}

			if(!done && cl4){				
				synchronized(collisionsList4){
					if(cl4){
						cl4=false;			
						collisionsList4.add(c);
						done=true;
						cl4=true;				
					}
				}
			}

			if(!done && cl5){				
				synchronized(collisionsList5){
					if(cl5){
						cl5=false;					
						collisionsList5.add(c);
						done=true;
						cl5=true;				
					}
				}
			}

			if(!done && cl6){				
				synchronized(collisionsList6){
					if(cl6){
						cl6=false;												
						collisionsList6.add(c);
						done=true;
						cl6=true;				
					}
				}
			}

			if(!done && cl7){				
				synchronized(collisionsList7){
					if(cl7){
						cl7=false;										
						collisionsList7.add(c);
						done=true;
						cl7=true;				
					}
				}
			}

			if(!done && cl8){				
				synchronized(collisionsList8){
					if(cl8){
						cl8=false;			
						collisionsList8.add(c);
						done=true;
						cl8=true;				
					}
				}		
			}

			if(!done  && cl9){
				synchronized(collisionsList9){
					if(cl9){
						cl9=false;					
						collisionsList9.add(c);
						done=true;
						cl9=true;				
					}
				}
			}
			
			if(!done  && cl10){
				synchronized(collisionsList10){
					if(cl10){
						cl10=false;								
						collisionsList10.add(c);
						done=true;
						cl10=true;				
					}
				}
			}

			if(!done  && cl11){
				synchronized(collisionsList11){
					if(cl11){
						cl11=false;									
						collisionsList11.add(c);
						done=true;
						cl11=true;				
					}
				}
			}
			
			if(!done  && cl12){
				synchronized(collisionsList12){
					if(cl12){
						cl12=false;		
						collisionsList12.add(c);
						done=true;
						cl12=true;				
					}
				}
			}
			
			if(!done  && cl13){
				synchronized(collisionsList13){
					if(cl13){
						cl13=false;		
						collisionsList13.add(c);
						done=true;
						cl13=true;				
					}
				}
			}
			
			if(!done  && cl14){
				synchronized(collisionsList14){
					if(cl14){
						cl14=false;								
						collisionsList14.add(c);
						done=true;
						cl14=true;				
					}
				}
			}
			
			if(!done  && cl15){
				synchronized(collisionsList15){
					if(cl15){
						cl15=false;	
						collisionsList15.add(c);
						done=true;
						cl15=true;				
					}
				}
			}
			
			if(!done  && cl16){
				synchronized(collisionsList16){
					if(cl16){
						cl16=false;		
						collisionsList16.add(c);
						done=true;
						cl16=true;				
					}
				}		
			}	
			/*
			if(!done  && cl17){
				synchronized(collisionsList17){
					if(cl17){
						cl17=false;		
						collisionsList17.add(c);
						done=true;
						cl17=true;				
					}
				}		
			}
			
			if(!done  && cl18){
				synchronized(collisionsList18){
					if(cl18){
						cl18=false;		
						collisionsList18.add(c);
						done=true;
						cl18=true;				
					}
				}		
			}
			
			if(!done  && cl19){
				synchronized(collisionsList19){
					if(cl19){
						cl19=false;		
						collisionsList19.add(c);
						done=true;
						cl19=true;				
					}
				}		
			}
			
			if(!done  && cl20){
				synchronized(collisionsList20){
					if(cl20){
						cl20=false;		
						collisionsList20.add(c);
						done=true;
						cl20=true;				
					}
				}		
			}
			
			if(!done  && cl21){
				synchronized(collisionsList21){
					if(cl21){
						cl21=false;		
						collisionsList21.add(c);
						done=true;
						cl21=true;				
					}
				}		
			}
			
			if(!done  && cl22){
				synchronized(collisionsList22){
					if(cl22){
						cl22=false;		
						collisionsList22.add(c);
						done=true;
						cl22=true;				
					}
				}		
			}
			
			if(!done  && cl23){
				synchronized(collisionsList23){
					if(cl23){
						cl23=false;		
						collisionsList23.add(c);
						done=true;
						cl23=true;				
					}
				}		
			}
			
			if(!done  && cl24){
				synchronized(collisionsList24){
					if(cl24){
						cl24=false;		
						collisionsList24.add(c);
						done=true;
						cl24=true;				
					}
				}		
			}
			
			if(!done  && cl25){
				synchronized(collisionsList25){
					if(cl25){
						cl25=false;		
						collisionsList25.add(c);
						done=true;
						cl25=true;				
					}
				}		
			}
			
			if(!done  && cl26){
				synchronized(collisionsList26){
					if(cl26){
						cl26=false;		
						collisionsList26.add(c);
						done=true;
						cl26=true;				
					}
				}		
			}
			
			if(!done  && cl27){
				synchronized(collisionsList27){
					if(cl27){
						cl27=false;		
						collisionsList27.add(c);
						done=true;
						cl27=true;				
					}
				}		
			}
			
			if(!done  && cl28){
				synchronized(collisionsList28){
					if(cl28){
						cl28=false;		
						collisionsList28.add(c);
						done=true;
						cl28=true;				
					}
				}		
			}
			
			if(!done  && cl29){
				synchronized(collisionsList29){
					if(cl29){
						cl29=false;		
						collisionsList29.add(c);
						done=true;
						cl29=true;				
					}
				}		
			}
			
			if(!done  && cl30){
				synchronized(collisionsList30){
					if(cl30){
						cl30=false;		
						collisionsList30.add(c);
						done=true;
						cl30=true;				
					}
				}		
			}
			
			if(!done  && cl31){
				synchronized(collisionsList31){
					if(cl31){
						cl31=false;		
						collisionsList31.add(c);
						done=true;
						cl31=true;				
					}
				}		
			}
			
			if(!done  && cl32){
				synchronized(collisionsList32){
					if(cl32){
						cl32=false;		
						collisionsList32.add(c);
						done=true;
						cl32=true;				
					}
				}		
			}
			*/			
		}
	}

	public void joinAllCollisionsLists(){

		collisionsList.addAll(collisionsList1);
		collisionsList.addAll(collisionsList2);
		collisionsList.addAll(collisionsList3);
		collisionsList.addAll(collisionsList4);
		collisionsList.addAll(collisionsList5);
		collisionsList.addAll(collisionsList6);
		collisionsList.addAll(collisionsList7);
		collisionsList.addAll(collisionsList8);
		collisionsList.addAll(collisionsList9);
		collisionsList.addAll(collisionsList10);
		collisionsList.addAll(collisionsList11);
		collisionsList.addAll(collisionsList12);
		collisionsList.addAll(collisionsList13);
		collisionsList.addAll(collisionsList14);
		collisionsList.addAll(collisionsList15);
		collisionsList.addAll(collisionsList16);
		/*
		collisionsList.addAll(collisionsList17);
		collisionsList.addAll(collisionsList18);
		collisionsList.addAll(collisionsList19);
		collisionsList.addAll(collisionsList20);
		collisionsList.addAll(collisionsList21);
		collisionsList.addAll(collisionsList22);
		collisionsList.addAll(collisionsList23);
		collisionsList.addAll(collisionsList24);
		collisionsList.addAll(collisionsList25);
		collisionsList.addAll(collisionsList26);		
		collisionsList.addAll(collisionsList27);
		collisionsList.addAll(collisionsList28);
		collisionsList.addAll(collisionsList29);
		collisionsList.addAll(collisionsList30);
		collisionsList.addAll(collisionsList31);
		collisionsList.addAll(collisionsList32);
		*/
		
	
		collisionsList1=new ArrayList<AbstractCollision>();
		collisionsList2=new ArrayList<AbstractCollision>();
		collisionsList3=new ArrayList<AbstractCollision>();
		collisionsList4=new ArrayList<AbstractCollision>();
		collisionsList5=new ArrayList<AbstractCollision>();
		collisionsList6=new ArrayList<AbstractCollision>();
		collisionsList7=new ArrayList<AbstractCollision>();
		collisionsList8=new ArrayList<AbstractCollision>();
		collisionsList9=new ArrayList<AbstractCollision>();
		collisionsList10=new ArrayList<AbstractCollision>();
		collisionsList11=new ArrayList<AbstractCollision>();
		collisionsList12=new ArrayList<AbstractCollision>();
		collisionsList13=new ArrayList<AbstractCollision>();
		collisionsList14=new ArrayList<AbstractCollision>();
		collisionsList15=new ArrayList<AbstractCollision>();
		collisionsList16=new ArrayList<AbstractCollision>();
		/*
		collisionsList17=new ArrayList<AbstractCollision>();
		collisionsList18=new ArrayList<AbstractCollision>();
		collisionsList19=new ArrayList<AbstractCollision>();
		collisionsList20=new ArrayList<AbstractCollision>();
		collisionsList21=new ArrayList<AbstractCollision>();
		collisionsList22=new ArrayList<AbstractCollision>();
		collisionsList23=new ArrayList<AbstractCollision>();
		collisionsList24=new ArrayList<AbstractCollision>();
		collisionsList25=new ArrayList<AbstractCollision>();
		collisionsList26=new ArrayList<AbstractCollision>();		
		collisionsList27=new ArrayList<AbstractCollision>();
		collisionsList28=new ArrayList<AbstractCollision>();
		collisionsList29=new ArrayList<AbstractCollision>();
		collisionsList30=new ArrayList<AbstractCollision>();
		collisionsList31=new ArrayList<AbstractCollision>();
		collisionsList32=new ArrayList<AbstractCollision>();	
		*/
	}

	public float getAngle(SimpleVector v1, SimpleVector v2){
		return v1.calcAngle(v2);
	}

	public void changeParentDomain(AbstractDomain newParent){
		//FIXME To be TESTED!!!
		this.parentDomain.detachChildDomain(this);
		float[] oldParentCenter=parentDomain.getAbsCenter();
		float[] newParentCenter=newParent.getAbsCenter();
		float[] newDomainCenter=getRelativeCenter();

		newDomainCenter[0]=newDomainCenter[0]+(oldParentCenter[0]-newParentCenter[0]);
		newDomainCenter[1]=newDomainCenter[1]+(oldParentCenter[1]-newParentCenter[1]);
		newDomainCenter[2]=newDomainCenter[2]+(oldParentCenter[2]-newParentCenter[2]);		

		this.parentDomain=newParent;		
		this.parentDomain.attachChildDomain(this);
		this.setCenter(newDomainCenter[0], newDomainCenter[1], newDomainCenter[2]);
	}

	public synchronized static void upCountThread(){
		countThread++;
	}

	public synchronized static void downCountThread(){
		countThread--;
	}

	public synchronized static long getCountThread(){
		return countThread;
	}
}
