/** This class implements the different Threading Strategies for the Move and CheckCollision phases.
 *  In this way we can remove the ExecutorService from the DiffusionModel Class and we can perform
 *  the BACKUP of the Simulation Objects  */

package MainLibrary;

import java.util.List;
//import com.db4o.types.TransientClass;

//public abstract class AbstractThreadingStrategy implements TransientClass{
public abstract class AbstractThreadingStrategy {
	
	protected MobilityModel m;
	
	public abstract void move(List<NanoObj> nanoList); 
	public abstract void checkCollision(List<NanoObj> objsToCheck);
	
	public AbstractThreadingStrategy(MobilityModel m){
		this.m = m;
	}
	
	public MobilityModel getModel(){
		return m;
	}
	
	public void setModel(MobilityModel m){
		this.m=m;
	}
}
