package MainLibrary;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;

public class CheckNanoObjCollisionThreadLatch implements Runnable{	
	
	private List<NanoObj> objsToCheck=new ArrayList<NanoObj>();
	private MobilityModel model;
	private int start,stop;
	public CountDownLatch latch;
	public AbstractDomain activeDomain=null;
	
	public CheckNanoObjCollisionThreadLatch(int start,int stop,List<NanoObj> objsToCheck,MobilityModel d,AbstractDomain activeDomain,CountDownLatch latch){
		this.objsToCheck=objsToCheck;
		this.model=d;
		this.start=start;
		this.stop=stop;
		this.latch=latch;
		this.activeDomain=activeDomain;			
	}

	public void run(){		
		AbstractCollisionDomainStrategy strategy=activeDomain.getCollisionStrategy();			
		
		//Check Collision!!
		boolean isFinish=false;
		NanoObj n=null;			
				
		for (int i=start;i<stop;i++){
			n=objsToCheck.get(i);				
			
			// FIXME BUGFIX for timeToLive=-1. No checks needed for killed objs!
			if(n.getTimeToLive()<0){
				isFinish=true;
			}else{
				isFinish=false;
			}
			//isFinish=false;		
			
			for (int j=i+1;j<objsToCheck.size() && !isFinish;j++){					
				
				// FIXME BUGFIX for timeToLive=-1. No checks needed for killed objs!
				if(objsToCheck.get(j).getTimeToLive()<0){
					
				}else if(objsToCheck.get(j).getAbsDistancePlusRadius()>=n.getAbsDistanceMinusRadius()){					
					model.detectCollision(objsToCheck.get(j),n);						
				} else{
					isFinish=true;					
				}
			}	
			strategy.checkInternalCollisionBound(n);
		}

		latch.countDown();	
		
	}	
}
