package MainLibrary;

import javax.xml.parsers.DocumentBuilderFactory ;
import javax.xml.parsers.DocumentBuilder ;
import org.w3c.dom.Document ;
import org.w3c.dom.NodeList ;
import org.w3c.dom.Node ;
import org.w3c.dom.Element ;
import com.threed.jpct.SimpleVector;
import java.io.File ;

public class Configurator2 {
	
	public static ConfigWrapper m;  
	private static Configurator2 instance=null;
	public static String additionalInfo="";

	private Configurator2(){
		m=new ConfigWrapper();
	}

	public static Configurator2 getConfigurator(){
		if(instance==null) instance=new Configurator2();
		return instance;
	}

	public static Configurator2 getConfigurator(Manager cc){
		if(instance==null) instance=new Configurator2();
		cc.configWrapper=m;
		return instance;
	}	

	public void readConfigurations(String filename){

		try {
			File fXmlFile = new File ( filename ) ;
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory. newInstance ( ) ;
			DocumentBuilder dBuilder = dbFactory. newDocumentBuilder ( ) ;
			Document doc = dBuilder. parse ( fXmlFile ) ;
			doc. getDocumentElement ( ) . normalize ( ) ;

			NodeList nList = doc. getElementsByTagName ("Node" );
			for ( int temp = 0; temp < nList. getLength ( ); temp ++ ) {
				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {		
					Element eElement = ( Element ) nNode ;
					int type=getTagValue ( "type" ,eElement ).intValue();		         
					m.nodeConfig.put(type+"-mass", getTagValue ( "mass" ,eElement ));
					m.nodeConfig.put(type+"-radius", getTagValue ( "radius" ,eElement ));
					m.nodeConfig.put(type+"-ttl", getTagValue ( "ttl" ,eElement ));
					m.nodeConfig.put(type+"-receptor", getTagValue ( "receptor" ,eElement ));
					m.nodeConfig.put(type+"-zoom3D", getTagValue ( "zoom3D" ,eElement )); 
					m.nodeConfig.put(type+"-burstEmission", getTagValue ( "burstEmission" ,eElement ));
					m.nodeConfig.put(type+"-receptorType", getTagValue ( "receptorType" ,eElement ));
					m.nodeConfig.put(type+"-stateType", getTagValue ( "stateType" ,eElement ));					
					
					//String nValue111  = eElement. getElementsByTagName ( "statesType" ).item(0). getChildNodes ( ) .item(0).getNodeValue();
					
					if( eElement. getElementsByTagName ( "timeForEmission" ).item(0)!=null){
						m.nodeConfig.put(type+"-timeForEmission", getTagValue ( "timeForEmission" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "emissionPattern" ).item(0)!=null){
						m.nodeConfig.put(type+"-emissionPattern", getTagValue ( "emissionPattern" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "patternSTART" ).item(0)!=null){
						m.nodeConfig.put(type+"-patternSTART", getTagValue ( "patternSTART" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "patternSTOP" ).item(0)!=null){
						m.nodeConfig.put(type+"-patternSTOP", getTagValue ( "patternSTOP" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "patternCUT" ).item(0)!=null){
						m.nodeConfig.put(type+"-patternCUT", getTagValue ( "patternCUT" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "patternBER" ).item(0)!=null){
						m.nodeConfig.put(type+"-patternBER", getTagValue ( "patternBER" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "assimilationThreshold" ).item(0)!=null){
						m.nodeConfig.put(type+"-assimilationThreshold", getTagValue ( "assimilationThreshold" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "timeForAssimilation" ).item(0)!=null){
						m.nodeConfig.put(type+"-timeForAssimilation", getTagValue ( "timeForAssimilation" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "globalAssimilationThreshold" ).item(0)!=null){
						m.nodeConfig.put(type+"-globalAssimilationThreshold", getTagValue ( "globalAssimilationThreshold" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "timeout" ).item(0)!=null){
						m.nodeConfig.put(type+"-timeout", getTagValue ( "timeout" ,eElement ));
					}
					if( eElement. getElementsByTagName ( "firstEmission" ).item(0)!=null){
						m.nodeConfig.put(type+"-firstEmission", getTagValue ( "firstEmission" ,eElement ));
					}
								
				}
			}

			nList = doc. getElementsByTagName ("Carrier" );
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {	
				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {	
					Element eElement = ( Element ) nNode ;
					int type=getTagValue ( "type" ,eElement ).intValue();
					m.carrierConfig.put(type+"-mass", getTagValue ( "mass" ,eElement ));
					m.carrierConfig.put(type+"-radius", getTagValue ( "radius" ,eElement ));
					m.carrierConfig.put(type+"-ttl", getTagValue ( "ttl" ,eElement ));
					m.carrierConfig.put(type+"-zoom3D", getTagValue ( "zoom3D" ,eElement ));	    	   		
				}
			}

			nList = doc. getElementsByTagName ("Noise" );		    
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {	
				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {	
					Element eElement = ( Element ) nNode ;
					int type=getTagValue ( "type" ,eElement ).intValue();
					m.genericObjConfig.put(type+"-mass", getTagValue ( "mass" ,eElement ));
					m.genericObjConfig.put(type+"-radius", getTagValue ( "radius" ,eElement ));
					m.genericObjConfig.put(type+"-ttl", getTagValue ( "ttl" ,eElement ));
					m.genericObjConfig.put(type+"-zoom3D", getTagValue ( "zoom3D" ,eElement ));	    	        
				}
			} 

			nList = doc. getElementsByTagName ("Receptor" ) ;
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {	
				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {	
					Element eElement = ( Element ) nNode ;
					int type=getTagValue ( "type" ,eElement ).intValue();
					m.receptorStateConfig.put(type+"-inactiveTime", getTagValue ( "inactiveTime" ,eElement ));
					m.receptorStateConfig.put(type+"-activeTime", getTagValue ( "activeTime" ,eElement ));
					m.receptorStateConfig.put(type+"-downloadTime", getTagValue ( "downloadTime" ,eElement ));
					m.receptorStateConfig.put(type+"-uploadTime", getTagValue ( "uploadTime" ,eElement ));
					m.receptorStateConfig.put(type+"-radius", getTagValue ( "radius" ,eElement ));
				}
			}

			nList = doc. getElementsByTagName ("DomainStrategy" );
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {	
				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {	
					Element eElement = ( Element ) nNode ;
					int type=getTagValue ( "type" ,eElement ).intValue();
					m.domainStrategyConfig.put(type+"-e", getTagValue ( "e" ,eElement ));  
					m.domainStrategyConfig.put(type+"-elongit", getTagValue ( "elongit" ,eElement ));
				}
			}

			nList = doc. getElementsByTagName ("System" ) ;
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {	
				Node nNode = nList. item ( temp ) ;	   	    	       
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {	
					Element eElement = ( Element ) nNode ;	    	          
					m.timeUnit=(long)(getTagValue ( "timeUnit" ,eElement )+0);
					m.ddt=m.timeUnit;      
					m._dt=getTagValue ( "_dt" ,eElement )+0;
					m.exportTimeLength=(long) (getTagValue ( "exportTime" ,eElement )+0);
					m.simulationTimeLength=(long) (getTagValue ( "simulationTime" ,eElement )+0);
					//m.getMobilityModel().setMobilityThreads((int) (getTagValue ( "mobilityThreads" ,eElement )+0));
					m.threads=(int) (getTagValue ( "mobilityThreads" ,eElement )+0);
					m.T=(getTagValue ( "temperature" ,eElement )+0);
					m.viscosity=(getTagValue ( "viscosity" ,eElement )+0);
					m.u=(int)(getTagValue ( "u" ,eElement )+0);
					m.nodeTreeLimit=(int)(getTagValue ( "nodeTreeLimit" ,eElement )+0);
					m.nodeSideLimit=(int)(getTagValue ( "nodeSideLimit" ,eElement )+0);
					m.printTimeOnScreen=(int)(getTagValue ( "printTimeOnScreen" ,eElement )+0);	
					m.ed=Double.parseDouble((getTagValue ( "ed" ,eElement ).toString()));	
					
				}
			}

			nList = doc. getElementsByTagName ("NodeState" );
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {	
				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {
					Element eElement = ( Element ) nNode ;
					int type=getTagValue ( "type" ,eElement ).intValue();    	          
					m.nodeStateConfig.put(type+"-idleTime",getTagValue ( "idleTime" ,eElement )+0);
					m.nodeStateConfig.put(type+"-encodeTime",getTagValue ( "encodeTime" ,eElement )+0);
					m.nodeStateConfig.put(type+"-transmitTime",getTagValue ( "transmitTime" ,eElement )+0);
					m.nodeStateConfig.put(type+"-decodeTime",getTagValue ( "decodeTime" ,eElement )+0); 	             	               
				}
			}

			nList = doc. getElementsByTagName ("window" ) ;
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {		
				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {		
					Element eElement = ( Element ) nNode ;	
					m.window=new int[]{(int) (getTagValue ( "w" ,eElement )+0),(int) (getTagValue ( "h" ,eElement )+0)};
				}
			}

			nList = doc. getElementsByTagName ("camera" );
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {	
				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {	
					Element eElement = ( Element ) nNode ;	    	          

					m.camera=new float[]{getTagValue ( "x" ,eElement ),
							getTagValue ( "y" ,eElement ),
							getTagValue ( "z" ,eElement )};

					SimpleVector v=new SimpleVector(	    	          
							getTagValue ( "lookX" ,eElement ),
							getTagValue ( "lookY" ,eElement ),
							getTagValue ( "lookZ" ,eElement )); 
					m.lookAt=v;
				}
			}

			nList = doc. getElementsByTagName ("light" );
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {	
				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {	
					Element eElement = ( Element ) nNode ;	    	          

					m.lights=new int[]{ (int) (getTagValue ( "r" ,eElement )+0),
							(int) (getTagValue ( "g" ,eElement )+0),
							(int) (getTagValue ( "b" ,eElement )+0)};
				}	    	         
			}
		} catch ( Exception e ) {
			e. printStackTrace ( ) ;
		}
	}

	public float[][] disposeNodeObj(String filename){
		float[][] coords=null;

		try {
			File fXmlFile = new File ( filename ) ;
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory. newInstance ( ) ;
			DocumentBuilder dBuilder = dbFactory. newDocumentBuilder ( ) ;
			Document doc = dBuilder. parse ( fXmlFile ) ;
			doc. getDocumentElement ( ) . normalize ( ) ;

			NodeList nList = doc. getElementsByTagName ("Node" ) ;
			int length=nList.getLength();
			coords=new float[length][4];

			for ( int temp = 0 ; temp < length ; temp ++ ) {

				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {

					Element eElement = ( Element ) nNode ;

					coords[temp][0]=getTagValue ( "x" ,eElement );
					coords[temp][1]=getTagValue ( "y" ,eElement );
					coords[temp][2]=getTagValue ( "z" ,eElement );
					coords[temp][3]=getTagValue ( "type" ,eElement );		          
				}
			}
		} catch ( Exception e ) {
			e. printStackTrace ( ) ;
		}
		return coords;
	}

	public float readCustomConfigurations(String filename, String tag, String element){
		float value=Float.NaN;
		try {
			File fXmlFile = new File ( filename ) ;
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory. newInstance ( ) ;
			DocumentBuilder dBuilder = dbFactory. newDocumentBuilder ( ) ;
			Document doc = dBuilder. parse ( fXmlFile ) ;
			doc. getDocumentElement ( ) . normalize ( ) ;

			NodeList nList = doc. getElementsByTagName (tag ) ;
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {

				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {		
					Element eElement = ( Element ) nNode ;		          
					value=getTagValue ( element ,eElement );
				}
			}
		} catch ( Exception e ) {
			e. printStackTrace ( ) ;		     
		}
		return value;
	}  	 
	
	public static String readCustomStringConfigurations(String filename, String tag, String element){
		String value=null;
		try {
			File fXmlFile = new File ( filename ) ;
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory. newInstance ( ) ;
			DocumentBuilder dBuilder = dbFactory. newDocumentBuilder ( ) ;
			Document doc = dBuilder. parse ( fXmlFile ) ;
			doc. getDocumentElement ( ) . normalize ( ) ;

			NodeList nList = doc. getElementsByTagName (tag ) ;
			for ( int temp = 0 ; temp < nList. getLength ( ) ; temp ++ ) {

				Node nNode = nList. item ( temp ) ;	    
				if ( nNode. getNodeType ( ) == Node. ELEMENT_NODE ) {		
					Element eElement = ( Element ) nNode ;		          
					value=getTagString ( element ,eElement );
				}
			}
		} catch ( Exception e ) {
			e. printStackTrace ( ) ;		     
		}
		return value;
	}  	 

	private static Float getTagValue ( String sTag, Element eElement ) {
		NodeList nlList = eElement. getElementsByTagName ( sTag ) . item ( 0 ) . getChildNodes ( ) ;
		Node nValue = ( Node ) nlList. item ( 0 ) ; 

		float floatValue=0f;

		try {
			floatValue = Float.valueOf(nValue.getNodeValue().trim()).floatValue();
		}
		catch (NumberFormatException nfe){
			System.out.println("NumberFormatException: " + nfe.getMessage());
			System.exit(0);
		}
		return floatValue ;    
	}
	
	private static String getTagString ( String sTag, Element eElement ) {
		NodeList nlList = eElement. getElementsByTagName ( sTag ) . item ( 0 ) . getChildNodes ( ) ;
		Node nValue = ( Node ) nlList. item ( 0 ) ; 

		String stringValue=null;

		try {
			stringValue = (nValue.getNodeValue().trim()).toString();
		}
		catch (Exception nfe){
			System.out.println("Exception: " + nfe.getMessage());
			System.exit(0);
		}
		return stringValue ;    
	}
}