package MainLibrary;

import java.util.ArrayList;
import java.util.List;

public class HeapSorter_Domains{
	
    private List<AbstractDomain> list=new ArrayList<AbstractDomain>();
    private int size;

    public void sort(List<AbstractDomain> domainList){
        list=domainList;
    	//list.addAll(domainList);
        size=list.size();
        heapsort();
    }

    private void heapsort(){
        buildheap();
        while (size>1){
        	size--;
            exchange (0, size);
            downheap (0);
        } 
    }

    private void buildheap(){
        for (int v=size/2-1; v>=0; v--)
            downheap (v);
    }

    private void downheap(int v){
        int w=2*v+1;    // first descendant of v
       
        while (w<size){
        	
            if (w+1<size)     // is there a second descendant?
            	if ((list.get(w+1).getBoundingRadius()+list.get(w+1).getDistance()) < (list.get(w).getBoundingRadius()+list.get(w).getDistance())) w++;
            	                       
            // if (list.get(w+1).getAbsDistancePlusRadius()<list.get(w).getAbsDistancePlusRadius()) w++;
            // w is the descendant of v with maximum label

            if (list.get(v).getBoundingRadius()+list.get(v).getDistance()<=list.get(w).getBoundingRadius()+list.get(w).getDistance()) return;  // v has heap property
            // otherwise
            exchange(v, w);  // exchange labels of v and w
            v=w;       		 // continue
            w=2*v+1;
        }
    }

    private void exchange(int i, int j){
    	AbstractDomain t=list.get(i);
    	list.set(i, list.get(j));
    	list.set(j, t);
    }
}    


