package MainLibrary;

import java.util.HashMap;
import java.util.Map;

public class InnerSphericalDomain extends AbstractDomain{		
	
	protected NodeObj owner;
	
	public InnerSphericalDomain(AbstractDomain parentDomain, NodeObj owner, MobilityModel model, AbstractCollisionDomainStrategy strategy, boolean visible, boolean export, float[] dCenter) {
		super(parentDomain, model, strategy, visible, export, dCenter, false);			
		this.owner=owner;
		setBoundingRadius();		
		ID="INNER SPHERICAL";
		
		//if (useOctree) initializeOctree();
		
		if (isVisible()) getManager().engine.addWrapper3DDomain(this);	
	}
	
	public void setOwner(NodeObj owner) {
		this.owner = owner;
	}

	public NodeObj getOwner(){
		return this.owner;
	}
	
	public void handleBoundCollision(NanoObj n){
		getCollisionStrategy().relocateInnerObjs(n,this);
	}
	
	public void handleBoundCollision(NodeObj n){		
		getCollisionStrategy().relocateInnerObjs(n,this);
	}
	
	public void handleBoundCollision(CarrierObj c){
		getOwner().checkIncomingCarrier(c);
	}	
	
	public String getType(){
		return "SPHERICAL DOMAIN";
	}	
	
	public float getRadius() {
		return getBoundingRadius();
	}

	@Override
	public void setBoundingRadius() {
			boundingRadius=owner.getRadius();		
	}
	
	public float[] getAbsCenter(){
		float[] dCenter=new float[3];
		
		float x=owner.getCenter()[0];
		float y=owner.getCenter()[1];
		float z=owner.getCenter()[2];
		
		float[] relativeCenter=getRelativeCenter();
		dCenter[0]=x+relativeCenter[0];
		dCenter[1]=y+relativeCenter[1];
		dCenter[2]=z+relativeCenter[2];		
		
		// returns the absolute coords!
		return dCenter;
	}

	@Override
	public void trigger() {
		// TODO Auto-generated method stub		
	}

	@Override
	public Map<Object, Object> export() {
		exportString=new HashMap<Object, Object>();		
		exportString.put("ID", ID);	
		return exportString;
	}

	@Override
	public boolean isInside(NanoObj objToCheck) {
		// If the Obj's center is inside, then the whole object is considered inside!

		// FIXME
		// This method return False because the spherical domain is the default inside domain for every NodeObjs!
		// If you need other spherical domains you have to create them. DON'T USE THIS!
		
		return false;
	}

	@Override
	public void initializeWrapper3D(Manager m) {
		// TODO Auto-generated method stub		
	}

	@Override
	public void initializeDirectionAxes() {
		// TODO Auto-generated method stub		
	}
}
