package MainLibrary;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;

public class LinearMotion extends MotionStrategy{

	private static LinearMotion instance=null;		
	private FileOutputStream file;
	private PrintStream Output;
	
	private LinearMotion(){
		
	}
	
	public static LinearMotion getInstance(){
		if (instance==null) instance=new LinearMotion();
		return instance;
	}	
	
	@Override
	public void move(NanoObj p) {
		float[] center=p.getCenter();
		float newVelocityModule=p.getVelocityModule();	
		float[] component=p.getVelocityComponent();
		
		float dx=component[0];
		float dy=component[1];
		float dz=component[2];
	
		if(p.getManager().configWrapper.ddt<1){				
			newVelocityModule=(float) Math.sqrt((dx*dx)+(dy*dy)+(dz*dz));			
			float[] angles=p.getVelocityAngles(dx,dy,dz);
			p.setVelocityComponent(newVelocityModule,angles[0], angles[1]);	// OK			
		}	
		
		center[0]=center[0]+dx;
		center[1]=center[1]+dy;
		center[2]=center[2]+dz;
		p.setCenter(center[0],center[1],center[2]);			
	}
	
	public void exportLinear(float dx, float dy, float dz){
		
		try{				
			file = new FileOutputStream("Gaussian.txt",true);
			Output = new PrintStream(file);
			Output.println(dx+" "+dy+" "+dz);		
			 
		} catch (IOException e) {
			System.out.println("Output Error: " + e);
			
		} finally {
		    // Close resource.
		    if (file!= null) try { 
		        file.close();
		    } catch (IOException logOrIgnore) {
		    	System.out.println("Output Error [closing file]: " + logOrIgnore);
		    }
		}
	}
}