package MainLibrary;

import java.util.*;

public abstract class OutputStrategy {
	
	private String classType="OutputStrategy";
	private Manager manager;
	private static String randomFileName=null;
	
	public abstract void export(Map<Object,Object> results);
	public abstract void close();
	public abstract void update(String text);			// UPDATE THE DESCRIPTION TEXT OF THE SIMULATION
	public abstract void initialize(Manager m);
	
	public void setManager(Manager m){
		manager=m;
	}
	
	public Manager getManager(){
		return manager;
	}
	
	public static String getRandomFileName(){

		Random r=new Random();
		if (randomFileName==null) {
			int day, month, year;
			GregorianCalendar gc = new GregorianCalendar();
			day = gc.get(Calendar.DAY_OF_MONTH);
			month = (gc.get(Calendar.MONTH))+1;
			year = gc.get(Calendar.YEAR);

			int hour,minute,second;
			hour=gc.get(Calendar.HOUR_OF_DAY);
			minute=gc.get(Calendar.MINUTE);
			second=gc.get(Calendar.SECOND);
			randomFileName="_exportID"+r.nextInt(1000)+"["+year+"-"+month+"-"+day+"]@"+hour+"-"+minute+"-"+second;
		}
		return randomFileName;
	}	
}
