package MainLibrary;

public abstract class Receptor extends UniversalReceptor{
	
	protected NodeObj node;	
	protected float theta;
	protected float fi;	
	
	public Receptor(NodeObj node, boolean canDownload,float[] relativeCoords, float theta, float fi, short r, int type, EventHandlerForReceptors e){
		super(node.getInnerDomain(), node.getDomain(), canDownload, relativeCoords, r, type, e);		
		
		this.node=node;			
		this.theta=theta;
		this.fi=fi;					
	}
	
	public NodeObj getNode(){
		return node;
	}
	
	public void setNode(NodeObj n){
		node=n;
	}
	
	public float[] getRelativeCoords(){
		double radius=node.getRadius();
		
		float[] coords=new float[3];
		coords[0]=(float) (radius*Math.sin((double)theta)*Math.cos((double)fi));
		coords[1]=(float) (radius*Math.sin((double)theta)*Math.sin((double)fi));
		coords[2]=(float) (radius*Math.cos((double)theta));

		return coords;
	}
	
	public float[] getAbsoluteCoords(){
		float[] nodeCenter=node.getCenter();
		float[] coords=getRelativeCoords();
		coords[0]+=(nodeCenter[0]);
		coords[1]+=(nodeCenter[1]);
		coords[2]+=(nodeCenter[2]);
		return coords;
	}	
	
	// FIXME Verifies if this method is defined also in UniversalReceptor class, if so, remove from here!	
	public void download(){		
		CarrierObj carrier=getCurrentCarrier();
		
		/* It assumes the CarrierObj was detached from its previous domain at the same time that it is attached to a Receptor! */		
		getInnerDomain().attachNanoObj(carrier);
		downloadCarrier(carrier);
		detachCarrier();	
	}	
	
	public float getFi(){
		return fi;		
	}
	
	public float getTheta(){
		return theta;		
	}
}
