package MainLibrary;

public abstract class ReceptorState {

	private int processingTime=10;
	public int remainingTime=processingTime;
	private boolean isFree=false; 
	private UniversalReceptor receptor;	
	
	public abstract void performAction();
	public abstract int getTiming();
		
	public ReceptorState(UniversalReceptor r){
		setReceptor(r);
	}
	
	public void setProcessingTime(int processingTime) {
		this.processingTime = processingTime;
		initRemainingTime();
	}

	public int getProcessingTime() {
		return processingTime;
	}
	
	public UniversalReceptor getReceptor(){
		return this.receptor;
	}
	
	public void setReceptor(UniversalReceptor r){
		this.receptor=r;
	}

	public void setFree(boolean isFree) {
		this.isFree = isFree;
	}

	public boolean isFree() {
		return isFree;
	}
	
	public void initRemainingTime(){
		this.remainingTime=this.processingTime;
	}
}
