package Octree;

import MainLibrary.CarrierObj;
import MainLibrary.NanoObj;
import MainLibrary.NodeObj;

public class OctreeNode extends Octree{

	private Octree parent;
	private OctreeRoot root;
	
	public OctreeNode(OctreeRoot root, Octree parent, String type, float x,float y,float z, float side, int maxObjects, int minSide){
		super(x,y,z,side,maxObjects,minSide);
        this.parent=parent;    
        this.type=type;
        this.level=parent.level+1;
        this.root=root;
        this.setDomain(root.getDomain());
	}
	
	public Octree getParent(){
		return parent;		
	}
	
	public OctreeRoot getRoot() {
		return root;
	}

	@Override
	public void firstInsertOnNode(NanoObj b) {
		insert(b);			
	}

	@Override
	public void firstInsertOnNode(NodeObj b) {
		insert(b);			
	}

	@Override
	public void firstInsertOnNode(CarrierObj b) {		
		insert(b);			
	}		
}
