package engine;

import java.awt.Color;
import MainLibrary.NanoObj;
import com.threed.jpct.Object3D;
import com.threed.jpct.Primitives;
import com.threed.jpct.SimpleVector;


public class Wrapper3D {

	private NanoObj obj;
	private Object3D obj3D;
	private Engine3D engine;

	public Wrapper3D(NanoObj obj , Object3D obj3D, Engine3D engine){
		this.obj = obj;
		this.obj3D = obj3D;
		this.engine = engine;		
	}

	public void draw3D() {		
		if(this.obj==null || this.obj.getTimeToLive()==-1){
			engine.world.removeObject(this.obj3D);
			engine.removeWrapper3d(this);
			try {
				this.finalize();
			} catch (Throwable e) {
				e.printStackTrace();
			}
		}
		else{
			SimpleVector v0 =new SimpleVector(obj.getCenter()[0],obj.getCenter()[1],obj.getCenter()[2]);

			if (obj.getID()==-69 && engine.followNano){				
				SimpleVector posCam8 = new SimpleVector(10,-obj.getRadius(),-10);
				posCam8.add(v0);			
				engine.world.getCamera().setPosition(posCam8);						
			}

			if (!(obj3D.getTranslation().equals(v0))){			
				v0=v0.calcSub(obj3D.getTranslation());
				obj3D.translate(v0);			
			}	
			
		}		
	}

	public void drawSmallPoint(SimpleVector v0){
		Object3D obj3D=null;
		obj3D = Primitives.getBox(5, 1);				
		obj3D.setCulling(false);		
		obj3D.setAdditionalColor(Color.WHITE);		
		obj3D.setEnvmapped(Object3D.ENVMAP_ENABLED);		
		obj3D.build();
		obj3D.translate(v0);	
		engine.world.addObject(obj3D);
		obj3D.compileAndStrip();	
		engine.smallPoint.add(obj3D);

		if(engine.smallPoint.size()>500){
			int size=engine.smallPoint.size();
			for(int i=0;i<size/2;i++){
				engine.world.removeObject(engine.smallPoint.remove(i));
			}
		}
	}

	public NanoObj getObj(){
		return obj;
	}

	public Object3D getObject3d(){
		return obj3D;
	}

	public void changeObj3DColor(Color color){
		obj3D.setAdditionalColor(color);
	}
}
