package engine;

import java.awt.Color;
import MainLibrary.AbstractDomain;
import com.threed.jpct.Object3D;
import com.threed.jpct.Primitives;
import com.threed.jpct.SimpleVector;

public class WrapperDomain3D {
	private AbstractDomain d;
	private Object3D obj3D;
	private Engine3D engine;

	public WrapperDomain3D(AbstractDomain d, Object3D obj3D, Engine3D engine){
		this.d = d;
		this.obj3D = obj3D;
		this.engine = engine;		
	}

	public void draw3D(){	
		if(this.d==null ){
			engine.world.removeObject(this.obj3D);
			engine.removeWrapperDomain3d(this);
			try {
				this.finalize();
			} catch (Throwable e) {
				e.printStackTrace();
			}
		}
		else{
			SimpleVector v0 =new SimpleVector(d.getAbsCenter()[0],d.getAbsCenter()[1],d.getAbsCenter()[2]);

			if (!(obj3D.getTranslation().equals(v0))){			
				v0=v0.calcSub(obj3D.getTranslation());
				obj3D.translate(v0);
				SimpleVector v1=new SimpleVector(d.getAbsCenter()[0],d.getAbsCenter()[1],d.getAbsCenter()[2]);
				drawSmallPoint(v1);
			}
		}
	}

	public void drawSmallPoint(SimpleVector v0){
		Object3D obj3D=null;
		obj3D = Primitives.getBox(20, 1);				
		obj3D.setCulling(false);		
		obj3D.setAdditionalColor(Color.WHITE);		
		obj3D.setEnvmapped(Object3D.ENVMAP_ENABLED);		
		obj3D.build();
		obj3D.translate(v0);	
		engine.world.addObject(obj3D);
		obj3D.compileAndStrip();		
	}

	public AbstractDomain getDomain(){
		return d;
	}

	public Object3D getObject3d(){
		return obj3D;
	}

	public void changeObj3DColor(Color color) {
		obj3D.setAdditionalColor(color);
	}
}
