package simulator;

import java.awt.Color;
import java.util.Map;

import MainLibrary.AbstractDomain;
import MainLibrary.CarrierObj;
import MainLibrary.EventHandlerForReceptors;
import MainLibrary.LigandObserver;
import MainLibrary.UniversalReceptor;
import com.threed.jpct.Object3D;
import com.threed.jpct.Primitives;
import com.threed.jpct.SimpleVector;
import engine.Engine3D;


public class CD40UniversalReceptor extends UniversalReceptor{

	public int assimilatedInfo=0;	
	
	public CD40UniversalReceptor(AbstractDomain parent, AbstractDomain outer, boolean canDownload, float[] center, float theta, float fi, short r, int type, EventHandlerForReceptors e) {
		super(parent, outer, canDownload, center, r, type, e);		
	}

	@Override
	public void downloadCarrier(CarrierObj c) {
		assimilatedInfo++;		
		c.kill(); 			
	}
	
	@Override
	public float[] getRelativeCoords() {	
		float[] center={cx,cy,cz};
		return center;
	}

	@Override
	public float[] getAbsoluteCoords() {		
		
		float[] absCenter=new float[3];	
		float[] relativeCenter=getRelativeCoords();	
		
		try {
			AbstractDomain domain=getInnerDomain();
			
			absCenter[0]=relativeCenter[0]+domain.getAbsCenter()[0];
			absCenter[1]=relativeCenter[1]+domain.getAbsCenter()[1];
			absCenter[2]=relativeCenter[2]+domain.getAbsCenter()[2];
			
		} catch (Exception e) {			
			System.out.println("- Error on CD40UniversalReceptor - Cast to CylindricDomain...");
			e.printStackTrace();
		}			
		return absCenter;
	}	

	public void finalize(){		
		super.finalize();
	}

	@Override
	public Map<Object,Object> export() {
		return null;	
	}
	
	// Draw the receptor in the 3D window
	public void drawSmallPoint(AbstractDomain parent){
		SimpleVector v0=new SimpleVector(getAbsoluteCoords());
		Object3D obj3D=null;
		obj3D = Primitives.getBox(100, 1);	
		//obj3D = Primitives.getBox(getRadius(), 1);	
		obj3D.setCulling(false);		
		obj3D.setAdditionalColor(Color.WHITE);		
		obj3D.setEnvmapped(Object3D.ENVMAP_ENABLED);		
		obj3D.build();
		obj3D.translate(v0);
		Engine3D engine3d=(Engine3D)parent.getManager().engine;
		engine3d.world.addObject(obj3D);
		obj3D.compileAndStrip();		
	} 	
	
	public LigandObserver getMyObserver(){
		return CD40LObserver.getInstance();
	}	
	
	public String assignName(){
		return "CD40UniversalReceptor";	
	}
}

