
package simulator;

import java.awt.Color;
import java.util.HashMap;
import java.util.Map;

import MainLibrary.AbstractDomain;
import MainLibrary.CarrierObj;
import MainLibrary.LigandObserver;
import MainLibrary.LinearMotion;
import MainLibrary.NoMotion;
import MainLibrary.NodeObj;


public class CalciumCarrier extends CarrierObj{
	
	
	public CalciumCarrier(AbstractDomain domain, NodeObj n, float x, float y, float z,int carrierNumberType) {		
		super(domain,n, x, y, z,
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-mass"), 
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-radius").floatValue(), 
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-ttl").intValue(),
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-zoom3D"), carrierNumberType);		
		color=Color.pink;	
	}	
	
	public CalciumCarrier(AbstractDomain domain, float x, float y, float z,int carrierNumberType) {
		super(domain, x, y, z,
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-mass"), 
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-radius").floatValue(), 
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-ttl").intValue(),
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-zoom3D"), carrierNumberType, true);		
	}
	
	@Override
	public LigandObserver getMyObserver() {
		return CalciumObserver.getInstance();
	}	
	
	@Override
	protected Map<Object, Object> specializedExport() {
		Map<Object, Object> m=new HashMap<Object,Object>();
		m.put("Type", "Carrier");
		return m;
	}

	@Override
	public void specializedDetach() {
		kill();		
	}
	
	@Override
	public void setMotionStrategy() {
		this.motionStrategy=BrownianMotion.getInstance();
		
	}
	public String assignName(){		
		return "Calcium Emitted Carrier";		
	}
}
