package simulator;


import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;

import MainLibrary.*;

public class CalciumCheckCollisionNanoObj implements Runnable{	
	
	private List<NanoObj> objsToCheck=new ArrayList<NanoObj>();
	private MobilityModel model;
	private int start,stop;
	public CountDownLatch latch;
	public AbstractDomain activeDomain=null;
	
	public CalciumCheckCollisionNanoObj(int start,int stop,List<NanoObj> objsToCheck,MobilityModel d,AbstractDomain activeDomain,CountDownLatch latch){
		this.objsToCheck=objsToCheck;
		this.model=d;
		this.start=start;
		this.stop=stop;
		this.latch=latch;
		this.activeDomain=activeDomain;			
	}

	public void run(){		
		AbstractCollisionDomainStrategy strategy=activeDomain.getCollisionStrategy();			
		
		//Check Collision!!
		boolean isFinish=false;
		NanoObj n=null;
		for (int i=start;i<stop;i++){
			n=objsToCheck.get(i);			
			isFinish=false;		
			
			for (int j=i+1;j<objsToCheck.size() && !isFinish;j++){	
				//System.out.println(objsToCheck.get(j).getAbsDistancePlusRadius()+" >= "+n.getAbsDistanceMinusRadius());
				if(objsToCheck.get(j).getAbsDistancePlusRadius()>=n.getAbsDistanceMinusRadius()){					
					model.detectCollision(objsToCheck.get(j),n);						
				} else{
					isFinish=true;					
				}
			}	
			strategy.checkInternalCollisionBound(n);
		}
		latch.countDown();
	}	
}
