package simulator;

import java.awt.Color;
import java.util.Map;

import MainLibrary.AbstractDomain;
import MainLibrary.CarrierObj;
import MainLibrary.EventHandlerForReceptors;
import MainLibrary.LigandObserver;
import MainLibrary.NodeObj;
import MainLibrary.Receptor;
import com.threed.jpct.Object3D;
import com.threed.jpct.Primitives;
import com.threed.jpct.SimpleVector;
import engine.Engine3D;


public class CalciumReceptor extends Receptor{

	public int assimilatedInfo=0;	
	
	public CalciumReceptor(NodeObj node, boolean canDownload, float[] center, float theta, float fi, short r, int type, EventHandlerForReceptors e) {
		super(node, canDownload, center, theta, fi, r, type, e);		
	}

	@Override
	public LigandObserver getMyObserver() {
		
		return CalciumObserver.getInstance();
	}

	public void finalize(){		
		super.finalize();
	}

	@Override
	public Map<Object,Object> export() {
		return null;	
	}
	
	// Draw the receptor in the 3D window
	public void drawSmallPoint(AbstractDomain parent){
		SimpleVector v0=new SimpleVector(getAbsoluteCoords());
		Object3D obj3D=null;
		obj3D = Primitives.getBox(15, 1);	
		//obj3D = Primitives.getBox(getRadius(), 1);	
		obj3D.setCulling(false);		
		obj3D.setAdditionalColor(Color.WHITE);		
		obj3D.setEnvmapped(Object3D.ENVMAP_ENABLED);		
		obj3D.build();
		obj3D.translate(v0);
		Engine3D engine3d=(Engine3D)parent.getManager().engine;
		engine3d.world.addObject(obj3D);
		obj3D.compileAndStrip();		
	} 	
	
		
	public String assignName(){
		return "CalciumReceptor";	
	}

	@Override
	public void downloadCarrier(CarrierObj c) {
		node.downloadInfoFrom(c,this);
	}
}
