package simulator;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import MainLibrary.AbstractDomain;
import MainLibrary.CarrierObj;
import MainLibrary.MobilityModel;
import MainLibrary.NanoObj;

public class CheckDomainCollisionThread implements Runnable{	
	
	//private List<NanoObj> objsToCheck=new ArrayList<NanoObj>();
	private List<CarrierObj> objsToCheck=new ArrayList<CarrierObj>();
	
	//private MobilityModel model;
	private int start,stop;
	public CountDownLatch latch;
	public List<AbstractDomain> activeDomain=null;
	public AbstractDomain mainDomain=null;
	
	//public CheckDomainCollisionThread(int start,int stop,List<AbstractDomain> domainToCheck, MobilityModel d, AbstractDomain mainDomain,List<NanoObj> objsToCheck,CountDownLatch latch){
	public CheckDomainCollisionThread(int start,int stop,List<AbstractDomain> domainToCheck, MobilityModel d, AbstractDomain mainDomain,List<CarrierObj> objsToCheck,CountDownLatch latch){
		this.objsToCheck=objsToCheck;
		//this.model=d;
		this.start=start;
		this.stop=stop;
		this.latch=latch;
		this.activeDomain=domainToCheck;	
		this.mainDomain=mainDomain;
	}

	public void run(){		
				
		boolean isFinish=false;	
		
		//Check Collision!!
		int objSize	= objsToCheck.size();	
		
		for (int i=start;i<stop;i++){				
			
			isFinish=false;
			try{
				for (int j=0;j<objSize && !isFinish;j++){
					if(objsToCheck.get(j).getDomain()==mainDomain){									
						float Dplus=activeDomain.get(i).getDistance()+activeDomain.get(i).getBoundingRadius();
						float Dminus=activeDomain.get(i).getDistance()-activeDomain.get(i).getBoundingRadius();
						float Nplus=objsToCheck.get(j).getAbsDistancePlusRadius();
						float Nminus=objsToCheck.get(j).getAbsDistanceMinusRadius();																		

						if(Dminus>Nplus) { 
							// They are not overlapped, neither the following objects!	
							isFinish=true;
							
						} else if((Dminus<=Nminus && Nminus<=Dplus) || (Dminus>=Nminus && Nplus>=Dminus) || (Dplus<=Nplus && Nminus<=Dplus)) { 
				
							// probable collision!!!							
							try{
								activeDomain.get(i).getCollisionStrategy().checkExternalCollisionBound(activeDomain.get(i), objsToCheck.get(j));

							}catch (Exception e){											
								e.printStackTrace();						
							}
						} 
					}
				}
			}catch (Exception e){
				e.printStackTrace();
			}
		}		
		
		latch.countDown();
	}	
}