package simulator;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import MainLibrary.AbstractDomain;
import MainLibrary.NanoObj;

public class CheckInnerDomainCollisionThread implements Runnable{	
	
	private List<NanoObj> objsToCheck=new ArrayList<NanoObj>();	
	private int start,stop;
	public CountDownLatch latch;
	public AbstractDomain mainDomain=null;

	
	public CheckInnerDomainCollisionThread(int start, int stop, AbstractDomain mainDomain, List<NanoObj> objsToCheck, CountDownLatch latch){
		this.objsToCheck=objsToCheck;		
		this.start=start;
		this.stop=stop;
		this.latch=latch;			
		this.mainDomain=mainDomain;
	}

	public void run(){		

		//Check Collision!!				
		mainDomain.getCollisionStrategy().checkInternalCollisionBound(objsToCheck.subList(start, stop));
		
		latch.countDown();
	}	
}