package simulator;

import java.awt.Color;
import java.util.Random;
import MainLibrary.AbstractCollision;
import MainLibrary.AbstractCollisionDomainStrategy;
import MainLibrary.AbstractDomain;
import MainLibrary.MobilityModel;
import MainLibrary.NanoCollision;
import MainLibrary.NanoObj;


public class CubicCalciumDomain extends CubicDomain{	
	
	public Random rand=new Random();	
	
	public CubicCalciumDomain(AbstractDomain parentDomain, MobilityModel model, AbstractCollisionDomainStrategy strategy, boolean visible, boolean export, float halfSide, float[] center,  boolean useOctree) {
		super(parentDomain, model, strategy, visible, export, halfSide, center, useOctree);					
	}	
	
	public String getType(){
		return "Cube Domain for Calcium";
	}	

	@Override
	public void trigger() {
		
	}

	public boolean isFreeSpace(NanoObj obj){

		boolean isFree=false;
		if(obj instanceof CalciumCell_TX || obj instanceof CalciumCarrier) {
			isFree=true;
		}else{
			isFree=super.isFreeSpace( obj);
		}			
		return isFree;			
	}
	
	public void addToCollisionsList(NanoObj p1,NanoObj p2,float dt){		
		AbstractCollision c=new NanoCollision(p1,p2,dt);
		
		//setCollisionsList(c);
		setToFreeCollisionsList3(c);			
		
		if (getManager().is3DEnable) {	
			if(p1 instanceof CalciumCell_TX){
				p1.setColor(Color.pink);
			}else{
				p1.setColor(Color.darkGray);
			}
			
			if(p2 instanceof CalciumCell_TX){
				p2.setColor(Color.pink);
			}else{
				p2.setColor(Color.darkGray);
			}			
		}
		
		p1.increaseCollisionCount();
		p2.increaseCollisionCount();
	}
}
