package simulator;

import com.threed.jpct.SimpleVector;

import MainLibrary.*;

public class CubicReceptorStrategy  extends CubicStrategy{	
	
	public CubicReceptorStrategy(int type){
		super(type);
	}
	
	//@Override
	public void checkExternalCollisionBound_PROVA(AbstractDomain domainToCheck, NanoObj objToCheck) {

		if(isCollidingFromOutside(domainToCheck, objToCheck)){
			CubicDomain domain=(CubicDomain)domainToCheck;

			SimpleVector dParallel=domain.getDirectionP();		
			SimpleVector nanoVector=new SimpleVector(getRelativeCenter(domainToCheck, objToCheck));
			float angle0=nanoVector.calcAngle(dParallel);
			float nanoModule=nanoVector.length();
			float dPOrto=(float) (nanoModule*Math.cos(angle0));

			SimpleVector dOrto=domain.getDirectionN();			
			float angle=nanoVector.calcAngle(dOrto);		
			float dNOrto=(float) (nanoModule*Math.cos(angle));

			SimpleVector dOrto2=domain.getDirectionO();		
			float angle2=nanoVector.calcAngle(dOrto2);
			float dNOrto2=(float) (nanoModule*Math.cos(angle2));

			float dP=Math.abs(dPOrto)-objToCheck.getRadius();
			float dN=Math.abs(dNOrto)-objToCheck.getRadius();
			float dN2=Math.abs(dNOrto2)-objToCheck.getRadius();
			float distanceP=dP;
			float distanceN=dN;

			double dsP=Math.abs((Math.abs(distanceP))-(domain.getHalfSide()));
			double dsN=Math.abs((Math.abs(distanceN))-(domain.getHalfSide()));
			double dsN2=Math.abs((Math.abs(dN2))-(domain.getHalfSide()));
			
			float[] velocity1=objToCheck.getVelocityComponent();			
			float dt=1;
			try {			
				// Computes the collision along the parallel component 
				if (dsP>=dsN && dsN2>=dsN){	
					SimpleVector velocityVector=new SimpleVector(velocity1);
					float angleV=velocityVector.calcAngle(domain.getDirectionN());
					float dsPV=(float) ((dsN)*Math.cos(angleV));

					dt =(float) Math.abs((dsPV))/Math.abs(objToCheck.getVelocityModule()); // Warning! catch the div-by-zero!!!
					dt=dt+0;

				}else if (dsP>=dsN2 && dsN>=dsN2){
					SimpleVector velocityVector=new SimpleVector(velocity1);
					float angleV=velocityVector.calcAngle(domain.getDirectionO());
					float dsNV=(float) ((dsN2)*Math.cos(angleV));
					dt =(float) Math.abs((dsNV))/Math.abs(objToCheck.getVelocityModule()); 

				} else if (dsP<=dsN2 && dsN>=dsP){
					SimpleVector velocityVector=new SimpleVector(velocity1);
					float angleV=velocityVector.calcAngle(domain.getDirectionP());
					float dsNV=(float) ((dsP)*Math.cos(angleV));
					dt =(float) Math.abs((dsNV))/Math.abs(objToCheck.getVelocityModule()); 
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());	
			}
			domain.getParentDomain().addToCollisionsListExternal(domain,objToCheck,dt);			
		} 
	}

	
	// _ORIGINAL_BUT_I_AM_NOT_SURE_IF_IT_WORKS
	@Override
	public void checkExternalCollisionBound(AbstractDomain domainToCheck, NanoObj objToCheck) {
		
		/** This class performs the collision handling for the HUVEC Cells, 
		 * 	that are represented here as Cubic Receptor Domains.
		 * 	The collision handling consists in a check of the incoming carriers,
		 * 	if they are over a specific receptor, then they can be assimilated, otherwise the collisions
		 * 	are delegated to the main Cylindric Domain (the blood vessel).
		 */
		
		if(isCollidingFromOutside(domainToCheck, objToCheck) && objToCheck instanceof CarrierObj){

			CubicReceptorDomain domain=(CubicReceptorDomain)domainToCheck;		
			
			float[] distanceOnAxis=getDistanceOnAxis(domainToCheck,objToCheck);
			float distanceP=distanceOnAxis[0]-objToCheck.getRadius();
			float distanceN=distanceOnAxis[1]-objToCheck.getRadius();	
			float[] velocity1=objToCheck.getVelocityComponent();	
			
			// The collision should have occurred at t-dt (Actually this is also an approximation).
			float dt=1;
			try {	
		
				double dsP=((Math.abs(distanceP)-(domain.getHalfSide())));
				double dsN=((Math.abs(distanceN)-(domain.getHalfSide())));
				
				// Computes the collision along the parallel component  				
				if (dsP>=dsN){
										
					SimpleVector velocityVector=new SimpleVector(velocity1);
					float angleV=velocityVector.calcAngle(domain.getDirectionP());

					float dsPV=(float) ((dsP)*Math.cos(angleV));				
					dt =(float) Math.abs((dsPV))/Math.abs(objToCheck.getVelocityModule()); // Warning! catch the div-by-zero!!!			
					
				}else{
															
					SimpleVector velocityVector=new SimpleVector(velocity1);
					float angleV=velocityVector.calcAngle(domain.getDirectionP());

					float dsNV=(float) ((dsN)*Math.sin(angleV));
					dt =(float) Math.abs((dsNV))/Math.abs(objToCheck.getVelocityModule()); 												
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());	
			}	
			
			domain.getParentDomain().addToCollisionsListExternal(domain,objToCheck,dt);			
		} 
	}
}