package simulator;

import java.awt.Color;
import java.util.List;
import java.util.concurrent.CountDownLatch;

import MainLibrary.AbstractDomain;
import MainLibrary.CheckNanoObjCollisionThreadLatch;
import MainLibrary.HeapSorter;
import MainLibrary.NanoObj;
import com.threed.jpct.SimpleVector;


public class CylindricStrategyBloodVessel extends CylindricStrategy{	

	// FIXME DEBUG ONLY
	public long domainCollision=0;

	public CylindricStrategyBloodVessel(int type){
		super(type);
	}


	// 17/03/2014 
	public void checkInternalCollisionBound(List<NanoObj> objsToCheck) {

		for (int i=0;i<objsToCheck.size();i++){			
			try{

				if(objsToCheck.get(i).getTimeToLive()>0){

					CylindricDomain domain=(CylindricDomain) objsToCheck.get(i).getDomain();					

					float[] distances=getDistanceOnAxis(domain,objsToCheck.get(i));				

					float[] domainCenter=domain.getAbsCenter();				

					float[] nanoCenter=objsToCheck.get(i).getCenter();	

					float distanceP= distances[0]+objsToCheck.get(i).getRadius();

					float distanceN= (float) ((Math.sqrt(distances[1]*distances[1]+distances[2]*distances[2]))+objsToCheck.get(i).getRadius());	

					// FIXME Tring to use directionN as a combination of N and O
					//double distanceN= Math.sqrt(distances[1]*distances[1]+distances[2]*distances[2])+objsToCheck.get(i).getRadius();

					float x=nanoCenter[0]-domainCenter[0];
					float y=nanoCenter[1]-domainCenter[1];
					float z=nanoCenter[2]-domainCenter[2];

					SimpleVector nanoObjRelativeCenter=new SimpleVector(x,y,z);
					
					
					if ((Math.abs(distanceP))>=domain.getHeight()/2){									

						// the collision should have occurred at t-dt (Actually this is also an approximation).
						float dt=1;
						try {							
							// FIXME Computes the collision along the parallel direction.
							// Computes the penetration distance (ds) along this direction.
							// Relocate the ds along the direction of collision and divide for the velocity in order to get the time spent for the penetration...
							double angleP=getAngle(domain.getDirectionP(),nanoObjRelativeCenter);		
							
							double ds=(Math.abs(distanceP)-(domain.getHeight()/2));
							dt =(float) Math.abs((ds/Math.cos(angleP)))/Math.abs(objsToCheck.get(i).getVelocityModule()); // Warning! catch the div-by-zero!!!

						} catch (Exception e) {
							System.out.println(e.getMessage());	
						}						
						domain.addToCollisionsListInternal(objsToCheck.get(i).getDomain(),objsToCheck.get(i),dt);							

					} else if(Math.abs(distanceN)>=domain.getRadius()){
						// the collision should have occurred at t-dt (Actually this is also an approximation).
						float dt=1;
						try {							
							// FIXME Computes the collision along the parallel direction.
							// Computes the penetration distance (ds) along this direction.
							// Relocate the ds along the direction of collision and divide for the velocity in order to get the time spent for the penetration...

							// FIXME Tring to use directionN...
							//double angleN=(Math.PI/2)-angleP;
							
							double angleN=domain.getAngleN(nanoObjRelativeCenter,distances[1],distances[2]);
							
							double ds=(Math.abs(distanceN)-(domain.getRadius()));
							dt =(float) Math.abs((ds/Math.cos(angleN)))/Math.abs(objsToCheck.get(i).getVelocityModule()); // Warning! catch the div-by-zero!!!

						} catch (Exception e) {
							System.out.println(e.getMessage());	
						}
						domain.addToCollisionsListInternal(domain,objsToCheck.get(i),dt);	
					}					
				}
			}catch (Exception e){
				e.printStackTrace();
			}
		}
	}

	// 17/03/2014  -  ORIGINAL
	public void checkInternalCollisionBound_ORIGINAL(List<NanoObj> objsToCheck) {

		//long start=System.currentTimeMillis();

		for (int i=0;i<objsToCheck.size();i++){			
			try{

				if(objsToCheck.get(i).getTimeToLive()>0){

					CylindricDomain domain=(CylindricDomain) objsToCheck.get(i).getDomain();					

					float[] distances=getDistanceOnAxis(domain,objsToCheck.get(i));				

					float[] domainCenter=domain.getAbsCenter();				

					float[] nanoCenter=objsToCheck.get(i).getCenter();	

					float distanceP= distances[0]+objsToCheck.get(i).getRadius();

					float distanceN= distances[1]+objsToCheck.get(i).getRadius();	

					// FIXME Tring to use directionN as a combination of N and O
					//double distanceN= Math.sqrt(distances[1]*distances[1]+distances[2]*distances[2])+objsToCheck.get(i).getRadius();


					float x=nanoCenter[0]-domainCenter[0];
					float y=nanoCenter[1]-domainCenter[1];
					float z=nanoCenter[2]-domainCenter[2];

					SimpleVector nanoObjRelativeCenter=new SimpleVector(x,y,z);


					double angleP=getAngle(domain.getDirectionP(),nanoObjRelativeCenter);					


					// FIXME Tring to use directionN...
					double angleN=(Math.PI/2)-angleP;
					/*
					SimpleVector vectorN=new SimpleVector(domain.getDirectionN());
					vectorN.add(domain.getDirectionO());
					vectorN.scalarMul((float) distanceN);

					double angleN=getAngle(vectorN,nanoObjRelativeCenter);
					// END of new strategy for distanceN
					*/


					if ((Math.abs(distanceP))>=domain.getHeight()/2){									

						// the collision should have occurred at t-dt (Actually this is also an approximation).
						float dt=1;
						try {							
							// FIXME Computes the collision along the parallel direction.
							// Computes the penetration distance (ds) along this direction.
							// Relocate the ds along the direction of collision and divide for the velocity in order to get the time spent for the penetration...

							double ds=(Math.abs(distanceP)-(domain.getHeight()/2));
							dt =(float) Math.abs((ds/Math.cos(angleP)))/Math.abs(objsToCheck.get(i).getVelocityModule()); // Warning! catch the div-by-zero!!!

						} catch (Exception e) {
							System.out.println(e.getMessage());	
						}						
						domain.addToCollisionsListInternal(objsToCheck.get(i).getDomain(),objsToCheck.get(i),dt);							

					} else if(Math.abs(distanceN)>=domain.getRadius()){
						// the collision should have occurred at t-dt (Actually this is also an approximation).
						float dt=1;
						try {							
							// FIXME Computes the collision along the parallel direction.
							// Computes the penetration distance (ds) along this direction.
							// Relocate the ds along the direction of collision and divide for the velocity in order to get the time spent for the penetration...

							double ds=(Math.abs(distanceN)-(domain.getRadius()));
							dt =(float) Math.abs((ds/Math.cos(angleN)))/Math.abs(objsToCheck.get(i).getVelocityModule()); // Warning! catch the div-by-zero!!!

						} catch (Exception e) {
							System.out.println(e.getMessage());	
						}
						domain.addToCollisionsListInternal(domain,objsToCheck.get(i),dt);	
					}					
				}
			}catch (Exception e){
				e.printStackTrace();
			}
		}
	}


	public void relocateInnerObjs(NanoObj toRelocate, AbstractDomain domain) {

		//FIXME For the BloodVessel Simulations I want to use a different
		// 		Strategy to relocate Objs! The original strategy fits with 
		//		the ordinary Cylindric Domains!!!

		relocateInnerObjsForBloodVessels(toRelocate,domain);
	}

	@Deprecated
	public void relocateInnerObjsForOrdinaryCylindricDomains(NanoObj toRelocate, AbstractDomain domain){

		if(toRelocate.getDomain()==domain){		
			CylindricDomain owner=(CylindricDomain)domain;

			float[] center1=toRelocate.getCenter();
			float[] center2=owner.getAbsCenter();
			float[] velocity1=toRelocate.getVelocityComponent();
			float modVelocity1=toRelocate.getVelocityModule();
			float modVelocity2=0;
			double dt=0;			

			if (modVelocity1==0 && modVelocity2==0){

			} else{

				float[] distances=getDistanceOnAxis(domain,toRelocate);				

				float[] domainCenter=domain.getAbsCenter();				

				float[] nanoCenter=toRelocate.getCenter();	

				float distanceP= distances[0]+toRelocate.getRadius();

				float distanceN= distances[1]+toRelocate.getRadius();	

				float dx21 = (center2[0]-center1[0]);
				float dy21 = (center2[1]-center1[1]);
				float dz21 = (center2[2]-center1[2]);		

				SimpleVector nanoObjRelativeCenter=new SimpleVector(dx21,dy21,dz21);
				double angleP=getAngle(domain.getDirectionP(),nanoObjRelativeCenter);

				double angleN=(Math.PI/2)-angleP;

				if ((Math.abs(distanceP))>=owner.getHeight()/2){		


					double ds=(Math.abs(distanceP)-(owner.getHeight()/2));	

					dt =(float) Math.abs((ds/Math.cos(angleP)))/Math.abs(toRelocate.getVelocityModule()); // Warning! catch the div-by-zero!!!

					center1[0]+=-velocity1[0]*dt;
					center1[1]+=-velocity1[1]*dt;
					center1[2]+=-velocity1[2]*dt;
					toRelocate.setCenter(center1[0], center1[1], center1[2]);

					SimpleVector v1=new SimpleVector(toRelocate.getVelocityComponent());
					SimpleVector d=domain.getDirectionP();
					double dModule=Math.sqrt(d.x*d.x+d.y*d.y+d.z*d.z);
					float[] dVersorComponent=new float[3];
					dVersorComponent[0]=(float) (d.x/dModule);
					dVersorComponent[1]=(float) (d.y/dModule);
					dVersorComponent[2]=(float) (d.z/dModule);

					SimpleVector dVersor=new SimpleVector(dVersorComponent);

					float x=nanoCenter[0]-domainCenter[0];
					float y=nanoCenter[1]-domainCenter[1];
					float z=nanoCenter[2]-domainCenter[2];

					float relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);

					SimpleVector nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);

					SimpleVector oTempVersor=nanoCenterVersor.calcCross(dVersor);

					if(oTempVersor.length()!=0){
						oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());

					}else{
						oTempVersor=new SimpleVector(0,0,0);
					}

					SimpleVector nTempVersor=oTempVersor.calcCross(dVersor);

					float alfa=nTempVersor.calcAngle(v1);
					double n1Module=toRelocate.getVelocityModule()*Math.cos(alfa);
					float[] n1components=new float[3];
					n1components[0]=(float) (n1Module*nTempVersor.x);
					n1components[1]=(float) (n1Module*nTempVersor.y);
					n1components[2]=(float) (n1Module*nTempVersor.z);				
					SimpleVector n1=new SimpleVector(n1components);

					float gamma=dVersor.calcAngle(v1);				
					double d1Module=toRelocate.getVelocityModule()*Math.cos(gamma);
					float[] d1components=new float[3];
					d1components[0]=(float) (d1Module*dVersor.x);
					d1components[1]=(float) (d1Module*dVersor.y);
					d1components[2]=(float) (d1Module*dVersor.z);				
					SimpleVector d1=new SimpleVector(d1components);

					float ro=oTempVersor.calcAngle(v1);				
					double o1Module=toRelocate.getVelocityModule()*Math.cos(ro);
					float[] o1components=new float[3];
					o1components[0]=(float) (o1Module*oTempVersor.x);
					o1components[1]=(float) (o1Module*oTempVersor.y);
					o1components[2]=(float) (o1Module*oTempVersor.z);				
					SimpleVector o1=new SimpleVector(o1components);

					n1.add(o1);
					SimpleVector v2=n1.calcSub(d1);

					float fi1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[0];
					float theta1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[1];
					float nextVelocityModule1=(float) Math.sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
					toRelocate.setVelocityComponent(nextVelocityModule1, fi1, theta1);	

					center1[0]+=v2.x*dt;
					center1[1]+=v2.y*dt;
					center1[2]+=v2.z*dt;
					toRelocate.setCenter(center1[0], center1[1], center1[2]);

				} if ((Math.abs(distanceN))>=owner.getRadius()){		
					double ds=(Math.abs(distanceN)-(owner.getRadius()));	
					dt =(float) Math.abs((ds/Math.cos(angleN)))/Math.abs(toRelocate.getVelocityModule()); // Warning! catch the div-by-zero!!!

					if (dt>1.1) {
						dt=1;					
					}

					center1[0]+=-velocity1[0]*dt;
					center1[1]+=-velocity1[1]*dt;
					center1[2]+=-velocity1[2]*dt;
					toRelocate.setCenter(center1[0], center1[1], center1[2]);

					SimpleVector v1=new SimpleVector(toRelocate.getVelocityComponent());
					SimpleVector d=domain.getDirectionP();
					double dModule=Math.sqrt(d.x*d.x+d.y*d.y+d.z*d.z);
					float[] dVersorComponent=new float[3];
					dVersorComponent[0]=(float) (d.x/dModule);
					dVersorComponent[1]=(float) (d.y/dModule);
					dVersorComponent[2]=(float) (d.z/dModule);

					SimpleVector dVersor=new SimpleVector(dVersorComponent);			

					float x=nanoCenter[0]-domainCenter[0];
					float y=nanoCenter[1]-domainCenter[1];
					float z=nanoCenter[2]-domainCenter[2];

					float relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);
					SimpleVector nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);
					SimpleVector oTempVersor=nanoCenterVersor.calcCross(dVersor);
					oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());
					SimpleVector nTempVersor=oTempVersor.calcCross(dVersor);

					float alfa=nTempVersor.calcAngle(v1);				
					double n1Module=toRelocate.getVelocityModule()*Math.cos(alfa);
					float[] n1components=new float[3];
					n1components[0]=(float) (n1Module*nTempVersor.x);
					n1components[1]=(float) (n1Module*nTempVersor.y);
					n1components[2]=(float) (n1Module*nTempVersor.z);				
					SimpleVector n1=new SimpleVector(n1components);

					float gamma=dVersor.calcAngle(v1);				
					double d1Module=toRelocate.getVelocityModule()*Math.cos(gamma);
					float[] d1components=new float[3];
					d1components[0]=(float) (d1Module*dVersor.x);
					d1components[1]=(float) (d1Module*dVersor.y);
					d1components[2]=(float) (d1Module*dVersor.z);				
					SimpleVector d1=new SimpleVector(d1components);

					float ro=oTempVersor.calcAngle(v1);				
					double o1Module=toRelocate.getVelocityModule()*Math.cos(ro);
					float[] o1components=new float[3];
					o1components[0]=(float) (o1Module*oTempVersor.x);
					o1components[1]=(float) (o1Module*oTempVersor.y);
					o1components[2]=(float) (o1Module*oTempVersor.z);				
					SimpleVector o1=new SimpleVector(o1components);

					d1.add(o1);
					SimpleVector v2=d1.calcSub(n1);	

					float fi1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[0];
					float theta1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[1];
					float nextVelocityModule1=(float) Math.sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
					toRelocate.setVelocityComponent(nextVelocityModule1, fi1, theta1);

					center1[0]+=v2.x*dt;
					center1[1]+=v2.y*dt;
					center1[2]+=v2.z*dt;
					toRelocate.setCenter(center1[0], center1[1], center1[2]);
				}
			}	
		}
	}

	@Override
	public void relocateOuterObjs(NanoObj toRelocate, AbstractDomain domainToRelocate) {
		if(toRelocate.getDomain()!=domain){			
			CylindricDomain domain=(CylindricDomain)domainToRelocate;

			float[] velocity1=toRelocate.getVelocityComponent();
			float modVelocity1=toRelocate.getVelocityModule();
			float modVelocity2=0;
			double dt=0;	

			if (modVelocity1==0 && modVelocity2==0){				

			} else{

				float[] distances=getDistanceOnAxis(domain,toRelocate);		
				float[] domainCenter=domain.getAbsCenter();		
				float[] nanoCenter=toRelocate.getCenter();	
				float distanceP= distances[0]-toRelocate.getRadius();
				//float distanceN= distances[1]-toRelocate.getRadius();	
				float distanceN= (float) ((Math.sqrt(distances[1]*distances[1]+distances[2]*distances[2]))-toRelocate.getRadius());	

				if (((distanceP)<=domain.getHeight()/2) && (distanceN<=domain.getRadius())){						

					float dsP=distanceP-(domain.getHeight()/2);
					float dsN=distanceN-(domain.getRadius());

					if (dsP>=dsN){
						SimpleVector velocityVector=new SimpleVector(velocity1);
						float angleV=velocityVector.calcAngle(domain.getDirectionP());
						float dsPV=(float) ((dsP)*Math.cos(angleV));
						dt =(float) Math.abs((dsPV))/Math.abs(toRelocate.getVelocityModule()); // Warning! catch the div-by-zero!!!

						if (dt>1.1) {
							dt=1;					
						}

						nanoCenter[0]+=-velocity1[0]*dt;
						nanoCenter[1]+=-velocity1[1]*dt;
						nanoCenter[2]+=-velocity1[2]*dt;
						toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);

						SimpleVector v1=new SimpleVector(toRelocate.getVelocityComponent());
						SimpleVector d=domain.getDirectionP();
						double dModule=Math.sqrt(d.x*d.x+d.y*d.y+d.z*d.z);
						float[] dVersorComponent=new float[3];
						dVersorComponent[0]=(float) (d.x/dModule);
						dVersorComponent[1]=(float) (d.y/dModule);
						dVersorComponent[2]=(float) (d.z/dModule);

						SimpleVector dVersor=new SimpleVector(dVersorComponent);
						domainCenter=domain.getAbsCenter();					
						nanoCenter=toRelocate.getCenter();

						float x=nanoCenter[0]-domainCenter[0];
						float y=nanoCenter[1]-domainCenter[1];
						float z=nanoCenter[2]-domainCenter[2];

						float relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);
						SimpleVector nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);
						SimpleVector oTempVersor=nanoCenterVersor.calcCross(dVersor);
						if(oTempVersor.length()!=0){
							oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());
						}else{
							oTempVersor=new SimpleVector(0,0,0);
						}

						SimpleVector nTempVersor=oTempVersor.calcCross(dVersor);
						float alfa=nTempVersor.calcAngle(v1);				

						double n1Module=toRelocate.getVelocityModule()*Math.cos(alfa);
						float[] n1components=new float[3];
						n1components[0]=(float) (n1Module*nTempVersor.x);
						n1components[1]=(float) (n1Module*nTempVersor.y);
						n1components[2]=(float) (n1Module*nTempVersor.z);				
						SimpleVector n1=new SimpleVector(n1components);

						float gamma=dVersor.calcAngle(v1);				
						double d1Module=toRelocate.getVelocityModule()*Math.cos(gamma);
						float[] d1components=new float[3];
						d1components[0]=(float) (d1Module*dVersor.x);
						d1components[1]=(float) (d1Module*dVersor.y);
						d1components[2]=(float) (d1Module*dVersor.z);				
						SimpleVector d1=new SimpleVector(d1components);

						float ro=oTempVersor.calcAngle(v1);				
						double o1Module=toRelocate.getVelocityModule()*Math.cos(ro);
						float[] o1components=new float[3];
						o1components[0]=(float) (o1Module*oTempVersor.x);
						o1components[1]=(float) (o1Module*oTempVersor.y);
						o1components[2]=(float) (o1Module*oTempVersor.z);				
						SimpleVector o1=new SimpleVector(o1components);

						//InelasticCollision
						d1.scalarMul(inelasticCoefficient);						
						// END InelasticCollision

						n1.add(o1);
						SimpleVector v2=n1.calcSub(d1);

						float fi1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[0];
						float theta1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[1];
						float nextVelocityModule1=(float) Math.sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
						toRelocate.setVelocityComponent(nextVelocityModule1, fi1, theta1);	



						velocity1=toRelocate.getVelocityComponent();
						nanoCenter[0]+=velocity1[0]*dt;
						nanoCenter[1]+=velocity1[1]*dt;
						nanoCenter[2]+=velocity1[2]*dt;
						toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);						


					}else{
						SimpleVector velocityVector=new SimpleVector(velocity1);
						float angleV=velocityVector.calcAngle(domain.getDirectionP());
						float dsNV=(float) ((dsN)*Math.sin(angleV));
						
						
						dt =(float) Math.abs((dsNV))/Math.abs(toRelocate.getVelocityModule()); 

						if (dt>1.1) {
							dt=1;					
						}

						nanoCenter[0]+=-velocity1[0]*dt;
						nanoCenter[1]+=-velocity1[1]*dt;
						nanoCenter[2]+=-velocity1[2]*dt;
						toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);

						SimpleVector v1=new SimpleVector(toRelocate.getVelocityComponent());
						SimpleVector d=domain.getDirectionP();
						double dModule=Math.sqrt(d.x*d.x+d.y*d.y+d.z*d.z);
						float[] dVersorComponent=new float[3];
						dVersorComponent[0]=(float) (d.x/dModule);
						dVersorComponent[1]=(float) (d.y/dModule);
						dVersorComponent[2]=(float) (d.z/dModule);

						SimpleVector dVersor=new SimpleVector(dVersorComponent);
						domainCenter=domain.getAbsCenter();
						nanoCenter=toRelocate.getCenter();

						float x=nanoCenter[0]-domainCenter[0];
						float y=nanoCenter[1]-domainCenter[1];
						float z=nanoCenter[2]-domainCenter[2];

						float relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);
						SimpleVector nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);
						SimpleVector oTempVersor=nanoCenterVersor.calcCross(dVersor);
						oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());
						SimpleVector nTempVersor=oTempVersor.calcCross(dVersor);
						nTempVersor=nTempVersor.normalize();

						float alfa=nTempVersor.calcAngle(v1);		
						double n1Module=toRelocate.getVelocityModule()*Math.cos(alfa);
						float[] n1components=new float[3];
						n1components[0]=(float) (n1Module*nTempVersor.x);
						n1components[1]=(float) (n1Module*nTempVersor.y);
						n1components[2]=(float) (n1Module*nTempVersor.z);				
						SimpleVector n1=new SimpleVector(n1components);

						float gamma=dVersor.calcAngle(v1);				
						double d1Module=toRelocate.getVelocityModule()*Math.cos(gamma);
						float[] d1components=new float[3];
						d1components[0]=(float) (d1Module*dVersor.x);
						d1components[1]=(float) (d1Module*dVersor.y);
						d1components[2]=(float) (d1Module*dVersor.z);				
						SimpleVector d1=new SimpleVector(d1components);

						float ro=oTempVersor.calcAngle(v1);				
						double o1Module=toRelocate.getVelocityModule()*Math.cos(ro);
						float[] o1components=new float[3];
						o1components[0]=(float) (o1Module*oTempVersor.x);
						o1components[1]=(float) (o1Module*oTempVersor.y);
						o1components[2]=(float) (o1Module*oTempVersor.z);				
						SimpleVector o1=new SimpleVector(o1components);

						//InelasticCollision
						n1.scalarMul(inelasticCoefficient);						
						// END InelasticCollision

						d1.add(o1);
						SimpleVector v2=d1.calcSub(n1);	

						float fi1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[0];
						float theta1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[1];
						float nextVelocityModule1=(float) Math.sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
						toRelocate.setVelocityComponent(nextVelocityModule1, fi1, theta1);	


						velocity1=toRelocate.getVelocityComponent();
						nanoCenter[0]+=velocity1[0]*dt;
						nanoCenter[1]+=velocity1[1]*dt;
						nanoCenter[2]+=velocity1[2]*dt;
						toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);
					}				
				} 				
			}				
		}
	}	

	@Deprecated
	public void relocateOuterObjs_NO_Inelastic_Coefficent(NanoObj toRelocate, AbstractDomain domainToRelocate) {
		if(toRelocate.getDomain()!=domain){			
			CylindricDomain domain=(CylindricDomain)domainToRelocate;
			float[] velocity1=toRelocate.getVelocityComponent();
			float modVelocity1=toRelocate.getVelocityModule();
			float modVelocity2=0;
			double dt=0;	

			if (modVelocity1==0 && modVelocity2==0){

			} else{

				float[] distances=getDistanceOnAxis(domain,toRelocate);				

				float[] domainCenter=domain.getAbsCenter();				

				float[] nanoCenter=toRelocate.getCenter();	

				float distanceP= distances[0]-toRelocate.getRadius();

				float distanceN= distances[1]-toRelocate.getRadius();				

				if (((distanceP)<=domain.getHeight()/2) && (distanceN<=domain.getRadius())){						

					float dsP=distanceP-(domain.getHeight()/2);
					float dsN=distanceN-(domain.getRadius());

					if (dsP>=dsN){
						SimpleVector velocityVector=new SimpleVector(velocity1);
						float angleV=velocityVector.calcAngle(domain.getDirectionP());

						float dsPV=(float) ((dsP)*Math.cos(angleV));

						dt =(float) Math.abs((dsPV))/Math.abs(toRelocate.getVelocityModule()); // Warning! catch the div-by-zero!!!

						if (dt>1.1) {
							dt=1;					
						}

						nanoCenter[0]+=-velocity1[0]*dt;
						nanoCenter[1]+=-velocity1[1]*dt;
						nanoCenter[2]+=-velocity1[2]*dt;
						toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);

						SimpleVector v1=new SimpleVector(toRelocate.getVelocityComponent());
						SimpleVector d=domain.getDirectionP();
						double dModule=Math.sqrt(d.x*d.x+d.y*d.y+d.z*d.z);
						float[] dVersorComponent=new float[3];
						dVersorComponent[0]=(float) (d.x/dModule);
						dVersorComponent[1]=(float) (d.y/dModule);
						dVersorComponent[2]=(float) (d.z/dModule);

						SimpleVector dVersor=new SimpleVector(dVersorComponent);

						domainCenter=domain.getAbsCenter();

						nanoCenter=toRelocate.getCenter();
						float x=nanoCenter[0]-domainCenter[0];
						float y=nanoCenter[1]-domainCenter[1];
						float z=nanoCenter[2]-domainCenter[2];

						float relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);

						SimpleVector nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);
						SimpleVector oTempVersor=nanoCenterVersor.calcCross(dVersor);

						if(oTempVersor.length()!=0){
							oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());

						}else{
							oTempVersor=new SimpleVector(0,0,0);
						}

						SimpleVector nTempVersor=oTempVersor.calcCross(dVersor);

						float alfa=nTempVersor.calcAngle(v1);			
						double n1Module=toRelocate.getVelocityModule()*Math.cos(alfa);
						float[] n1components=new float[3];
						n1components[0]=(float) (n1Module*nTempVersor.x);
						n1components[1]=(float) (n1Module*nTempVersor.y);
						n1components[2]=(float) (n1Module*nTempVersor.z);				
						SimpleVector n1=new SimpleVector(n1components);

						float gamma=dVersor.calcAngle(v1);				
						double d1Module=toRelocate.getVelocityModule()*Math.cos(gamma);
						float[] d1components=new float[3];
						d1components[0]=(float) (d1Module*dVersor.x);
						d1components[1]=(float) (d1Module*dVersor.y);
						d1components[2]=(float) (d1Module*dVersor.z);				
						SimpleVector d1=new SimpleVector(d1components);

						float ro=oTempVersor.calcAngle(v1);				
						double o1Module=toRelocate.getVelocityModule()*Math.cos(ro);
						float[] o1components=new float[3];
						o1components[0]=(float) (o1Module*oTempVersor.x);
						o1components[1]=(float) (o1Module*oTempVersor.y);
						o1components[2]=(float) (o1Module*oTempVersor.z);				
						SimpleVector o1=new SimpleVector(o1components);

						n1.add(o1);
						SimpleVector v2=n1.calcSub(d1);

						float fi1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[0];
						float theta1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[1];
						float nextVelocityModule1=(float) Math.sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
						toRelocate.setVelocityComponent(nextVelocityModule1, fi1, theta1);	

						nanoCenter[0]+=v2.x*dt;
						nanoCenter[1]+=v2.y*dt;
						nanoCenter[2]+=v2.z*dt;
						toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);

					}else{
						SimpleVector velocityVector=new SimpleVector(velocity1);
						float angleV=velocityVector.calcAngle(domain.getDirectionP());

						float dsNV=(float) ((dsN)*Math.sin(angleV));					
						dt =(float) Math.abs((dsNV))/Math.abs(toRelocate.getVelocityModule()); 

						if (dt>1.1) {
							dt=1;					
						}

						nanoCenter[0]+=-velocity1[0]*dt;
						nanoCenter[1]+=-velocity1[1]*dt;
						nanoCenter[2]+=-velocity1[2]*dt;
						toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);

						SimpleVector v1=new SimpleVector(toRelocate.getVelocityComponent());
						SimpleVector d=domain.getDirectionP();
						double dModule=Math.sqrt(d.x*d.x+d.y*d.y+d.z*d.z);
						float[] dVersorComponent=new float[3];
						dVersorComponent[0]=(float) (d.x/dModule);
						dVersorComponent[1]=(float) (d.y/dModule);
						dVersorComponent[2]=(float) (d.z/dModule);

						SimpleVector dVersor=new SimpleVector(dVersorComponent);
						domainCenter=domain.getAbsCenter();
						nanoCenter=toRelocate.getCenter();

						float x=nanoCenter[0]-domainCenter[0];
						float y=nanoCenter[1]-domainCenter[1];
						float z=nanoCenter[2]-domainCenter[2];

						float relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);

						SimpleVector nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);

						SimpleVector oTempVersor=nanoCenterVersor.calcCross(dVersor);

						oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());

						SimpleVector nTempVersor=oTempVersor.calcCross(dVersor);

						float alfa=nTempVersor.calcAngle(v1);				

						double n1Module=toRelocate.getVelocityModule()*Math.cos(alfa);
						float[] n1components=new float[3];
						n1components[0]=(float) (n1Module*nTempVersor.x);
						n1components[1]=(float) (n1Module*nTempVersor.y);
						n1components[2]=(float) (n1Module*nTempVersor.z);				
						SimpleVector n1=new SimpleVector(n1components);

						float gamma=dVersor.calcAngle(v1);				
						double d1Module=toRelocate.getVelocityModule()*Math.cos(gamma);
						float[] d1components=new float[3];
						d1components[0]=(float) (d1Module*dVersor.x);
						d1components[1]=(float) (d1Module*dVersor.y);
						d1components[2]=(float) (d1Module*dVersor.z);				
						SimpleVector d1=new SimpleVector(d1components);

						float ro=oTempVersor.calcAngle(v1);				
						double o1Module=toRelocate.getVelocityModule()*Math.cos(ro);
						float[] o1components=new float[3];
						o1components[0]=(float) (o1Module*oTempVersor.x);
						o1components[1]=(float) (o1Module*oTempVersor.y);
						o1components[2]=(float) (o1Module*oTempVersor.z);				
						SimpleVector o1=new SimpleVector(o1components);

						d1.add(o1);
						SimpleVector v2=d1.calcSub(n1);	

						float fi1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[0];
						float theta1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[1];
						float nextVelocityModule1=(float) Math.sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
						toRelocate.setVelocityComponent(nextVelocityModule1, fi1, theta1);	

						nanoCenter[0]+=v2.x*dt;
						nanoCenter[1]+=v2.y*dt;
						nanoCenter[2]+=v2.z*dt;
						toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);
					}				
				} 				
			}				
		}
	}

	@Override
	public void checkExternalCollisionBound(AbstractDomain domainToCheck, NanoObj objToCheck) {

		if(isCollidingFromOutside(domainToCheck, objToCheck)){			

			CylindricDomain domain=(CylindricDomain)domainToCheck;
			float[] distanceOnAxis=getDistanceOnAxis(domainToCheck,objToCheck);
			float distanceP=distanceOnAxis[0]-objToCheck.getRadius();
			//float distanceN=distanceOnAxis[1]-objToCheck.getRadius();
			float distanceN= (float) ((Math.sqrt(distanceOnAxis[1]*distanceOnAxis[1]+distanceOnAxis[2]*distanceOnAxis[2]))-objToCheck.getRadius());	
			
			float[] velocity1=objToCheck.getVelocityComponent();

			// the collision should have occurred at t-dt (Actually this is also an approximation).
			float dt=1;
			try {	

				double dsP=((Math.abs(distanceP)-(domain.getHeight()/2)));
				double dsN=((Math.abs(distanceN)-(domain.getRadius())));			

				if (dsP>=dsN){				
					SimpleVector velocityVector=new SimpleVector(velocity1);
					float angleV=velocityVector.calcAngle(domain.getDirectionP());
					float dsPV=(float) ((dsP)*Math.cos(angleV));
					dt =(float) Math.abs((dsPV))/Math.abs(objToCheck.getVelocityModule()); // Warning! catch the div-by-zero!!!

				}else{
					SimpleVector velocityVector=new SimpleVector(velocity1);
					float angleV=velocityVector.calcAngle(domain.getDirectionP());
					float dsNV=(float) ((dsN)*Math.sin(angleV));
					dt =(float) Math.abs((dsNV))/Math.abs(objToCheck.getVelocityModule()); 
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());	
			}
			domain.addToCollisionsListExternal(domain,objToCheck,dt);			
		} 
	}

	public double getInternalCollisionTime(NanoObj collisionObj, AbstractDomain d){

		CylindricDomain domain=(CylindricDomain) d;
		float dt=0;	
		float[] domainCenter=domain.getAbsCenter();			

		float x=collisionObj.getCenter()[0]-domainCenter[0];
		float y=collisionObj.getCenter()[1]-domainCenter[1];
		float z=collisionObj.getCenter()[2]-domainCenter[2];

		SimpleVector nanoObjRelativeCenter=new SimpleVector(x,y,z);
		double angleP=getAngle(domain.getDirectionP(),nanoObjRelativeCenter);
		double distanceP= (collisionObj.getAbsDistancePlusRadius()*Math.cos(angleP));
		double angleN=(Math.PI/2)-angleP;
		double distanceN= (collisionObj.getAbsDistancePlusRadius()*Math.cos(angleN));


		if ((Math.abs(distanceP))>=domain.getHeight()/2){	
			// the collision should have occurred at t-dt (Actually this is also an approximation).
			dt=1;
			try {							
				// FIXME Computes the collision along the parallel direction.
				// Computes the penetration distance (ds) along this direction.
				// Relocate the ds along the direction of collision and divide for the velocity in order to get the time spent for the penetration...

				double ds=(Math.abs(distanceP)-(domain.getHeight()/2));
				dt =(float) Math.abs((ds/Math.cos(angleP)))/Math.abs(collisionObj.getVelocityModule()); // Warning! catch the div-by-zero!!!

			} catch (Exception e) {
				System.out.println(e.getMessage());	
			}
			domain.addToCollisionsListInternal(collisionObj.getDomain(),collisionObj,dt);							

		}else if(Math.abs(distanceN)>=domain.getRadius()){

			// the collision should have occurred at t-dt (Actually this is also an approximation).
			dt=1;
			try {							
				// FIXME Computes the collision along the parallel direction.
				// Computes the penetration distance (ds) along this direction.
				// Relocate the ds along the direction of collision and divide for the velocity in order to get the time spent for the penetration...

				double ds=(Math.abs(distanceN)-(domain.getRadius()));
				dt =(float) Math.abs((ds/Math.cos(angleN)))/Math.abs(collisionObj.getVelocityModule()); // Warning! catch the div-by-zero!!!

			} catch (Exception e) {
				System.out.println(e.getMessage());	
			}
		}
		return (double)dt;
	}

	public double getExternalCollisionTime(NanoObj collisionObj, AbstractDomain d){

		CylindricDomain domain=(CylindricDomain) d;
		float[] velocity1=collisionObj.getVelocityComponent();
		float modVelocity1=collisionObj.getVelocityModule();

		double dt=0;	

		if (modVelocity1==0){

		} else{

			float[] domainCenter=domain.getAbsCenter();			

			float xx=collisionObj.getCenter()[0]-domainCenter[0];
			float yy=collisionObj.getCenter()[1]-domainCenter[1];
			float zz=collisionObj.getCenter()[2]-domainCenter[2];

			SimpleVector nanoObjRelativeCenter=new SimpleVector(xx,yy,zz);
			double nanoObjRelativeModule=Math.sqrt(xx*xx+yy*yy+zz*zz);

			double angleP=getAngle(domain.getDirectionP(),nanoObjRelativeCenter);	
			double distanceP= ((nanoObjRelativeModule-collisionObj.getRadius())*Math.cos(angleP));

			double angleN=(Math.PI/2)-angleP;				
			double distanceN= ((nanoObjRelativeModule-collisionObj.getRadius())*Math.cos(angleN));				

			if (((Math.abs(distanceP))<=domain.getHeight()/2) && (Math.abs(distanceN)<=domain.getRadius())){	

				double dsP=(Math.abs(distanceP)-(domain.getHeight()/2));
				double dsN=(Math.abs(distanceN)-(domain.getRadius()));

				if (dsP>=dsN){
					SimpleVector velocityVector=new SimpleVector(velocity1);
					float angleV=velocityVector.calcAngle(domain.getDirectionP());

					float dsPV=(float) ((dsP)*Math.cos(angleV));

					dt =(float) Math.abs((dsPV))/Math.abs(collisionObj.getVelocityModule()); // Warning! catch the div-by-zero!!!

					if (dt>1.1) {
						dt=1;					
					}

				}else{
					SimpleVector velocityVector=new SimpleVector(velocity1);
					float angleV=velocityVector.calcAngle(domain.getDirectionP());

					float dsNV=(float) ((dsN)*Math.sin(angleV));

					dt =(float) Math.abs((dsNV))/Math.abs(collisionObj.getVelocityModule()); 

					if (dt>1.1) {
						dt=1;					
					}			
				}				
			} // END IF			
		}	
		return dt;
	}

	@Override
	public boolean isAnInternalCollisionBound(NanoObj n) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isCollidingFromOutside(AbstractDomain domainToCheck, NanoObj objToCheck){
		CylindricDomain domain=(CylindricDomain)domainToCheck;
		float[] distancesOnAxis=getDistanceOnAxis(domainToCheck,objToCheck);

		boolean result=false;

		float dP=distancesOnAxis[0]-objToCheck.getRadius();
		//float dN=distancesOnAxis[1]-objToCheck.getRadius();
		float dN= (float) ((Math.sqrt(distancesOnAxis[1]*distancesOnAxis[1]+distancesOnAxis[2]*distancesOnAxis[2]))-objToCheck.getRadius());	
		
		if(dP<=domain.getHeight()/2 && dN<=domain.getRadius()){
			float x0=domain.getHeight()/2-objToCheck.getRadius();
			float y0=domain.getRadius()-objToCheck.getRadius();

			float alfa1=(float) Math.atan((domain.getHeight()/2)/y0);
			float alfa2=(float) ((Math.PI/2) - Math.atan((domain.getRadius())/x0));

			SimpleVector nanoObjRelativeCenter=getRelativeCenter(domain, objToCheck);

			SimpleVector d=domain.getDirectionP();

			double angleP=getAngle(d,nanoObjRelativeCenter);		

			if(angleP>alfa2 && angleP<alfa1){
				float circle=(dP-x0)*(dP-x0)+(dN-y0)*(dN-y0);
				if(circle<objToCheck.getRadius()*objToCheck.getRadius()){
					result=true;
				}	
			} else result=true;						
		}
		return result;
	}

	// 17/03/2014   -    _OLD_BEFORE_CODE_CLEANING
	public void relocateInnerObjsForBloodVessels_OLD_BEFORE_CLEANING(NanoObj toRelocate, AbstractDomain domain) {

		if(toRelocate.getDomain()==domain){			

			CylindricDomain owner=(CylindricDomain)domain;

			float[] center1=toRelocate.getCenter();	
			float[] center2=owner.getAbsCenter();	
			float[] velocity1=toRelocate.getVelocityComponent();
			float modVelocity1=toRelocate.getVelocityModule();
			float modVelocity2=0;
			double dt=0;			


			if (modVelocity1==0 && modVelocity2==0){

			} else{

				// COLLISION WITH THE EDGE OF THE DOMAIN!
				
				domainCollision++;				
				
				float[] distances=getDistanceOnAxis(domain,toRelocate);			
				float[] domainCenter=domain.getAbsCenter();				
				float distanceP= Math.abs(distances[0]+toRelocate.getRadius());
				float distanceN= Math.abs(distances[1]+toRelocate.getRadius());	

				//double distanceN= Math.sqrt(distances[1]*distances[1]+distances[2]*distances[2])+toRelocate.getRadius();


				float dx21 = (center2[0]-center1[0]);
				float dy21 = (center2[1]-center1[1]);
				float dz21 = (center2[2]-center1[2]);		

				SimpleVector nanoObjRelativeCenter=new SimpleVector(dx21,dy21,dz21);


				double angleP=getAngle(domain.getDirectionP(),nanoObjRelativeCenter);

				// FIXME Trying to use directionN
				double angleN=(Math.PI/2)-angleP;			
				//double angleN=getAngle(domain.getDirectionN(),nanoObjRelativeCenter);		
				/*
				SimpleVector vectorN=new SimpleVector(domain.getDirectionN());
				vectorN.add(domain.getDirectionO());
				vectorN.scalarMul((float) distanceN);

				double angleN=getAngle(vectorN,nanoObjRelativeCenter);
				// END of new strategy for distanceN
				*/


				float[] nanoCenter=toRelocate.getCenter();	


				if ((Math.abs(distanceP))>=owner.getHeight()/2){		
					toRelocate.kill();
					//System.out.println(distanceP);

					((CylindricBloodVesselDomain) domain).destroyedCell++;

				}else if ((Math.abs(distanceN))>=owner.getRadius()){		

					/** =======================
					 *  GET the AXIS d, n and o! 
					 * ========================= */
					SimpleVector v1=new SimpleVector(toRelocate.getVelocityComponent());
					SimpleVector dVersor=domain.getDirectionP();

					float x=nanoCenter[0]-domainCenter[0];
					float y=nanoCenter[1]-domainCenter[1];
					float z=nanoCenter[2]-domainCenter[2];

					float relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);
					SimpleVector nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);
					SimpleVector oTempVersor=nanoCenterVersor.calcCross(dVersor);
					oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());

					// The N versor points towards inside of domain, such as towards its center (over the secant plane and the d versor)
					SimpleVector nTempVersor=oTempVersor.calcCross(dVersor);

					double ds=(distanceN-(owner.getRadius()));	
					velocity1=toRelocate.getVelocityComponent();					

					dt =(float) Math.abs((ds/Math.cos(angleN)))/Math.abs(toRelocate.getVelocityModule()); // Warning! catch the div-by-zero!!!

					if (dt>1.1) {
						dt=1;						
					}

					center1=toRelocate.getCenter();	
					center1[0]+=-velocity1[0]*dt;
					center1[1]+=-velocity1[1]*dt;
					center1[2]+=-velocity1[2]*dt;
					toRelocate.setCenter(center1[0], center1[1], center1[2]);

					
					nanoCenter=toRelocate.getCenter();

					x=nanoCenter[0]-domainCenter[0];
					y=nanoCenter[1]-domainCenter[1];
					z=nanoCenter[2]-domainCenter[2];

					relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);
					nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);
					oTempVersor=nanoCenterVersor.calcCross(dVersor);
					oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());

					// The N versor points towards inside of domain, such as towards its center (over the secant plane and the d versor)
					nTempVersor=oTempVersor.calcCross(dVersor);

					float alfa=nTempVersor.calcAngle(v1);		
					double n1Module=Math.abs(toRelocate.getVelocityModule()*Math.cos(alfa));  

					float[] n1components=new float[3];
					n1components[0]=(float) (n1Module*nTempVersor.x);	
					n1components[1]=(float) (n1Module*nTempVersor.y);
					n1components[2]=(float) (n1Module*nTempVersor.z);				
					SimpleVector n1=new SimpleVector(n1components);
					SimpleVector dsNN=new SimpleVector(nTempVersor);

					float angleN1=nanoCenterVersor.calcAngle(n1);
					float ds_On_N1_Module=(float) (ds*Math.cos(angleN1));
					dsNN.scalarMul(Math.abs(ds_On_N1_Module));		

					float gamma=dVersor.calcAngle(v1);	
					double d1Module=toRelocate.getVelocityModule()*Math.cos(gamma);
					float[] d1components=new float[3];
					d1components[0]=(float) (d1Module*dVersor.x);
					d1components[1]=(float) (d1Module*dVersor.y);
					d1components[2]=(float) (d1Module*dVersor.z);				
					SimpleVector d1=new SimpleVector(d1components);

					float ro=oTempVersor.calcAngle(v1);				
					double o1Module=toRelocate.getVelocityModule()*Math.cos(ro);
					float[] o1components=new float[3];
					o1components[0]=(float) (o1Module*oTempVersor.x);
					o1components[1]=(float) (o1Module*oTempVersor.y);
					o1components[2]=(float) (o1Module*oTempVersor.z);				
					SimpleVector o1=new SimpleVector(o1components);

					n1.scalarMul(inelasticCoefficient);
					d1.add(o1);

					SimpleVector v2=new SimpleVector(d1);
					v2.scalarMul(inelasticCoefficientLongit);		// FIXME NEW feature. 25/11/2013

					v2.add(n1);	

					float fi1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[0];
					float theta1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[1];
					float nextVelocityModule1=(float) Math.sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
					toRelocate.setVelocityComponent(nextVelocityModule1, fi1, theta1);	

					velocity1=toRelocate.getVelocityComponent();

					center1[0]+=velocity1[0]*dt;
					center1[1]+=velocity1[1]*dt;
					center1[2]+=velocity1[2]*dt;
					toRelocate.setCenter(center1[0], center1[1], center1[2]);

				
					x=center1[0]-domainCenter[0];
					y=center1[1]-domainCenter[1];
					z=center1[2]-domainCenter[2];

					relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);
					nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);
					oTempVersor=nanoCenterVersor.calcCross(dVersor);
					oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());

					// The N versor points towards inside of domain, such as towards its center (over the secant plane and the d versor)
					nTempVersor=oTempVersor.calcCross(dVersor);

					// Avoids that the nano-object crosses the edge						
					float[] distances2=getDistanceOnAxis(domain,toRelocate);					
					float dN= Math.abs(distances2[1]+toRelocate.getRadius());						
					ds=dN-owner.getRadius();					

					SimpleVector correction=new SimpleVector(nTempVersor);					



					if(ds>0){		
						// N	

						correction.scalarMul((float) Math.abs((ds)));		

						float x1=(float) (correction.x);
						float y1=(float) (correction.y);
						float z1=(float) (correction.z);

						center1[0]=center1[0]+x1;
						center1[1]=center1[1]+y1;
						center1[2]=center1[2]+z1;
						toRelocate.setCenter(center1[0], center1[1], center1[2]);	

					}else{
						correction.scalarMul(0);
					}

					// Checks that the nano objects is still inside this domain
					distances=getDistanceOnAxis(domain,toRelocate);		
					distanceP= Math.abs(distances[0]+toRelocate.getRadius());
					distanceN= Math.abs(distances[1]+toRelocate.getRadius());	

					if (distanceP-2*toRelocate.getRadius()>owner.getHeight()/2 || distanceN-2*toRelocate.getRadius()>owner.getRadius()){
						toRelocate.setColor(Color.green);
						System.out.println("N - The relocateInner has not compute very well the new position of the nano objects!!!  Obj: "+toRelocate.name+",  x: "+toRelocate.getCenter()[0]+", y: "+toRelocate.getCenter()[1]+", z: "+toRelocate.getCenter()[2]+"  -  "+distanceP+"  -  "+distanceN+"  -  V: "+toRelocate.getVelocityModule());
					}	
				}
			}
		}
	}	

	// 17/03/2014
	public void relocateInnerObjsForBloodVessels(NanoObj toRelocate, AbstractDomain domain) {		

		if(toRelocate.getDomain()==domain){			

			CylindricDomain owner=(CylindricDomain)domain;

			float[] nanoCenter=toRelocate.getCenter();	
			float[] domainCenter=owner.getAbsCenter();	
			float[] velocity1=toRelocate.getVelocityComponent();
			float modVelocity1=toRelocate.getVelocityModule();
			//float modVelocity2=0;
			double dt=0;			


			if (modVelocity1==0 ){

			} else{

				domainCollision++;
				
				float[] distances=getDistanceOnAxis(owner,toRelocate);			
				//float[] domainCenter=domain.getAbsCenter();				
				float distanceP= Math.abs(distances[0]+toRelocate.getRadius());
				//float distanceN= Math.abs(distances[1]+toRelocate.getRadius());	
				float distanceN= (float) ((Math.sqrt(distances[1]*distances[1]+distances[2]*distances[2]))+toRelocate.getRadius());	

				/*
				float dx21 = -(domainCenter[0]-nanoCenter[0]);
				float dy21 = -(domainCenter[1]-nanoCenter[1]);
				float dz21 = -(domainCenter[2]-nanoCenter[2]);	
				*/
				
				//double angleP=getAngle(owner.getDirectionP(),nanoObjRelativeCenter);


				if ((Math.abs(distanceP))>=owner.getHeight()/2){		
					toRelocate.kill();
					
					((CylindricBloodVesselDomain) domain).destroyedCell++;

				}else if ((Math.abs(distanceN))>=owner.getRadius()){		

					/** =======================
					 *  GET the AXIS d, n and o! 
					 * ========================= */
					SimpleVector v1=new SimpleVector(toRelocate.getVelocityComponent());
					SimpleVector dVersor=owner.getDirectionP();

					float x=nanoCenter[0]-domainCenter[0];
					float y=nanoCenter[1]-domainCenter[1];
					float z=nanoCenter[2]-domainCenter[2];
					
					SimpleVector nanoObjRelativeCenter=new SimpleVector(x,y,z);
					
					SimpleVector nanoCenterVersor=nanoObjRelativeCenter.normalize();

					double ds=(distanceN-(owner.getRadius()));	
					
					
					// FIXME Tring to use directionN...
					//double angleN=(Math.PI/2)-angleP;
					
					SimpleVector vectorN=new SimpleVector(domain.getDirectionN());
					vectorN.scalarMul(distances[1]);

					SimpleVector vectorO=new SimpleVector(domain.getDirectionO());
					vectorO.scalarMul(distances[2]);

					vectorN.add(vectorO);
					// END of new strategy for distanceN
					
					
					double angleN=getAngle(vectorN,nanoObjRelativeCenter);

					dt =(float) Math.abs((ds/Math.cos(angleN)))/Math.abs(toRelocate.getVelocityModule()); // Warning! catch the div-by-zero!!!

					if (dt>1.1) {
						dt=1;						
					}

					//center1=toRelocate.getCenter();	
					nanoCenter[0]+=-velocity1[0]*dt;
					nanoCenter[1]+=-velocity1[1]*dt;
					nanoCenter[2]+=-velocity1[2]*dt;
					toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);

					//nanoCenter=toRelocate.getCenter();
					x=nanoCenter[0]-domainCenter[0];
					y=nanoCenter[1]-domainCenter[1];
					z=nanoCenter[2]-domainCenter[2];

					/*
					relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);
					nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);
					*/
					nanoCenterVersor=new SimpleVector(x,y,z);
					nanoCenterVersor=nanoCenterVersor.normalize();

					SimpleVector oTempVersor=nanoCenterVersor.calcCross(dVersor);
					//oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());

					//SimpleVector oTempVersor=new SimpleVector(vectorN);
					oTempVersor=oTempVersor.normalize();				


					// The N versor points towards inside of domain, such as towards its center (over the secant plane and the d versor)
					SimpleVector nTempVersor=oTempVersor.calcCross(dVersor);
					nTempVersor=nTempVersor.normalize();


					float alfa=nTempVersor.calcAngle(v1);
					double n1Module=Math.abs(toRelocate.getVelocityModule()*Math.cos(alfa));  

					float[] n1components=new float[3];
					n1components[0]=(float) (n1Module*nTempVersor.x);	
					n1components[1]=(float) (n1Module*nTempVersor.y);
					n1components[2]=(float) (n1Module*nTempVersor.z);				
					SimpleVector n1=new SimpleVector(n1components);
					SimpleVector dsNN=new SimpleVector(nTempVersor);

					float angleN1=nanoCenterVersor.calcAngle(n1);
					float ds_On_N1_Module=(float) (ds*Math.cos(angleN1));
					dsNN.scalarMul(Math.abs(ds_On_N1_Module));		

					float gamma=dVersor.calcAngle(v1);	
					double d1Module=toRelocate.getVelocityModule()*Math.cos(gamma);
					float[] d1components=new float[3];
					d1components[0]=(float) (d1Module*dVersor.x);
					d1components[1]=(float) (d1Module*dVersor.y);
					d1components[2]=(float) (d1Module*dVersor.z);				
					SimpleVector d1=new SimpleVector(d1components);

					float ro=oTempVersor.calcAngle(v1);				
					double o1Module=toRelocate.getVelocityModule()*Math.cos(ro);
					float[] o1components=new float[3];
					o1components[0]=(float) (o1Module*oTempVersor.x);
					o1components[1]=(float) (o1Module*oTempVersor.y);
					o1components[2]=(float) (o1Module*oTempVersor.z);				
					SimpleVector o1=new SimpleVector(o1components);

					n1.scalarMul(inelasticCoefficient);
					d1.add(o1);

					SimpleVector v2=new SimpleVector(d1);
					v2.scalarMul(inelasticCoefficientLongit);		// FIXME NEW feature. 25/11/2013

					v2.add(n1);	

					float fi1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[0];
					float theta1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[1];
					float nextVelocityModule1=(float) Math.sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
					toRelocate.setVelocityComponent(nextVelocityModule1, fi1, theta1);	

					velocity1=toRelocate.getVelocityComponent();

					nanoCenter[0]+=velocity1[0]*dt;
					nanoCenter[1]+=velocity1[1]*dt;
					nanoCenter[2]+=velocity1[2]*dt;
					toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);


					x=nanoCenter[0]-domainCenter[0];
					y=nanoCenter[1]-domainCenter[1];
					z=nanoCenter[2]-domainCenter[2];

					//relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);
					//nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);

					nanoCenterVersor=new SimpleVector(x,y,z);
					nanoCenterVersor=nanoCenterVersor.normalize();


					oTempVersor=nanoCenterVersor.calcCross(dVersor);
					//oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());
					oTempVersor=oTempVersor.normalize();


					// The N versor points towards inside of domain, such as towards its center (over the secant plane and the d versor)
					nTempVersor=oTempVersor.calcCross(dVersor);
					nTempVersor=nTempVersor.normalize();

					// Avoids that the nano-object crosses the edge						
					float[] distances2=getDistanceOnAxis(owner,toRelocate);					
					//float dN= Math.abs(distances2[1]+toRelocate.getRadius());		
					float dN= (float) ((Math.sqrt(distances2[1]*distances2[1]+distances2[2]*distances2[2]))+toRelocate.getRadius());	

					ds=dN-owner.getRadius();					

					//SimpleVector correction=new SimpleVector(nTempVersor);


					if(ds>0){		
						// N	
						
						SimpleVector correction=new SimpleVector(nTempVersor);	
						
						correction.scalarMul((float) Math.abs((ds)));		

						float x1=(float) (correction.x);
						float y1=(float) (correction.y);
						float z1=(float) (correction.z);

						nanoCenter[0]=nanoCenter[0]+x1;
						nanoCenter[1]=nanoCenter[1]+y1;
						nanoCenter[2]=nanoCenter[2]+z1;
						toRelocate.setCenter(nanoCenter[0], nanoCenter[1], nanoCenter[2]);		

					}/* else{
						correction.scalarMul(0);
					}*/

					// Checks that the nano objects is still inside this domain
					distances=getDistanceOnAxis(owner,toRelocate);		
					distanceP= Math.abs(distances[0]+toRelocate.getRadius());
					//distanceN= Math.abs(distances[1]+toRelocate.getRadius());
					distanceN= (float) ((Math.sqrt(distances[1]*distances[1]+distances[2]*distances[2]))+toRelocate.getRadius());

					if (distanceP-2*toRelocate.getRadius()>owner.getHeight()/2 || distanceN-2*toRelocate.getRadius()>owner.getRadius()){
						toRelocate.setColor(Color.green);
						System.out.println("N - The relocateInner has not compute very well the new position of the nano objects!!!  Obj: "+toRelocate.name+",  x: "+toRelocate.getCenter()[0]+", y: "+toRelocate.getCenter()[1]+", z: "+toRelocate.getCenter()[2]+"  -  "+distanceP+"  -  "+distanceN+"  -  V: "+toRelocate.getVelocityModule());
					}	
				}
			}
		}		
	}	

	@Deprecated
	public void relocateInnerObjsForBloodVessels_NO_INELASTIC(NanoObj toRelocate, AbstractDomain domain) {
		if(toRelocate.getDomain()==domain){			

			CylindricDomain owner=(CylindricDomain)domain;
			float[] center1=toRelocate.getCenter();			
			float[] velocity1=toRelocate.getVelocityComponent();
			float modVelocity1=toRelocate.getVelocityModule();
			float modVelocity2=0;
			double dt=0;			

			if (modVelocity1==0 && modVelocity2==0){

			} else{

				float[] distances=getDistanceOnAxis(domain,toRelocate);				

				float[] domainCenter=domain.getAbsCenter();				

				float[] nanoCenter=toRelocate.getCenter();	

				float distanceP= distances[0]+toRelocate.getRadius();

				float distanceN= distances[1]+toRelocate.getRadius();	

				if ((Math.abs(distanceP))>=owner.getHeight()/2){		
					toRelocate.kill();

				}else if ((Math.abs(distanceN))>=owner.getRadius()){		

					double ds=(Math.abs(distanceN)-(owner.getRadius()));						
					SimpleVector vNano=new SimpleVector(toRelocate.getVelocityComponent());
					double newAngle=(Math.PI/2)-vNano.calcAngle(domain.getDirectionP());
					dt =(float) Math.abs((ds/Math.cos(newAngle)))/Math.abs(toRelocate.getVelocityModule()); // Warning! catch the div-by-zero!!!

					center1[0]+=-velocity1[0]*dt;
					center1[1]+=-velocity1[1]*dt;
					center1[2]+=-velocity1[2]*dt;
					toRelocate.setCenter(center1[0], center1[1], center1[2]);

					if (dt>1.1) {
						dt=1;	
					}

					SimpleVector v1=new SimpleVector(toRelocate.getVelocityComponent());
					SimpleVector d=domain.getDirectionP();
					double dModule=Math.sqrt(d.x*d.x+d.y*d.y+d.z*d.z);
					float[] dVersorComponent=new float[3];
					dVersorComponent[0]=(float) (d.x/dModule);
					dVersorComponent[1]=(float) (d.y/dModule);
					dVersorComponent[2]=(float) (d.z/dModule);

					SimpleVector dVersor=new SimpleVector(dVersorComponent);	
					float x=nanoCenter[0]-domainCenter[0];
					float y=nanoCenter[1]-domainCenter[1];
					float z=nanoCenter[2]-domainCenter[2];

					float relativeCenterModule=(float) Math.sqrt(x*x+y*y+z*z);

					SimpleVector nanoCenterVersor=new SimpleVector(x/relativeCenterModule,y/relativeCenterModule,z/relativeCenterModule);

					SimpleVector oTempVersor=nanoCenterVersor.calcCross(dVersor);

					oTempVersor=new SimpleVector(oTempVersor.x/oTempVersor.length(),oTempVersor.y/oTempVersor.length(),oTempVersor.z/oTempVersor.length());

					SimpleVector nTempVersor=oTempVersor.calcCross(dVersor);

					float alfa=nTempVersor.calcAngle(v1);	
					double n1Module=toRelocate.getVelocityModule()*Math.cos(alfa);
					float[] n1components=new float[3];
					n1components[0]=(float) (n1Module*nTempVersor.x);
					n1components[1]=(float) (n1Module*nTempVersor.y);
					n1components[2]=(float) (n1Module*nTempVersor.z);				
					SimpleVector n1=new SimpleVector(n1components);

					float gamma=dVersor.calcAngle(v1);				
					double d1Module=toRelocate.getVelocityModule()*Math.cos(gamma);
					float[] d1components=new float[3];
					d1components[0]=(float) (d1Module*dVersor.x);
					d1components[1]=(float) (d1Module*dVersor.y);
					d1components[2]=(float) (d1Module*dVersor.z);				
					SimpleVector d1=new SimpleVector(d1components);

					float ro=oTempVersor.calcAngle(v1);				
					double o1Module=toRelocate.getVelocityModule()*Math.cos(ro);
					float[] o1components=new float[3];
					o1components[0]=(float) (o1Module*oTempVersor.x);
					o1components[1]=(float) (o1Module*oTempVersor.y);
					o1components[2]=(float) (o1Module*oTempVersor.z);				
					SimpleVector o1=new SimpleVector(o1components);

					d1.add(o1);
					SimpleVector v2=d1.calcSub(n1);	

					float fi1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[0];
					float theta1=toRelocate.getVelocityAngles(v2.x,v2.y, v2.z)[1];
					float nextVelocityModule1=(float) Math.sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
					toRelocate.setVelocityComponent(nextVelocityModule1, fi1, theta1);	

					center1[0]+=v2.x*dt;
					center1[1]+=v2.y*dt;
					center1[2]+=v2.z*dt;
					toRelocate.setCenter(center1[0], center1[1], center1[2]);

					// Checks that the nano objects is still inside this domain
					distances=getDistanceOnAxis(domain,toRelocate);		
					distanceP= Math.abs(distances[0]+toRelocate.getRadius());
					distanceN= Math.abs(distances[1]+toRelocate.getRadius());	

					if (distanceP-2*toRelocate.getRadius()>owner.getHeight()/2 || distanceN-2*toRelocate.getRadius()>owner.getRadius()){
						toRelocate.setColor(Color.green);
						System.out.println("N - The relocateInner has not compute very well the new position of the nano objects!!! "+distanceP+"  -  "+distanceN+"  -  V: "+toRelocate.getVelocityModule());
					}	
				}
			}	
		}
	}		
}
