package simulator;

import java.util.ArrayList;
import java.util.List;
import MainLibrary.MobilityModel;
import MainLibrary.NanoObj;


public class DiffusionModelMoveOLDThread extends Thread{
	
	protected List<NanoObj> partialNanoObjList=new ArrayList<NanoObj>();
	protected MobilityModel model;
	protected int size=0;
	
	public DiffusionModelMoveOLDThread(List<NanoObj> nanoList){
		partialNanoObjList=nanoList;				
		model=partialNanoObjList.get(0).getDomain().getMobilityModel();
		size=partialNanoObjList.size();
		setDaemon(true);
	}
		
	public void run(){		
		NanoObj p=null;		
		for (int i=0;i<size;i++){			
			try {
				if(size!=partialNanoObjList.size()) {
					System.out.println("========================");
					System.out.println("DiffusionModelMoveOLDThread -> partialNanoList.size is changed!!! from: "+size+" to: "+partialNanoObjList.size());
					System.out.println("========================");
					System.exit(0);
				}else{
					p=partialNanoObjList.get(i);
					if(p!=null) {
						p.getMotionStrategy().move(p);
					}
				}
			} catch (Exception e) {
				System.out.println("--Error on DiffusionModelMoveOLDThread.run() - SIZE: "+size+" - p.size(): "+partialNanoObjList.size());
				e.printStackTrace();							
			}
		}
	}	
}
