package simulator;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import MainLibrary.NanoObj;


public class DiffusionModelMoveThread implements Runnable{

	protected List<NanoObj> partialNanoObjList=new ArrayList<NanoObj>();	
	protected int size=0;
	public CountDownLatch latch;
	
	public DiffusionModelMoveThread(List<NanoObj> nanoList, CountDownLatch latch){		
		partialNanoObjList=nanoList;			
		size=partialNanoObjList.size();
		this.latch=latch;
	}

	public void run(){
		NanoObj p=null;		
		for (int i=0;i<size;i++){			
			try {
				if(size!=partialNanoObjList.size()) {
					System.out.println("========================");
					System.out.println("DiffusionModelMoveThread -> partialNanoList.size is changed!!! from: "+size+" to: "+partialNanoObjList.size());
					System.out.println("========================");
					System.exit(0);
				}else{
					p=partialNanoObjList.get(i);
					if(p!=null) {
						p.getMotionStrategy().move(p);		
						
					}
				}
			} catch (Exception e) {
				System.out.println("--Error on DiffusionModelMoveThread.run() - SIZE: "+size+" - p.size(): "+partialNanoObjList.size()+"  -  p: "+p.getTypeNanoObj());
				e.printStackTrace();
				System.exit(0);				
			}
		}
		this.latch.countDown();
	}		
}
