package simulator;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import simulator.CD40LObserver;
import simulator.CubicDomain;
import simulator.CubicStrategy;
import simulator.CylindricDomain;
import simulator.CylindricStrategy;
import simulator.DiffusionModel;
import simulator.Platelet;

import MainLibrary.AbstractDomain;
import MainLibrary.AbstractThreadingStrategy;
import MainLibrary.LigandObserver;
import MainLibrary.MobilityModel;
import MainLibrary.NanoObj;



/** This class has to be used exclusively for the creation of the "database schema" 
 * and to avoid db4o bugs regarding the management of lists and arrays in client/server mode. 
 * The only thing that this Model class has to do is to create an object for each type within the "network creation" method and nothing else...
 */

public class MobilityModelForDbCreation extends MobilityModel {
	/* (non-Javadoc)
	 * @see MainLibrary.MobilityModel#algorithm(MainLibrary.AbstractDomain)
	 */

	@Override
	public void algorithm(AbstractDomain domain) {
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see MainLibrary.MobilityModel#networkCreation()
	 */
	@Override
	public void networkCreation() {

		System.out.println("-----------------------------------");
		System.out.println("Auto-Create Network... [DATABASE INITIALIZATION]");
		System.out.println("-----------------------------------");

		List<LigandObserver> observer=new ArrayList<LigandObserver>();

		float height3=3000000;	
		float rad3=10000;	

		float[] cdCenter3=new float[3];
		cdCenter3[0]=100000;
		cdCenter3[1]=100000;
		cdCenter3[2]=100000;		

		CylindricStrategy cs=new CylindricStrategy(0);
		DiffusionModel mainFlow=new DiffusionModel(getManager().rootDomain);

		CylindricDomain mainCylinder=new CylindricDomain(getManager().rootDomain, mainFlow,cs, true, false, height3, rad3,cdCenter3, false);
		mainCylinder.ID="Cylindric";

		float[] cdCenter5=new float[3];	
		cdCenter5[0]=10000;
		cdCenter5[1]=1480000;
		cdCenter5[2]=0;		

		CubicStrategy cubeStrategy=new CubicStrategy(0);
		DiffusionModel cubeDiffusion=new DiffusionModel(getManager().rootDomain);

		CubicDomain cubetto=new CubicDomain(mainCylinder, cubeDiffusion, cubeStrategy, true, false, 1000, cdCenter5, false);
		cubetto.ID="CUBE";

		observer=new ArrayList<LigandObserver>();
		observer.add(CD40LObserver.getInstance());
		Platelet platelet1=new Platelet(mainCylinder,107500,1300000,100000,4,observer);
		platelet1.setColor(Color.darkGray);				
		if (platelet1.getTimeToLive()>0);
		System.out.println("[FIXED CREATION]");	
		platelet1.burstEmission=10;
		BrownianMotion m = BrownianMotion.getInstance();
		platelet1.setMotionStrategy(m);
	}

	/* (non-Javadoc)
	 * @see MainLibrary.MobilityModel#checkCollision(java.util.List)
	 */
	@Override
	public void checkCollision(List<NanoObj> objsToCheck) {

	}

	/* (non-Javadoc)
	 * @see MainLibrary.MobilityModel#detectCollision(MainLibrary.NanoObj, MainLibrary.NanoObj)
	 */
	@Override
	public void detectCollision(NanoObj n1, NanoObj n2) {
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see MainLibrary.MobilityModel#move(java.util.List)
	 */
	@Override
	public void move(List<NanoObj> nanoObjList) {
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see MainLibrary.MobilityModel#avoidCollision(MainLibrary.AbstractDomain)
	 */
	@Override
	public void avoidCollision(AbstractDomain domain) {
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see MainLibrary.MobilityModel#relocateObjs(MainLibrary.NanoObj, MainLibrary.NanoObj)
	 */
	@Override
	public void relocateObjs(NanoObj p1, NanoObj p2) {
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see MainLibrary.MobilityModel#getDiffusionCoefficient(MainLibrary.NanoObj)
	 */
	@Override
	public float getDiffusionCoefficient(NanoObj p) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see MainLibrary.MobilityModel#checkCoords(float, float, float)
	 */
	@Override
	public boolean checkCoords(float x, float y, float z) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public AbstractThreadingStrategy getThreadingStrategy() {
		// TODO Auto-generated method stub
		return null;
	}
}
