package simulator;

import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import MainLibrary.AbstractDomain;
import MainLibrary.ConfigWrapper;
import MainLibrary.Configurator2;
import MainLibrary.LigandObserver;
import MainLibrary.LivingObjObserver;
import MainLibrary.Manager;
import MainLibrary.NanoObj;
import MainLibrary.NodeObj;
import MainLibrary.Receptor;
import MainLibrary.UniversalReceptor;
import com.mysql.jdbc.Connection;
import com.mysql.jdbc.Statement;
import com.threed.jpct.SimpleVector;



public class MySQLBackup_BloodVessel {

	private static MySQLBackup_BloodVessel instance=null;
	private static boolean hasBackuppedNanoObj=false;
	private static boolean hasBackuppedDomain=false;
	private String address="localhost";
	private String port="3306";
	private String user="";
	private String password="";
	private String db="";
	private String url="";
	private String description="N/A";	
	private int storingFactor=1;
	public Manager manager=null;
	private static String simulationID=null;
	private Long ID_Wrapper=(long) -1;
	
	private String query="";
	private boolean initialized=false;
	
	
	// Data to store
	private ConfigWrapper configWrapper=null;
	private String mobilityModel="";
	private String outputStrategy="";
	private long lastTimestep=0;

	ArrayList<Integer> addedNode=new ArrayList<Integer>();	
	ArrayList<Integer> addedCarrier=new ArrayList<Integer>();
	ArrayList<Integer> addedGeneric=new ArrayList<Integer>();
	ArrayList<Integer> addedDomainStrategy=new ArrayList<Integer>();
	ArrayList<Integer> addedNodeState=new ArrayList<Integer>();
	ArrayList<Integer> addedReceptorState=new ArrayList<Integer>();

	List<NanoObj> disposedNanoObj=new ArrayList<NanoObj>();	
	List<NanoObj> undisposedNanoObj=new ArrayList<NanoObj>();	

	// Get from RESTORE processs
	public HashMap<String,LigandObserver> ligandObserver=new HashMap<String,LigandObserver>();	


	//public List<OutputWrapperResults> wrapperList = new ArrayList<OutputWrapperResults>();	


	public static MySQLBackup_BloodVessel getInstance(){
		if (instance==null) instance=new MySQLBackup_BloodVessel();		
		return instance;
	}

	private MySQLBackup_BloodVessel(){	
		simulationID=getSimulationID();
		address=Configurator2.readCustomStringConfigurations("config.xml", "Database", "address");		
		port=Configurator2.readCustomStringConfigurations("config.xml", "Database", "port");		
		user=Configurator2.readCustomStringConfigurations("config.xml", "Database", "user");		
		password=Configurator2.readCustomStringConfigurations("config.xml", "Database", "password");	
		db=Configurator2.readCustomStringConfigurations("config.xml", "Database", "db-backup");	
		description=Configurator2.readCustomStringConfigurations("config.xml", "System", "description");			

		// FIXME This address only for DEBUG in LOCAL PC
		address="localhost";	
		port="3307";
		user="root";		
		password="pippo";
		
		url="jdbc:mysql://"+address+":"+port+"/"+db;

		System.out.println("========================================");
		System.out.println("BACKUP DATABASE: "+url);					
		System.out.println("========================================");
	}	

	private Connection connect() {		
		Connection con=null;		
		try {				
			con = (Connection) DriverManager.getConnection(url, user, password);				
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return con;		
	}	

	public void initialize() {	
		
		// FIXME Only for DEBUG!		
		restore(1);		
		initialized=true;	// Disables the backup, because I want to debug the restore! 		
		// END DEBUG
		
		
		if(!initialized){
			Connection con=connect();
			try {	
				Statement stmt = (Statement) con.createStatement();
				String sql="";		
				//lastTimestep=manager.getCurrentTime();	

				// CONFIG_WRAPPER
				sql="('"+simulationID+"','"+description+"','"+mobilityModel+"','"+outputStrategy+"','"+lastTimestep+"','"+configWrapper.simulationTimeLength+"','"+configWrapper.exportTimeLength+"','"+configWrapper.threads+"','"+configWrapper.ddt+"','"+configWrapper._dt+"','"+configWrapper.timeUnit+"','"+configWrapper.T+"','"+configWrapper.viscosity+"','"+configWrapper.u+"','"+configWrapper.nodeTreeLimit+"','"+configWrapper.nodeSideLimit+"','"+configWrapper.printTimeOnScreen+"','"+configWrapper.camera[0]+"','"+configWrapper.camera[1]+"','"+configWrapper.camera[2]+"','"+configWrapper.lookAt.x+"','"+configWrapper.lookAt.y+"','"+configWrapper.lookAt.z+"','"+configWrapper.lights[0]+"','"+configWrapper.lights[1]+"','"+configWrapper.lights[2]+"','"+configWrapper.window[0]+"','"+configWrapper.window[1]+"') ";		
				String finalSQL="INSERT INTO nano_saved.config_wrapper ( name, description, mobility_model, output_strategy, last_timestep, simulationTimeLength, exportTimeLength, threads, ddt, _dt, timeUnit, T, viscosity, u, nodeTreeLimit, nodeSideLimit, printTimeOnScreen, camera_x, camera_y, camera_z, lookAt_x, lookAt_y, lookAt_z, lights_r, lights_g, lights_b, window_w, window_h) VALUES "+sql;
				stmt.executeUpdate(finalSQL);	

				String getID="SELECT ID FROM nano_saved.config_wrapper WHERE name='"+simulationID+"'";
				ResultSet ss=stmt.executeQuery(getID);	

				if(ss.next()) {
					ID_Wrapper=ss.getLong("ID");
				}

				// CONFIG_WRAPPER_NODE
				Map<String, Float> nodeConfig = configWrapper.nodeConfig;
				Iterator it=nodeConfig.keySet().iterator();			
				while(it.hasNext()){	
					String element = (String) it.next();
					String[] parsed=element.split("-",2);

					if(!(addedNode.contains(Integer.parseInt(parsed[0])))){

						int type=Integer.parseInt(parsed[0]);					
						float mass=nodeConfig.get(parsed[0]+"-mass");
						float radius=nodeConfig.get(parsed[0]+"-radius");
						long ttl=(long)((nodeConfig.get(parsed[0]+"-ttl")).floatValue());
						long receptor=(long)((nodeConfig.get(parsed[0]+"-receptor")).floatValue());
						int zoom3D=(int)((nodeConfig.get(parsed[0]+"-zoom3D")).floatValue());
						long burstEmission=(long)((nodeConfig.get(parsed[0]+"-burstEmission")).floatValue());
						int receptorType=(int)((nodeConfig.get(parsed[0]+"-receptorType")).floatValue());
						int stateType=(int)((nodeConfig.get(parsed[0]+"-stateType")).floatValue());

						addedNode.add(Integer.parseInt(parsed[0]));

						sql="('"+ID_Wrapper+"','"+type+"','"+mass+"','"+radius+"','"+ttl+"','"+receptor+"','"+zoom3D+"','"+burstEmission+"','"+receptorType+"','"+stateType+"') ";		
						String nodeSQL="INSERT INTO nano_saved.config_wrapper_node ( ID_config_wrapper, type, mass, radius, TTL, receptor, zoom3D, burstEmission, receptorType, stateType) VALUES "+sql;
						stmt.executeUpdate(nodeSQL);	
					}
				}// END WRAPPER NODE


				// CONFIG_WRAPPER_CARRIER
				Map<String, Float> carrierConfig = configWrapper.carrierConfig;
				it=carrierConfig.keySet().iterator();			
				while(it.hasNext()){	
					String element = (String) it.next();
					String[] parsed=element.split("-",2);

					if(!(addedCarrier.contains(Integer.parseInt(parsed[0])))){

						int type=Integer.parseInt(parsed[0]);					
						float mass=carrierConfig.get(parsed[0]+"-mass");
						float radius=carrierConfig.get(parsed[0]+"-radius");
						long ttl=(long)((carrierConfig.get(parsed[0]+"-ttl")).floatValue());						
						int zoom3D=(int)((carrierConfig.get(parsed[0]+"-zoom3D")).floatValue());

						addedCarrier.add(Integer.parseInt(parsed[0]));

						sql="('"+ID_Wrapper+"','"+type+"','"+mass+"','"+radius+"','"+ttl+"','"+zoom3D+"') ";		
						String carrierSQL="INSERT INTO nano_saved.config_wrapper_carrier ( ID_config_wrapper, type, mass, radius, TTL, zoom3D) VALUES "+sql;
						stmt.executeUpdate(carrierSQL);	
					}
				}// END WRAPPER CARRIER


				// CONFIG_WRAPPER_GENERIC
				Map<String, Float> genericConfig = configWrapper.genericObjConfig;
				it=genericConfig.keySet().iterator();			
				while(it.hasNext()){	
					String element = (String) it.next();
					String[] parsed=element.split("-",2);

					if(!(addedGeneric.contains(Integer.parseInt(parsed[0])))){

						int type=Integer.parseInt(parsed[0]);					
						float mass=genericConfig.get(parsed[0]+"-mass");
						float radius=genericConfig.get(parsed[0]+"-radius");
						long ttl=(long)((genericConfig.get(parsed[0]+"-ttl")).floatValue());						
						int zoom3D=(int)((genericConfig.get(parsed[0]+"-zoom3D")).floatValue());

						addedGeneric.add(Integer.parseInt(parsed[0]));

						sql="('"+ID_Wrapper+"','"+type+"','"+mass+"','"+radius+"','"+ttl+"','"+zoom3D+"') ";		
						String genericSQL="INSERT INTO nano_saved.config_wrapper_generic_obj ( ID_config_wrapper, type, mass, radius, TTL, zoom3D) VALUES "+sql;
						stmt.executeUpdate(genericSQL);	
					}
				}// END WRAPPER GENERIC


				// CONFIG_WRAPPER_DOMAIN_STRATEGY
				Map<String, Float> domainConfig = configWrapper.domainStrategyConfig;
				it=domainConfig.keySet().iterator();			
				while(it.hasNext()){	
					String element = (String) it.next();
					String[] parsed=element.split("-",2);

					if(!(addedDomainStrategy.contains(Integer.parseInt(parsed[0])))){

						int type=Integer.parseInt(parsed[0]);					
						float e=domainConfig.get(parsed[0]+"-e");

						addedDomainStrategy.add(Integer.parseInt(parsed[0]));

						sql="('"+ID_Wrapper+"','"+type+"','"+e+"') ";		
						String domainSQL="INSERT INTO nano_saved.config_wrapper_domain_strategy ( ID_config_wrapper, type, e) VALUES "+sql;
						stmt.executeUpdate(domainSQL);	
					}
				}// END WRAPPER DOMAIN STRATEGY


				// CONFIG_WRAPPER_NODE_STATE
				Map<String, Float> nodeStateConfig = configWrapper.nodeStateConfig;
				it=nodeStateConfig.keySet().iterator();			
				while(it.hasNext()){	
					String element = (String) it.next();
					String[] parsed=element.split("-",2);

					if(!(addedNodeState.contains(Integer.parseInt(parsed[0])))){

						int type=Integer.parseInt(parsed[0]);					
						int idle=(int)((nodeStateConfig.get(parsed[0]+"-idleTime")).floatValue());
						int encode=(int)((nodeStateConfig.get(parsed[0]+"-encodeTime")).floatValue());
						int transmit=(int)((nodeStateConfig.get(parsed[0]+"-transmitTime")).floatValue());
						int decode=(int)((nodeStateConfig.get(parsed[0]+"-decodeTime")).floatValue());


						addedNodeState.add(Integer.parseInt(parsed[0]));

						sql="('"+ID_Wrapper+"','"+type+"','"+idle+"','"+encode+"','"+transmit+"','"+decode+"') ";		
						String nodeStateSQL="INSERT INTO nano_saved.config_wrapper_node_state ( ID_config_wrapper, type, idle, encode, transmit, decode) VALUES "+sql;
						stmt.executeUpdate(nodeStateSQL);	
					}
				}// END WRAPPER NODE STATE


				// CONFIG_WRAPPER_RECEPTOR_STATE
				Map<String, Float> receptorStateConfig = configWrapper.receptorStateConfig;
				it=receptorStateConfig.keySet().iterator();			
				while(it.hasNext()){	
					String element = (String) it.next();
					String[] parsed=element.split("-",2);

					if(!(addedReceptorState.contains(Integer.parseInt(parsed[0])))){

						int type=Integer.parseInt(parsed[0]);					
						int inactive=(int)((receptorStateConfig.get(parsed[0]+"-inactiveTime")).floatValue());
						int active=(int)((receptorStateConfig.get(parsed[0]+"-activeTime")).floatValue());
						int download=(int)((receptorStateConfig.get(parsed[0]+"-downloadTime")).floatValue());
						int upload=(int)((receptorStateConfig.get(parsed[0]+"-uploadTime")).floatValue());
						float radius=receptorStateConfig.get(parsed[0]+"-radius");						

						addedReceptorState.add(Integer.parseInt(parsed[0]));

						sql="('"+ID_Wrapper+"','"+type+"','"+inactive+"','"+active+"','"+download+"','"+upload+"','"+radius+"') ";		
						String receptorStateSQL="INSERT INTO nano_saved.config_wrapper_receptor_state ( ID_config_wrapper, type, inactive, active, download, upload, radius) VALUES "+sql;
						stmt.executeUpdate(receptorStateSQL);	
					}
				}// END WRAPPER RECEPTOR STATE

				initialized=true;
			} catch (Exception e) {
				//} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();

			}finally{
				try {
					con.close();

				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}	


	// Can be overridden by other kind of simulation!
	// cycles on all NanoObjs, Receptors and domains that are going to be stored!
	public void collectData(){

		if(!hasBackuppedNanoObj){

			//disposedNanoObj=null;
			//undisposedNanoObj=null;

			ArrayList<LivingObjObserver> list=manager.getAllLivingObjObserver();

			disposedNanoObj=new ArrayList<NanoObj>();
			undisposedNanoObj=new ArrayList<NanoObj>();

			// Collect data from every NanoObj in every Domain!
			for (int k=0;k<list.size();k++){

				disposedNanoObj.addAll(list.get(k).getDomain().getAllDisposedObj());
				undisposedNanoObj.addAll(list.get(k).getDomain().getAllUndisposedObj());
			}

			System.out.println(">>> TOTAL disposed NanoObj: "+disposedNanoObj.size());
			System.out.println();
			for (int i=0;i<disposedNanoObj.size();i++){
				System.out.println("   >>> NanoObj n: "+i);
				NanoObj n=disposedNanoObj.get(i);

				String toString=n.toString();
				String objClass=n.getClass().toString();
				
				//String domain=n.getDomain().getClass().toString();
				String domain=n.getDomain().toString();	
				
				String type=n.name;
				float x=n.getCenter()[0];				
				float y=n.getCenter()[1];
				float z=n.getCenter()[2];

				float radius=n.getRadius();
				double mass=n.getMass();

				float velocity_module=n.getVelocityModule();
				float velocity_fi=n.getFi();
				float velocity_theta=n.getTheta();

				float velocityMM_module=n.getVelocityModuleMM();
				float velocityMM_fi=n.getFiMM();
				float velocityMM_theta=n.getThetaMM();

				float velocityMS_module=n.getVelocityModuleMS();
				float velocityMS_fi=n.getFiMS();
				float velocityMS_theta=n.getThetaMS();

				long ttl=n.getTimeToLive();
				float absDistance=n.getAbsDistance();			
				long collisionCount=n.getCollisionCount();

				long informationCount=n.informationCount;


				int numberType=n.numberType;

				long configWrapper=ID_Wrapper;
				short disposed=1;


				String sql="('"+objClass+"','"+domain+"','"+x+"','"+y+"','"+z+"','"+radius+"','"+mass+"','"+velocity_module+"','"+velocity_fi+"','"+velocity_theta+"','"+velocityMM_module+"','"+velocityMM_fi+"','"+velocityMM_theta+"','"+velocityMS_module+"','"+velocityMS_fi+"','"+velocityMS_theta+"','"+ttl+"','"+absDistance+"','"+informationCount+"','"+collisionCount+"','"+type+"','"+configWrapper+"','"+numberType+"','"+toString+"','"+disposed+"') ";		
				String finalSQL="INSERT INTO nano_saved.nanoobj ( class, domain, x, y, z, radius, mass, velocity_module, velocity_fi, velocity_theta, velocityMM_module, velocityMM_fi, velocityMM_theta, velocityMS_module, velocityMS_fi, velocityMS_theta, ttl, absDistance, informationCount, collisionCount, type, configWrapper, configType, toString, disposed) VALUES "+sql;

				runQuery(finalSQL);


				//Check if it is a NodeObj
				try{

					if(n instanceof NodeObj){


						List<Receptor> receptors=((NodeObj) n).receptorList;
						List<LigandObserver> ligandObserver=((NodeObj) n).getObsList();
						
						String sql1="";
						String sql2="";
						//String getID="SELECT ID FROM nano_saved.nanoobj WHERE configWrapper='"+configWrapper+"' AND toString='"+toString+"' ";
						//long ID_Node=runSelectID(getID);

						if(receptors.size()>0){
							ArrayList<String> myReceptorsID=new ArrayList<String>();
							String sql3="";
							
							for(int j=0;j<receptors.size();j++){

								LigandObserver myLigandObserver=receptors.get(j).getObsList();
								
								Receptor r=receptors.get(j);					

								String toString1=r.toString();
								String objClass1=r.getClass().toString();
								String owner_type=type;
								myReceptorsID.add(toString1);

								//FIXME Per non usare float[]
								/*
								float x1=r.center[0];				
								float y1=r.center[1];
								float z1=r.center[2];
								*/
								float x1=r.cx;				
								float y1=r.cy;
								float z1=r.cz;
								

								float radius1=r.getRadius();
								float assimilatedInfo=0;	// Because it is a node's receptor. Only the domain's receptors have this attribute!

								float relativeDistance=r.relativeDistance;
								byte canDownload=0;
								if(r.canDownload) canDownload=1;
								String type1=r.name;

								// Each receptor will be inserted in the query
								sql1=sql1+" ('"+objClass1+"','"+x1+"','"+y1+"','"+z1+"','"+radius1+"','"+owner_type+"','"+assimilatedInfo+"','"+relativeDistance+"','"+canDownload+"','"+type1+"','"+configWrapper+"','"+toString1+"'), ";		

								// Refresh also the table of node-receptor association
								sql2=sql2+" ('"+configWrapper+"','"+toString+"','"+toString1+"'), ";

								// Ligand Observer for every receptor
								String toString2=myLigandObserver.toString();
								String target_type=toString1;
								sql3=sql3+" ('"+toString2+"','"+target_type+"','"+configWrapper+"'), ";	
							}

							sql1=sql1.substring(0, sql1.lastIndexOf(","));
							String finalSQL1="INSERT INTO nano_saved.receptor ( class, x, y, z, radius, owner_type, assimilatedInfo, relativeDistance, canDownload, type, configWrapper, toString) VALUES "+sql1;
							runQuery(finalSQL1);

							// Refresh also the table of node-receptor association
							sql2=sql2.substring(0, sql2.lastIndexOf(","));
							String finalSQL2="INSERT INTO nano_saved.node_receptor_list ( configWrapper, node_toString, receptor_toString) VALUES "+sql2;				
							runQuery(finalSQL2);

							// Insert the Ligand Observer for every Receptor
							sql3=sql3.substring(0, sql3.lastIndexOf(","));
							String finalSQL3="INSERT INTO nano_saved.ligand_observer ( toString, target_toString, configWrapper ) VALUES "+sql3;
							runQuery(finalSQL3);
														
						}
						
						String sql3="";
						//REFRESH also the ligandObserver for the NodeObj
						for(int j=0;j<ligandObserver.size();j++){

							LigandObserver lig=ligandObserver.get(j);					

							String toString1=lig.toString();
							
							String target_type=toString;							
							
							sql3=sql3+" ('"+toString1+"','"+target_type+"','"+configWrapper+"'), ";	
						}

						sql3=sql3.substring(0, sql3.lastIndexOf(","));
						String finalSQL3="INSERT INTO nano_saved.ligand_observer ( toString, target_toString, configWrapper ) VALUES "+sql3;
						runQuery(finalSQL3);						
					}
				}catch (Exception e) {
					e.printStackTrace();
				}
			}

			// FIXME TO DEBUG! In what follows there are not any control if the NanoObj is a NodeObj and the LigandObserver are not handled!
			for (int i=0;i<undisposedNanoObj.size();i++){
				NanoObj n=undisposedNanoObj.get(i);

				String toString=n.toString();
				String objClass=n.getClass().toString();
				String domain=n.getDomain().getClass().toString();
				String type=n.name;
				float x=n.getCenter()[0];				
				float y=n.getCenter()[1];
				float z=n.getCenter()[2];

				float radius=n.getRadius();
				double mass=n.getMass();

				float velocity_module=n.getVelocityModule();
				float velocity_fi=n.getFi();
				float velocity_theta=n.getTheta();

				float velocityMM_module=n.getVelocityModuleMM();
				float velocityMM_fi=n.getFiMM();
				float velocityMM_theta=n.getThetaMM();

				float velocityMS_module=n.getVelocityModuleMS();
				float velocityMS_fi=n.getFiMS();
				float velocityMS_theta=n.getThetaMS();

				long ttl=n.getTimeToLive();
				float absDistance=n.getAbsDistance();			
				long collisionCount=n.getCollisionCount();

				long informationCount=n.informationCount;

				long configWrapper=ID_Wrapper;
				short disposed=0;

				String sql="('"+objClass+"','"+domain+"','"+x+"','"+y+"','"+z+"','"+radius+"','"+mass+"','"+velocity_module+"','"+velocity_fi+"','"+velocity_theta+"','"+velocityMM_module+"','"+velocityMM_fi+"','"+velocityMM_theta+"','"+velocityMS_module+"','"+velocityMS_fi+"','"+velocityMS_theta+"','"+ttl+"','"+absDistance+"','"+informationCount+"','"+collisionCount+"','"+type+"','"+configWrapper+"','"+toString+"','"+disposed+"') ";		
				String finalSQL="INSERT INTO nano_saved.nanoobj ( class, domain, x, y, z, radius, mass, velocity_module, velocity_fi, velocity_theta, velocityMM_module, velocityMM_fi, velocityMM_theta, velocityMS_module, velocityMS_fi, velocityMS_theta, ttl, absDistance, informationCount, collisionCount, type, configWrapper, toString, disposed) VALUES "+sql;

				runQuery(finalSQL);
			}			
			hasBackuppedNanoObj=true;
		}
	}

	public void collectDataFrom(CylindricBloodVesselDomain parent){

		ArrayList<AbstractDomain> childList=new ArrayList<AbstractDomain>();
		
				
		if(!hasBackuppedDomain){
			
			String toString=parent.toString();
			String objClass=parent.getClass().toString();
			String mainDomain=parent.getClass().toString();
			String type=parent.getType();
			float x=parent.getAbsCenter()[0];				
			float y=parent.getAbsCenter()[1];
			float z=parent.getAbsCenter()[2];

			float radius=parent.getRadius();
			float height=parent.getHeight();
			
			String dP=parent.getDirectionP().toString();
			String dN=parent.getDirectionN().toString();
			String dO=parent.getDirectionO().toString();

			byte visible=0;
			if(parent.visibleOn3D) visible=1;
			
			byte export=0;
			if(parent.export) export=1;
			
			byte octree=0;
			if(parent.useOctree) octree=1;
			
			long configWrapper=ID_Wrapper;
			
			int strategy=parent.collisionStrategy.type;

			String sql="('"+mainDomain+"','"+x+"','"+y+"','"+z+"','"+height+"','"+radius+"','"+objClass+"','"+type+"','"+visible+"','"+export+"','"+octree+"','"+configWrapper+"', '"+strategy+"', '"+dP+"', '"+dN+"', '"+dO+"', '"+toString+"') ";		
			String finalSQL="INSERT INTO nano_saved.cylindric_domain ( mainDomain, x, y, z, height, radius, class, type, visible, export, octree, configWrapper, strategy, directionP, directionN, directionO, toString) VALUES "+sql;
			runQuery(finalSQL);
			

			//----------------------------------------------
			//   Get Childs Domains!
			//----------------------------------------------

			childList.addAll(parent.childDomainList);

			System.out.println();
			System.out.println(">>> TOTAL Child Domains: "+childList.size());
			System.out.println();

			String sql1="";

			for (int i=0;i<childList.size();i++){
				if(childList.get(i) instanceof CubicReceptorDomain){
					System.out.println("   >>> Child n: "+i);
					CubicReceptorDomain n=(CubicReceptorDomain) childList.get(i);


					String toString1=n.toString();
					String objClass1=n.getClass().toString();
					//String domain1=mainDomain;
					String type1=n.getType();
					float x1=n.getRelativeCenter()[0];				
					float y1=n.getRelativeCenter()[1];
					float z1=n.getRelativeCenter()[2];

					float side=n.getHalfSide();
					int receptorQuantity=n.receptorList.size();
					int receptorType=n.receptorType;
					
					String dP1=n.getDirectionP().toString();
					String dN1=n.getDirectionN().toString();
					String dO1=n.getDirectionO().toString();
					String rotationAngle=Float.toString(n.rotationAngleP);

					byte visible1=0;
					if(n.visibleOn3D) visible1=1;

					byte export1=0;
					if(n.export) export1=1;

					byte octree1=0;
					if(n.useOctree) octree1=1;

					int strategy1=n.collisionStrategy.type;

					sql1=sql1+" ('"+mainDomain+"','"+x1+"','"+y1+"','"+z1+"','"+side+"','"+objClass1+"','"+type1+"','"+receptorQuantity+"','"+receptorType+"','"+visible1+"','"+export1+"','"+octree1+"','"+configWrapper+"','"+strategy1+"','"+dP1+"', '"+dN1+"', '"+dO1+"','"+rotationAngle+"','"+toString1+"'), ";
					
					
					// ----------------------------------------
					// 		Get all RECEPTORS!!
					// ----------------------------------------
					List<UniversalReceptor> receptors=n.receptorList;
					String sql1a="";
					String sql2="";					

					if(receptors.size()>0){
						ArrayList<String> myReceptorsID=new ArrayList<String>();
						String sql3="";
					for(int j=0;j<receptors.size();j++){
					


						CD40UniversalReceptor r=(CD40UniversalReceptor) receptors.get(j);					

								String toString2=r.toString();
								String objClass2=r.getClass().toString();
								String owner_type2=type1;
								myReceptorsID.add(toString2);								
								
								float x2=r.cx;				
								float y2=r.cy;
								float z2=r.cz;

								float radius2=r.getRadius();
								float assimilatedInfo2=0;	// Because it is a node's receptor. Only the domain's receptors have this attribute!

								float relativeDistance2=r.relativeDistance;
								byte canDownload2=0;
								if(r.canDownload) canDownload2=1;
								String type2=r.name;


								// ADDS EACH RECEPTOR TO THE QUERY
								sql1a=sql1a+" ('"+objClass2+"','"+x2+"','"+y2+"','"+z2+"','"+radius2+"','"+owner_type2+"','"+assimilatedInfo2+"','"+relativeDistance2+"','"+canDownload2+"','"+type2+"','"+configWrapper+"','"+toString2+"'), ";		

								// REFRESH THE TABLE OF NODE-RECEPTOR ASSOCIATION		
								sql2=sql2+" ('"+configWrapper+"','"+toString1+"','"+toString2+"'), ";								
								
								// Ligand Observer for every receptor
								LigandObserver myLigandObserver=receptors.get(j).getObsList();
								String toString3=myLigandObserver.toString();
								String target_type=toString2;
								sql3=sql3+" ('"+toString3+"','"+target_type+"','"+configWrapper+"'), ";		
							}

							sql1a=sql1a.substring(0, sql1a.lastIndexOf(","));
							String finalSQL1="INSERT INTO nano_saved.receptor ( class, x, y, z, radius, owner_type, assimilatedInfo, relativeDistance, canDownload, type, configWrapper, toString) VALUES "+sql1a;
							runQuery(finalSQL1);

							// REFRESH THE TABLE OF NODE-RECEPTOR ASSOCIATION	
							sql2=sql2.substring(0, sql2.lastIndexOf(","));
							String finalSQL2="INSERT INTO nano_saved.domain_receptor_list ( configWrapper, domain_toString, receptor_toString) VALUES "+sql2;				
							runQuery(finalSQL2);							
							
							// Insert the Ligand Observer for every Receptor
							sql3=sql3.substring(0, sql3.lastIndexOf(","));
							String finalSQL3="INSERT INTO nano_saved.ligand_observer ( toString, target_toString, configWrapper ) VALUES "+sql3;
							runQuery(finalSQL3);							
					}
					
					List<LigandObserver> ligandObserver=(n).getObsList();
					String sql3="";
					
					//REFRESH the LIGAND_OBSERVER FOR THE NODEOBJ
					for(int j=0;j<ligandObserver.size();j++){

						LigandObserver lig=ligandObserver.get(j);
						String toString3=lig.toString();
						String target_type=toString1;
						sql3=sql3+" ('"+toString3+"','"+target_type+"','"+configWrapper+"'), ";	
					}

					sql3=sql3.substring(0, sql3.lastIndexOf(","));
					String finalSQL3="INSERT INTO nano_saved.ligand_observer ( toString, target_toString, configWrapper ) VALUES "+sql3;
					runQuery(finalSQL3);
				}
			}
			sql1=sql1.substring(0, sql1.lastIndexOf(","));
			String finalSQL1="INSERT INTO nano_saved.cubic_receptor_domain ( mainDomain, x, y, z, side, class, type, receptorQuantity, receptorType, visible, export, octree, configWrapper, strategy, directionP, directionN, directionO, rotationAngle, toString) VALUES "+sql1;
			runQuery(finalSQL1);
			
			hasBackuppedDomain=true;
		}		
	}


public void runQuery(String sql){
		Connection con=connect();
		try {	
			
			Statement stmt = (Statement) con.createStatement();		
			stmt.executeUpdate(sql);	

		}catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			try {
				con.close();

			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}	
	}
	
	
	public long runSelectID(String sql){
		Connection con=connect();
		long ID=0;
		try {	
			Statement stmt = (Statement) con.createStatement();
			
			ResultSet ss=stmt.executeQuery(sql);		
			
			ID=0;
			if(ss.next()) {
				ID=ss.getLong("ID");
			}

		}catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			try {
				con.close();

			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return ID;	
	}
	
	public Map<String,String> getQuery_config_wrapper_node(long simID, int configType){
		Connection con=connect();

		Map<String, String> results = new HashMap<String, String>();

		try {	
			Statement stmt = (Statement) con.createStatement();
			String finalSQL="SELECT * FROM nano_saved.config_wrapper_node WHERE configWrapper='"+simID+"' AND type='"+configType+"'";
			ResultSet ss=stmt.executeQuery(finalSQL);			
			while(ss.next()) {
				
				String ID=ss.getString("ID");		
				
				String mass=ss.getString("mass");	
				String radius=ss.getString("radius");	
				String ttl=ss.getString("ttl");	
				String receptor=ss.getString("receptor");	
				String zoom3D=ss.getString("zoom3D");	
				String burstEmission=ss.getString("burstEmission");	
				String receptorType=ss.getString("receptorType");	
				String stateType=ss.getString("stateType");					
				
				results.put("ID", ID);
				results.put("mass", mass);
				results.put("radius", radius);
				results.put("ttl", ttl);
				results.put("receptor", receptor);
				results.put("zoom3D", zoom3D);
				results.put("burstEmission", burstEmission);
				results.put("receptorType", receptorType);
				results.put("stateType", stateType);
			}
			
		}catch (Exception e){
			e.printStackTrace();
		}finally{
			try {
				con.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return results;		
	}

	public Map<String,String> getQuery_CylindricDomain(long simID){
		Connection con=connect();

		Map<String, String> domains = new HashMap<String, String>();

		try {	
			Statement stmt = (Statement) con.createStatement();
			String finalSQL="SELECT * FROM nano_saved.cylindric_domain WHERE configWrapper='"+simID+"'";
			ResultSet ss=stmt.executeQuery(finalSQL);			
			while(ss.next()) {
				
				String ID=ss.getString("ID");		
				String mainDomain=ss.getString("mainDomain");	
				String x=ss.getString("x");	
				String y=ss.getString("y");	
				String z=ss.getString("z");	
				String height=ss.getString("height");	
				String radius=ss.getString("radius");	
				String myClass=ss.getString("class");	
				String type=ss.getString("type");	
				String visible=ss.getString("visible");	
				String export=ss.getString("export");	
				String octree=ss.getString("octree");	
				String toString=ss.getString("toString");
				String strategy=ss.getString("strategy");				
				String dP=ss.getString("directionP");
				String dN=ss.getString("directionN");
				String dO=ss.getString("directionO");				
				
				domains.put(ID+"-mainDomain", mainDomain);
				domains.put(ID+"-x", x);
				domains.put(ID+"-y", y);
				domains.put(ID+"-z", z);
				domains.put(ID+"-height", height);
				domains.put(ID+"-radius", radius);
				domains.put(ID+"-class", myClass);
				domains.put(ID+"-type", type);
				domains.put(ID+"-visible", visible);
				domains.put(ID+"-export", export);
				domains.put(ID+"-octree", octree);	
				domains.put(ID+"-toString", toString);	
				domains.put(ID+"-strategy", strategy);				
				domains.put(ID+"-directionP", dP);
				domains.put(ID+"-directionN", dN);
				domains.put(ID+"-directionO", dO);							
			}
			
		}catch (Exception e){
			e.printStackTrace();
		}finally{
			try {
				con.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return domains;		
	}
	
	public Map<String,String> getQuery_NanoObj(String domain_toString, long simID){
		Connection con=connect();

		Map<String, String> nanoObjs = new HashMap<String, String>();

		try {	
			Statement stmt = (Statement) con.createStatement();
			String finalSQL="SELECT * FROM nanoobj AS n WHERE n.domain='"+domain_toString+"' AND n.configWrapper='"+simID+"' ";
			ResultSet ss=stmt.executeQuery(finalSQL);			
			while(ss.next()) {
				
				String ID=ss.getString("ID");		
				String domain=ss.getString("domain");	
				String x=ss.getString("x");	
				String y=ss.getString("y");	
				String z=ss.getString("z");					
				String radius=ss.getString("radius");	
				
				String mass=ss.getString("mass");	
				
				String velocity_module=ss.getString("velocity_module");	
				String velocity_fi=ss.getString("velocity_fi");	
				String velocity_theta=ss.getString("velocity_theta");	
				
				String velocityMM_module=ss.getString("velocityMM_module");	
				String velocityMM_fi=ss.getString("velocityMM_fi");	
				String velocityMM_theta=ss.getString("velocityMM_theta");	
				
				String velocityMS_module=ss.getString("velocityMS_module");	
				String velocityMS_fi=ss.getString("velocityMS_fi");	
				String velocityMS_theta=ss.getString("velocityMS_theta");	
				
				String myClass=ss.getString("class");	
				String type=ss.getString("type");	
				String configType=ss.getString("configType");
				String ttl=ss.getString("ttl");	
				String absDistance=ss.getString("absDistance");	
				String informationCount=ss.getString("informationCount");	
				
				String collisionCount=ss.getString("collisionCount");	
				String toString=ss.getString("toString");	
				String disposed=ss.getString("disposed");			
				
				
				nanoObjs.put(ID+"-domain", domain);
				nanoObjs.put(ID+"-x", x);
				nanoObjs.put(ID+"-y", y);
				nanoObjs.put(ID+"-z", z);
				
				nanoObjs.put(ID+"-radius", radius);
				nanoObjs.put(ID+"-class", myClass);
				nanoObjs.put(ID+"-type", type);
				nanoObjs.put(ID+"-configType", configType);
				
				nanoObjs.put(ID+"-mass", mass);
				
				nanoObjs.put(ID+"-velocity_module", velocity_module);
				nanoObjs.put(ID+"-velocity_fi", velocity_fi);	
				nanoObjs.put(ID+"-velocity_theta", velocity_theta);
				
				nanoObjs.put(ID+"-velocityMM_module", velocityMM_module);
				nanoObjs.put(ID+"-velocityMM_fi", velocityMM_fi);	
				nanoObjs.put(ID+"-velocityMM_theta", velocityMM_theta);
				
				nanoObjs.put(ID+"-velocityMS_module", velocityMS_module);
				nanoObjs.put(ID+"-velocityMS_fi", velocityMS_fi);	
				nanoObjs.put(ID+"-velocityMS_theta", velocityMS_theta);
				
				nanoObjs.put(ID+"-ttl", ttl);
				nanoObjs.put(ID+"-absDistance", absDistance);
				nanoObjs.put(ID+"-informationCount", informationCount);
				
				nanoObjs.put(ID+"-collisionCount", collisionCount);				
				nanoObjs.put(ID+"-toString", toString);
				nanoObjs.put(ID+"-disposed", disposed);							
			}
			
		}catch (Exception e){
			e.printStackTrace();
		}finally{
			try {
				con.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return nanoObjs;		
	}
	
	// For each target returns its LigandObserver (that may be even the same for everyone!)
	public ArrayList<String> getQuery_LigandObserver(String target, long simID){
		Connection con=connect();

		// Map<target_name, LigandObserver_class>
		// Map<String, String> target_observerMap = new HashMap<String, String>();

		ArrayList<String> target_observerMap=new ArrayList<String>();		
		
		try {	
			Statement stmt = (Statement) con.createStatement();
			String finalSQL="SELECT * FROM nano_saved.ligand_observer WHERE configWrapper='"+simID+"' AND target_toString ='"+target+"'";
			ResultSet ss=stmt.executeQuery(finalSQL);			
			while(ss.next()) {
				
				String name=ss.getString("target_toString");		
				//String targetName=name.substring(name.lastIndexOf("@")+1,name.length());				
				
				String observer=ss.getString("toString");					
				//String observerClass=observer.substring(0,observer.lastIndexOf("@"));				
				
				target_observerMap.add(observer);	// Any observer added to this list is unique, because of the primary key of the ligand_observer entity!
													// P_KEY(toString, target_toString, configWrapper)				
							
			}
			
		}catch (Exception e){
			e.printStackTrace();
		}finally{
			try {
				con.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return target_observerMap;		
	}
	
	public Map<String,String> getQuery_CubicReceptorDomain(long simID){
		Connection con=connect();

		Map<String, String> domains = new HashMap<String, String>();

		try {	
			Statement stmt = (Statement) con.createStatement();
			String finalSQL="SELECT * FROM nano_saved.cubic_receptor_domain WHERE configWrapper='"+simID+"'";
			ResultSet ss=stmt.executeQuery(finalSQL);			
			while(ss.next()) {
				
				String ID=ss.getString("ID");		
				String mainDomain=ss.getString("mainDomain");	
				String x=ss.getString("x");	
				String y=ss.getString("y");	
				String z=ss.getString("z");	
				String side=ss.getString("side");	
			
				String myClass=ss.getString("class");	
				String type=ss.getString("type");	
				String receptorQuantity=ss.getString("receptorQuantity");	
				String receptorType=ss.getString("receptorType");
				String visible=ss.getString("visible");	
				String export=ss.getString("export");	
				String octree=ss.getString("octree");	
				String toString=ss.getString("toString");
				String strategy=ss.getString("strategy");
				
				String dP=ss.getString("directionP");
				String dN=ss.getString("directionN");
				String dO=ss.getString("directionO");
				String rotationAngle=ss.getString("rotationAngle");
				
				domains.put(ID+"-mainDomain", mainDomain);
				domains.put(ID+"-x", x);
				domains.put(ID+"-y", y);
				domains.put(ID+"-z", z);
				domains.put(ID+"-side", side);
				
				domains.put(ID+"-class", myClass);
				domains.put(ID+"-type", type);
				domains.put(ID+"-receptorQuantity", receptorQuantity);
				domains.put(ID+"-receptorType", receptorType);
				domains.put(ID+"-visible", visible);
				domains.put(ID+"-export", export);
				domains.put(ID+"-octree", octree);	
				domains.put(ID+"-toString", toString);	
				domains.put(ID+"-strategy", strategy);	
				
				domains.put(ID+"-directionP", dP);
				domains.put(ID+"-directionN", dN);
				domains.put(ID+"-directionO", dO);
				domains.put(ID+"-rotationAngle", rotationAngle);							
			}
			
		}catch (Exception e){
			e.printStackTrace();
		}finally{
			try {
				con.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return domains;		
	}
	
	public Map<String,String> getReceptorsForNode(String owner_toString, long simID){
		Connection con=connect();

		Map<String, String> receptors = new HashMap<String, String>();

		try {	
			Statement stmt = (Statement) con.createStatement();
			String finalSQL="SELECT * FROM node_receptor_list AS nl JOIN receptor AS r  WHERE nl.node_toString='"+owner_toString+"' AND nl.configWrapper='"+simID+"' AND r.configWrapper='"+simID+"' AND r.toString=nl.receptor_toString";
			ResultSet ss=stmt.executeQuery(finalSQL);			
			while(ss.next()) {
				
				String ID=ss.getString("ID");				
				String x=ss.getString("x");	
				String y=ss.getString("y");	
				String z=ss.getString("z");					
				String radius=ss.getString("radius");	
				String myClass=ss.getString("class");	
				String owner_type=ss.getString("owner_type");	
				String assimilatedInfo=ss.getString("assimilatedInfo");	
				String relativeDistance=ss.getString("relativeDistance");	
				String canDownload=ss.getString("canDownload");	
				String type=ss.getString("type");				
				receptors.put(ID+"-x", x);
				receptors.put(ID+"-y", y);
				receptors.put(ID+"-z", z);
				receptors.put(ID+"-owner_type", owner_type);
				receptors.put(ID+"-radius", radius);
				receptors.put(ID+"-class", myClass);
				receptors.put(ID+"-type", type);
				receptors.put(ID+"-assimilatedInfo", assimilatedInfo);
				receptors.put(ID+"-relativeDistance", relativeDistance);
				receptors.put(ID+"-canDownload", canDownload);								
			}
			
		}catch (Exception e){
			e.printStackTrace();
		}finally{
			try {
				con.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return receptors;		
	}
	
	public Map<String,String> getReceptorsForCubicDomain(String owner_toString, long simID){
		Connection con=connect();

		Map<String, String> receptors = new HashMap<String, String>();

		try {	
			Statement stmt = (Statement) con.createStatement();
			String finalSQL="SELECT * FROM domain_receptor_list AS nl JOIN receptor AS r  WHERE nl.domain_toString='"+owner_toString+"' AND nl.configWrapper='"+simID+"' AND r.configWrapper='"+simID+"' AND r.toString=nl.receptor_toString";
			ResultSet ss=stmt.executeQuery(finalSQL);			
			while(ss.next()) {
				
				String ID=ss.getString("ID");		
			
				String x=ss.getString("x");	
				String y=ss.getString("y");	
				String z=ss.getString("z");	
				
				String radius=ss.getString("radius");	
				String myClass=ss.getString("class");	
				String owner_type=ss.getString("owner_type");	
				String assimilatedInfo=ss.getString("assimilatedInfo");	
				String relativeDistance=ss.getString("relativeDistance");	
				String canDownload=ss.getString("canDownload");	
				String type=ss.getString("type");
				
				receptors.put(ID+"-x", x);
				receptors.put(ID+"-y", y);
				receptors.put(ID+"-z", z);
				receptors.put(ID+"-owner_type", owner_type);
				receptors.put(ID+"-radius", radius);
				receptors.put(ID+"-class", myClass);
				receptors.put(ID+"-type", type);
				receptors.put(ID+"-assimilatedInfo", assimilatedInfo);
				receptors.put(ID+"-relativeDistance", relativeDistance);
				receptors.put(ID+"-canDownload", canDownload);								
			}
			
		}catch (Exception e){
			e.printStackTrace();
		}finally{
			try {
				con.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return receptors;		
	}
	
	public void restore(long simID) {	

		Connection con=connect();
		try {	
			Statement stmt = (Statement) con.createStatement();
			
			// CONFIG WRAPPER
			String finalSQL="SELECT * FROM nano_saved.config_wrapper WHERE ID='"+simID+"'";
			ResultSet ss=stmt.executeQuery(finalSQL);			
			if(ss.next()) {
				String simulationID=ss.getString("name");
				String description=ss.getString("description");
				String mobilityModel=ss.getString("mobility_model");
				String outputStrategy=ss.getString("output_strategy");
				long lastTimestep=ss.getLong("last_timestep");
				long simulationTimeLength=ss.getLong("simulationTimeLength");
				int exportTimeLength=ss.getInt("exportTimeLength");
				
				int threads=ss.getInt("threads");
				int ddt=ss.getInt("ddt");
				int _dt=ss.getInt("_dt");
				int timeUnit=ss.getInt("timeUnit");
				
				float T=ss.getFloat("T");
				float viscosity=ss.getFloat("viscosity");
				int u=ss.getInt("u");
				
				int nodeTreeLimit=ss.getInt("nodeTreeLimit");
				int nodeSideLimit=ss.getInt("nodeSideLimit");
				int printTimeOnScreen=ss.getInt("printTimeOnScreen");
				
				float[] camera=new float[3];				
				camera[0]=ss.getFloat("camera_x");
				camera[1]=ss.getFloat("camera_y");
				camera[2]=ss.getFloat("camera_z");
				
				SimpleVector lookAt=new SimpleVector(ss.getFloat("lookAt_x"),ss.getFloat("lookAt_y"),ss.getFloat("lookAt_z"));				
				
				int[] lights=new int[3];
				lights[0]=ss.getInt("lights_r");
				lights[1]=ss.getInt("lights_g");
				lights[2]=ss.getInt("lights_b");
				
				int[] window=new int[2];
				window[0]=ss.getInt("window_w");
				window[1]=ss.getInt("window_h");						
				
				configWrapper.simulationTimeLength=simulationTimeLength;
				configWrapper.exportTimeLength=exportTimeLength;
				configWrapper.threads=threads;
				configWrapper.ddt=ddt;
				configWrapper._dt=_dt;
				configWrapper.timeUnit=timeUnit;
				configWrapper.T=T;
				configWrapper.u=u;				
				configWrapper.viscosity=viscosity;
				configWrapper.nodeTreeLimit=nodeTreeLimit;				
				configWrapper.nodeSideLimit=nodeSideLimit;
				configWrapper.printTimeOnScreen=printTimeOnScreen;				
				configWrapper.camera=camera;
				configWrapper.lights=lights;				
				configWrapper.window=window;
				configWrapper.lookAt=lookAt;				
			}
			

			
			// CONFIG_WRAPPER_NODE
			//Map<String, Float> nodeConfig = configWrapper.nodeConfig;
			Map<String, Float> nodeConfig = new HashMap<String, Float>();
			
			finalSQL="SELECT * FROM nano_saved.config_wrapper_node WHERE ID_config_wrapper='"+simID+"'";
			ss=stmt.executeQuery(finalSQL);			
			while(ss.next()) {
				
				int type=ss.getInt("type");					
				float mass=ss.getFloat("mass");
				float radius=ss.getFloat("radius");
				long ttl=ss.getLong("ttl");
				long receptor=ss.getLong("receptor");
				int zoom3D=ss.getInt("zoom3D");
				long burstEmission=ss.getLong("burstEmission");
				int receptorType=ss.getInt("receptorType");
				int stateType=ss.getInt("stateType");
				
				
				nodeConfig.put(type+"-mass", mass);
				nodeConfig.put(type+"-radius", radius);
				nodeConfig.put(type+"-ttl", (float)ttl);
				nodeConfig.put(type+"-receptor", (float)receptor);
				nodeConfig.put(type+"-zoom3D", (float)zoom3D);
				nodeConfig.put(type+"-burstEmission", (float)burstEmission);
				nodeConfig.put(type+"-receptorType", (float)receptorType);
				nodeConfig.put(type+"-stateType", (float)stateType);				
				
			}
			
			configWrapper.nodeConfig=nodeConfig;			
			// END WRAPPER NODE

			
			// CONFIG_WRAPPER_CARRIER
			Map<String, Float> carrierConfig = new HashMap<String, Float>();			
			
			finalSQL="SELECT * FROM nano_saved.config_wrapper_carrier WHERE ID_config_wrapper='"+simID+"'";
			ss=stmt.executeQuery(finalSQL);			
			while(ss.next()) {
				
				int type=ss.getInt("type");					
				float mass=ss.getFloat("mass");
				float radius=ss.getFloat("radius");
				long ttl=ss.getLong("ttl");				
				int zoom3D=ss.getInt("zoom3D");					
				
				carrierConfig.put(type+"-mass", mass);
				carrierConfig.put(type+"-radius", radius);
				carrierConfig.put(type+"-ttl", (float)ttl);				
				carrierConfig.put(type+"-zoom3D", (float)zoom3D);				
			}
			
			configWrapper.carrierConfig=carrierConfig;	
			// END WRAPPER CARRIER
			
					
			

			// CONFIG_WRAPPER_GENERIC
			Map<String, Float> genericConfig = new HashMap<String, Float>();
					
			finalSQL="SELECT * FROM nano_saved.config_wrapper_generic_obj WHERE ID_config_wrapper='"+simID+"'";
			ss=stmt.executeQuery(finalSQL);		
			
			while(ss.next()) {
				
				int type=ss.getInt("type");					
				float mass=ss.getFloat("mass");
				float radius=ss.getFloat("radius");
				long ttl=ss.getLong("ttl");				
				int zoom3D=ss.getInt("zoom3D");					
				
				genericConfig.put(type+"-mass", mass);
				genericConfig.put(type+"-radius", radius);
				genericConfig.put(type+"-ttl", (float)ttl);				
				genericConfig.put(type+"-zoom3D", (float)zoom3D);				
			}
			
			configWrapper.genericObjConfig=genericConfig;				
			// END WRAPPER GENERIC
			
			

			// CONFIG_WRAPPER_DOMAIN_STRATEGY
			Map<String, Float> domainConfig = new HashMap<String, Float>();
			//configWrapper.domainStrategyConfig;
			
			finalSQL="SELECT * FROM nano_saved.config_wrapper_domain_strategy WHERE ID_config_wrapper='"+simID+"'";
			ss=stmt.executeQuery(finalSQL);		
			
			while(ss.next()) {
				
				int type=ss.getInt("type");					
				float e=ss.getFloat("e");								
				
				genericConfig.put(type+"-e", e);							
			}
			configWrapper.domainStrategyConfig=domainConfig;				
			// END WRAPPER DOMAIN STRATEGY

						

			// CONFIG_WRAPPER_NODE_STATE
			Map<String, Float> nodeStateConfig =  new HashMap<String, Float>();
			//configWrapper.nodeStateConfig;
			
			finalSQL="SELECT * FROM nano_saved.config_wrapper_node_state WHERE ID_config_wrapper='"+simID+"'";
			ss=stmt.executeQuery(finalSQL);		
			
			while(ss.next()) {
				
				int type=ss.getInt("type");	
				int idle=ss.getInt("idle");	
				int encode=ss.getInt("encode");	
				int transmit=ss.getInt("transmit");	
				int decode=ss.getInt("decode");	
				
				nodeStateConfig.put(type+"-idle", (float)idle);							
				nodeStateConfig.put(type+"-encode", (float)encode);
				nodeStateConfig.put(type+"-transmit", (float)transmit);
				nodeStateConfig.put(type+"-decode", (float)decode);
			}
			configWrapper.nodeStateConfig=nodeStateConfig;	
			// END WRAPPER NODE STATE
			
			
			// CONFIG_WRAPPER_RECEPTOR_STATE
			Map<String, Float> receptorStateConfig =  new HashMap<String, Float>();
			//configWrapper.receptorStateConfig;
				
			finalSQL="SELECT * FROM nano_saved.config_wrapper_receptor_state WHERE ID_config_wrapper='"+simID+"'";
			ss=stmt.executeQuery(finalSQL);		
			
			while(ss.next()) {
				int type=ss.getInt("type");	
				int inactive=ss.getInt("inactive");	
				int active=ss.getInt("active");	
				int download=ss.getInt("download");	
				int upload=ss.getInt("upload");	
				float radius=ss.getInt("radius");	
				
				receptorStateConfig.put(type+"-inactive", (float)inactive);							
				receptorStateConfig.put(type+"-active", (float)active);
				receptorStateConfig.put(type+"-download", (float)download);
				receptorStateConfig.put(type+"-upload", (float)upload);
				receptorStateConfig.put(type+"-radius", (float)radius);				
			}
			configWrapper.receptorStateConfig=receptorStateConfig;	
			// END WRAPPER RECEPTOR STATE
			
			
			
			// LIGAND OBSERVER		
			finalSQL="SELECT * FROM nano_saved.ligand_observer WHERE configWrapper='"+simID+"' GROUP BY  'toString'";
			ss=stmt.executeQuery(finalSQL);		
			
			while(ss.next()) {
				String observer=ss.getString("toString");					
				String observerClass=observer.substring(0,observer.lastIndexOf("@"));
				String observerName=observer.substring(observer.lastIndexOf("@")+1,observer.length());
				
				try{					
					Class myClass = Class.forName(observerClass);			
					ligandObserver.put(observerName, (LigandObserver)myClass.getDeclaredMethod("getInstance", null).invoke(null, null));
					
				}catch (Exception e){
					e.printStackTrace();
				}					
			}				
			// END LIGAND OBSERVER
			
			
			
		} catch (Exception e) {
			//} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();

		}finally{
			try {
				con.close();

			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}		
	}	
	

	public void setManager(Manager m){
		this.manager=m;
		this.configWrapper=manager.configWrapper;
	}

	private String getSimulationID(){
		Random r=new Random();
		if (simulationID==null) {					
			String name=Configurator2.readCustomStringConfigurations("config.xml", "System", "simulationName");			
			int day, month, year;
		    GregorianCalendar gc = new GregorianCalendar();
		    day = gc.get(Calendar.DAY_OF_MONTH);
		    month = (gc.get(Calendar.MONTH))+1;
		    year = gc.get(Calendar.YEAR);		    
	    	int hour,minute,second;
	    	hour=gc.get(Calendar.HOUR_OF_DAY);
	    	minute=gc.get(Calendar.MINUTE);
	    	second=gc.get(Calendar.SECOND);
	    	simulationID="backup_"+name+"_"+r.nextInt(99999)+"_"+year+month+day+hour+minute+second;
		}
		return simulationID;
	}
}
