package simulator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import Wrappers.OutputWrapperBloodVessel;
import simulator.CubicReceptorDomain;
import MainLibrary.AbstractDomain;
import MainLibrary.Manager;
import MainLibrary.OutputStrategy;


/** This class stores all the relevant objects into a database file!   */


public class OutputStrategyDBCubicReceptorDomain extends OutputStrategy {
	
	public List<OutputWrapperBloodVessel> wrapperList = new ArrayList<OutputWrapperBloodVessel>();	
	private static OutputStrategyDBCubicReceptorDomain instance=null;	
	
	public static OutputStrategyDBCubicReceptorDomain getInstance(){
		if (instance==null) instance=new OutputStrategyDBCubicReceptorDomain();		
		return instance;
	}
	
	private OutputStrategyDBCubicReceptorDomain(){
		
	}
	
	/* (non-Javadoc)
	 * @see MainLibrary.OutputStrategy#export(java.util.Map)
	 */	
	@Override
	public void export(Map<Object, Object> results) {		
		if(results.get("Type")=="CubeReceptorVessel"){		

			String ID=(String) results.get("ID");
			String x=(String) results.get("X").toString();
			String y=(String) results.get("Y").toString();
			String z=(String) results.get("Z").toString();
			String timeStep=(String) results.get("TimeStep").toString();
			String assimilations=(String) results.get("Assimilations").toString();

			OutputWrapperBloodVessel o=new OutputWrapperBloodVessel(ID, x,y,z, timeStep, assimilations, "null");		
			
			wrapperList.add(o);
			
		}else if(results.get("Typev")=="PlateletVessel"){

			String ID=(String) results.get("IDv").toString();
			String timeStep=(String) results.get("TimeStepv").toString();
			String x=(String) results.get("Xv").toString();
			String y=(String) results.get("Yv").toString();
			String z=(String) results.get("Zv").toString();
			
			OutputWrapperBloodVessel o=new OutputWrapperBloodVessel(ID, x,y,z, timeStep, "null", "null");

			wrapperList.add(o);			
		
		}else if(results.get("Typev")=="MacrophageVessel"){

			String ID=(String) results.get("IDv").toString();
			String x=(String) results.get("Xv").toString();
			String y=(String) results.get("Yv").toString();
			String z=(String) results.get("Zv").toString();
			String timeStep=(String) results.get("TimeStepv").toString();
			String assimilations=(String) results.get("Assimilations").toString();		

			OutputWrapperBloodVessel o=new OutputWrapperBloodVessel(ID, x,y,z, timeStep, assimilations, "null");
			
			wrapperList.add(o);			
		}		
	}

	/* (non-Javadoc)
	 * @see MainLibrary.OutputStrategy#close()
	 */
	@Override
	public void close() {
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see MainLibrary.OutputStrategy#initialize(MainLibrary.Manager)
	 */
	@Override
	public void initialize(Manager m) {
		
	}
	
	public Collection<? extends CubicReceptorDomain> searchForCubicReceptorsDomain(AbstractDomain d){
		List<CubicReceptorDomain> list = new ArrayList<CubicReceptorDomain>();
		if(d instanceof CubicReceptorDomain){
			list.add((CubicReceptorDomain) d);
		}
		for(AbstractDomain domain:d.getAllChildDomains()){
			list.addAll(searchForCubicReceptorsDomain(domain));
		}
		return list;		
	}

	@Override
	public void update(String text) {
		// TODO Auto-generated method stub
		
	}
}

