package simulator;

import java.io.*;
import java.util.*;
import MainLibrary.Manager;
import MainLibrary.OutputStrategy;


public class OutputTXT extends OutputStrategy{

	private static OutputTXT instance=null;
	private static String fileName=null;
	private static FileOutputStream file;
	private static PrintStream Output;

	private OutputTXT(){
		
	}
	
	public static OutputTXT getInstance(){
		if (instance==null) instance=new OutputTXT();
		
		try {
			file = new FileOutputStream(instance.getFileName(),true);
			Output = new PrintStream(file);
			Output.println("Textual Export");	  
		} catch (IOException e) {
			System.out.println("Output Error: " + e);
		}
		return instance;
	}
	
	@Override
	public void export(Map<Object, Object> results) {
				
		Object[] o=results.entrySet().toArray();
		    	  
		try {
			file = new FileOutputStream(getFileName(),true);
			Output = new PrintStream(file);
			Output.println("===============");
			for(int i=0;i<o.length;i++){
				Output.println(o[i]);
			}			
		} catch (IOException e) {
			System.out.println("Output Error: " + e);
		}
	} 
	
	public String getFileName(){
		Random r=new Random();
		if (fileName==null) {
			int day, month, year;
		    GregorianCalendar gc = new GregorianCalendar();
		    day = gc.get(Calendar.DAY_OF_MONTH);
		    month = (gc.get(Calendar.MONTH))+1;
		    year = gc.get(Calendar.YEAR);
		    
	    	int hour,minute,second;
	    	hour=gc.get(Calendar.HOUR_OF_DAY);
	    	minute=gc.get(Calendar.MINUTE);
	    	second=gc.get(Calendar.SECOND);
	    	fileName="export_id"+r.nextInt(1000)+" ["+year+"-"+month+"-"+day+"] @ "+hour+"-"+minute+"-"+second+".txt";
		}
		return fileName;
	}

	@Override
	public void close() {
		
	}

	@Override
	public void initialize(Manager m) {
		// TODO Auto-generated method stub		
	}

	@Override
	public void update(String text) {
		// TODO Auto-generated method stub
		
	}	      
}
