package simulator;

import java.io.*;
import java.util.*;
import MainLibrary.Manager;
import MainLibrary.OutputStrategy;


public class OutputTXTDomains extends OutputStrategy{

	private static OutputTXTDomains instance=null;
	private static String fileName=null;
	private static FileOutputStream file;
	private static PrintStream Output;
	private static Map<Object,Object> standByExportMap=new HashMap<Object,Object>();
	private boolean hasHeader=false;
	
	private OutputTXTDomains(){
	
	}
	
	public static OutputTXTDomains getInstance(){
		if (instance==null) instance=new OutputTXTDomains();

		try {
			file = new FileOutputStream(instance.getFileName(),true);
			Output = new PrintStream(file);
			 
		} catch (IOException e) {
			System.out.println("Output Error: " + e);
		}
		return instance;
	}
	
	public void initialize(Manager m){
		try {
							
			file = new FileOutputStream(getFileName(),true);
			Output = new PrintStream(file);		
			
						
		} catch (IOException e) {
			System.out.println("Initialize Output Error: " + e);
			
		} finally {
		    // Close resource.
		    if (file!= null) try { 
		        file.close();
		    } catch (IOException logOrIgnore) {
		    	System.out.println("Output Error [closing file]: " + logOrIgnore);
		    }
		}
	}	
	
	@Override
	public void export(Map<Object, Object> results) {
		
		if (results!=null){	  
			try {
				file = new FileOutputStream(getFileName(),true);
				Output = new PrintStream(file);

				if (results.containsKey("CurrentTime")){
					standByExportMap.putAll(results);
					
				}else{	
					if(!hasHeader){
						Output.println();
						Output.print("CurrentTime ");
						int mapSize=results.size()/2;
						for(int j=0;j<mapSize;j++){								
							Output.print(results.get("Receptor-"+j)+" ");									
						}								
						hasHeader=true;
					}
					
					if(standByExportMap.containsKey("CurrentTime")){
						Output.println();
						Output.print(standByExportMap.get("CurrentTime")+" ");	
						standByExportMap=new HashMap<Object,Object>();
					}

					int mapSize=results.size()/2;
					for(int j=0;j<mapSize;j++){						
						Output.print(results.get("Assimilations-"+j)+" ");	
					}		
				}

			} catch (IOException e) {
				System.out.println("Output Error: " + e);

			} finally {
				// Close resource.
				if (file!= null) try { 
					file.close();
				} catch (IOException logOrIgnore) {
					System.out.println("Output Error [closing file]: " + logOrIgnore);
				}
			}
		}
	} 	

	public void close(){
		
	}
	
	public String getFileName(){	
		fileName="Domains"+getRandomFileName()+".txt";
		return fileName;
	}

	@Override
	public void update(String text) {
		// TODO Auto-generated method stub
		
	}	      
}