package simulator;

import java.io.*;
import java.util.*;
import MainLibrary.Manager;
import MainLibrary.OutputStrategy;


public class OutputTXTExecutionTime extends OutputStrategy{

	private static OutputTXTExecutionTime instance=null;
	private static String fileName=null;
	private static FileOutputStream file;
	private static PrintStream Output;	
	private OutputTXTExecutionTime(){
		
	}
	
	public static OutputTXTExecutionTime getInstance(){
		if (instance==null) instance=new OutputTXTExecutionTime();

		try {
			file = new FileOutputStream(instance.getFileName(),true);
			Output = new PrintStream(file);			
		} catch (IOException e) {
			System.out.println("Output Error 1: " + e);
		}
		return instance;
	}
	
	public void initialize(Manager m){
		
		try {
			file = new FileOutputStream(getFileName(),true);
			Output = new PrintStream(file);
			
			
			Output.println("TimeStep[cycles] CPUTime[ms] StepDuration[ms]");
			
						
		} catch (IOException e) {
			System.out.println("Initialize Output Error: " + e);
					
		} finally {
		    // Close resource.
		    if (file!= null) try { 
		        file.close();
		    } catch (IOException logOrIgnore) {
		    	System.out.println("Output Error [closing file]: " + logOrIgnore);
		    }
		}
		
	}
	
	@Override
	public void export(Map<Object, Object> results) {
		
		try {
			file = new FileOutputStream(getFileName(),true);
			Output = new PrintStream(file);
			long step=0;
			long cpuTime=0;
			if (results.containsKey("CurrentTime") && results.containsKey("CPUTime")){	
							
				step=((Number)results.get("CurrentTime")).longValue();
				cpuTime=((Number)results.get("CPUTime")).longValue();
				Output.print(step+" "+cpuTime);
				
				if (step>0 && cpuTime>0){
					Output.print(" "+(cpuTime/step));		
				}
				Output.println("");	
			}			
						
		} catch (IOException e) {
			System.out.println("Output Error 2: " + e);
			
		} finally {
		    // Close resource.
		    if (file!= null) try { 
		        file.close();
		    } catch (IOException logOrIgnore) {
		    	System.out.println("Output Error [closing file]: " + logOrIgnore);
		    }
		}
	} 	

	public void close(){
		
	}
	
	public String getFileName(){
		Random r=new Random();
		if (fileName==null) {
			int day, month, year;
		    GregorianCalendar gc = new GregorianCalendar();
		    day = gc.get(Calendar.DAY_OF_MONTH);
		    month = (gc.get(Calendar.MONTH))+1;
		    year = gc.get(Calendar.YEAR);
		    
	    	int hour,minute,second;
	    	hour=gc.get(Calendar.HOUR_OF_DAY);
	    	minute=gc.get(Calendar.MINUTE);
	    	second=gc.get(Calendar.SECOND);
	    	fileName="ExecutionTime_export_id"+r.nextInt(1000)+"["+year+"-"+month+"-"+day+"]@"+hour+"-"+minute+"-"+second+".txt";
		}
		return fileName;
	}

	@Override
	public void update(String text) {
		// TODO Auto-generated method stub
		
	}	      
}