package simulator;

import java.io.*;
import java.util.*;
import java.util.Map.Entry;

import MainLibrary.Manager;
import MainLibrary.OutputStrategy;


public class OutputTXTReceptors extends OutputStrategy{

	private static OutputTXTReceptors instance=null;
	private static String fileName=null;
	private static FileOutputStream file;
	private static PrintStream Output;	
	private OutputTXTReceptors(){
		
	}
	
	public static OutputTXTReceptors getInstance(){
		if (instance==null) instance=new OutputTXTReceptors();

		try {
			file = new FileOutputStream(instance.getFileName(),true);
			Output = new PrintStream(file);			
		} catch (IOException e) {
			System.out.println("Output Error 1: " + e);
		}
		return instance;
	}
	
	public void initialize(Manager m){
		/*
		try {
			file = new FileOutputStream(getFileName(),true);
			Output = new PrintStream(file);
			
			
			Output.println("TimeStep[cycles] CPUTime[ms] StepDuration[ms]");
			
						
		} catch (IOException e) {
			System.out.println("Initialize Output Error: " + e);
					
		} finally {
		    // Close resource.
		    if (file!= null) try { 
		        file.close();
		    } catch (IOException logOrIgnore) {
		    	System.out.println("Output Error [closing file]: " + logOrIgnore);
		    }
		}*/
		
	}
	
	@Override
	public void export(Map<Object, Object> results) {
		
		try {
			file = new FileOutputStream(getFileName(),false);
			Output = new PrintStream(file);
			
			/*
			//int ID_Receptor=-1;
			float theta_r=0;
			float fi_r=0;
			int assimilations_r=0;
			*/
			
			//if (results.containsKey("CurrentTime") && results.containsKey("CPUTime")){	
			    
			
			/*
			Object[] o=results.entrySet().toArray();			
			for(int i=0;i<o.length;i++){
				Output.println(o[i]);
			}
			*/
			
			
			
			Iterator iterator = (Iterator) results.entrySet().iterator(); // apply iterator to entrySet()

			while(iterator.hasNext()){
				@SuppressWarnings("unchecked")
				Map.Entry<Object, Object> keyValuePair = (Entry<Object, Object>) iterator.next(); // using Entry property of Map 
				Output.println(keyValuePair.getValue());				
			}

			
				/*
			    //ID_Receptor=((Number)results.get("ID_Receptor")).intValue();
				theta_r=((Number)results.get("theta_r")).floatValue();
				fi_r=((Number)results.get("fi_r")).floatValue();
				assimilations_r=((Number)results.get("assimilations_r")).intValue();
				
				
				
				Output.println(ID_Receptor+" "+theta_r+" "+fi_r+" "+assimilations_r);
				*/
			
			//}			
						
		} catch (IOException e) {
			System.out.println("Output Error 2: " + e);
			
		} finally {
		    // Close resource.
		    if (file!= null) try { 
		        file.close();
		    } catch (IOException logOrIgnore) {
		    	System.out.println("Output Error [closing file]: " + logOrIgnore);
		    }
		}
	} 	

	public void close(){
		
	}
	
	public String getFileName(){
		Random r=new Random();
		if (fileName==null) {
			int day, month, year;
		    GregorianCalendar gc = new GregorianCalendar();
		    day = gc.get(Calendar.DAY_OF_MONTH);
		    month = (gc.get(Calendar.MONTH))+1;
		    year = gc.get(Calendar.YEAR);
		    
	    	int hour,minute,second;
	    	hour=gc.get(Calendar.HOUR_OF_DAY);
	    	minute=gc.get(Calendar.MINUTE);
	    	second=gc.get(Calendar.SECOND);
	    	fileName="RX_Receptors_Map_ID"+r.nextInt(1000)+"["+year+"-"+month+"-"+day+"]@"+hour+"-"+minute+"-"+second+".txt";
		}
		return fileName;
	}

	@Override
	public void update(String text) {
		// TODO Auto-generated method stub
		
	}	      
}