package simulator;

import java.util.List;

import MainLibrary.AbstractDomain;

import MainLibrary.CarrierObj;
import MainLibrary.LigandObserver;
import MainLibrary.NanoObj;
import MainLibrary.NoMotion;
import MainLibrary.NodeObj;




public class PlateletVesselTX_STATIC extends PlateletVesselTX{

	BloodFlowModel model=null;
	

	public PlateletVesselTX_STATIC(AbstractDomain domain, float x, float y, float z, int nodeNumberType, List<LigandObserver> observer){
		super(domain,x,y,z,nodeNumberType,observer);	
		model=(BloodFlowModel) getDomain().getMobilityModel();
	}	
	
	public void exec(){
		super.exec();
		if(hasTransmitted){
			setMotionStrategy(BrownianMotionBloodStream.getInstance());	
			setVelocityComponent(0,0,0);
			setVelocityComponentMM(0,0,0);
		}
	}

	public void handle(CarrierObj c){
		
		if(!hasTransmitted){
			model.relocateObjs_FOR_STATIC_PLATELET(c,this);
		}else{
			model.relocateObjs(c,this);
		}
	}

	public void handle(NodeObj n){	
		if(!hasTransmitted){
			model.relocateObjs_FOR_STATIC_PLATELET(n,this);
		}else{
			model.relocateObjs(n,this);
		}
	}

	public void handle(NanoObj n){	
		if(!hasTransmitted){
			model.relocateObjs_FOR_STATIC_PLATELET(n,this);
		}else{
			model.relocateObjs(n,this);
		}
	}	
	
	public void setCenter(float x, float y, float z){			
		if(hasTransmitted){
			super.setCenter(x,y,z);
		}
	}
	
	/*
	public void setVelocityComponentMM(float v, float fi, float theta){
		if(!hasTransmitted){
			super.setVelocityComponentMM(0, 0, 0);
		}else{
			super.setVelocityComponentMM(v,fi,theta);
		}
	}

	public void setVelocityComponentMS(float v, float fi, float theta){
		if(!hasTransmitted){
			super.setVelocityComponentMS(0, 0, 0);
		}else{
			super.setVelocityComponentMM(v,fi,theta);
		}
	}

	public void setVelocityComponent(float v, float fi, float theta){
		if(!hasTransmitted){	
			super.setVelocityComponent(0, 0, 0);
		}else{
			super.setVelocityComponentMM(v,fi,theta);
		}
	}*/

	@Override
	public void setMotionStrategy() {		
		//this.motionStrategy=BrownianMotionBloodStream.getInstance();
		this.motionStrategy=NoMotion.getInstance();
	}	

	public String assignName(){		
		return "Platelet";		
	}
	
}