package simulator;

import java.awt.Color;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import MainLibrary.AbstractDomain;
import MainLibrary.CarrierObj;
import MainLibrary.LigandObserver;
import MainLibrary.NodeObj;
import MainLibrary.Receptor;


public class TCPLike_Carrier_A extends CarrierObj{
	
	private long localExportTime=50000;
	
	public TCPLike_Carrier_A(AbstractDomain domain, NodeObj n, float x, float y, float z,int carrierNumberType) {		
		super(domain,n, x, y, z,
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-mass"), 
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-radius").floatValue(), 
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-ttl").intValue(),
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-zoom3D"), carrierNumberType);		
		color=Color.cyan;	
	}	
	
	public TCPLike_Carrier_A(AbstractDomain domain, float x, float y, float z,int carrierNumberType) {
		super(domain, x, y, z,
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-mass"), 
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-radius").floatValue(), 
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-ttl").intValue(),
				domain.getManager().configWrapper.carrierConfig.get(carrierNumberType+"-zoom3D"), carrierNumberType);		
		color=Color.cyan;		
	}
	
	@Override
	public LigandObserver getMyObserver() {
		return TCPLike_CarrierA_Observer.getInstance();
	}	
	
	@Override
	protected Map<Object, Object> specializedExport() {
		Map<Object, Object> m=new HashMap<Object,Object>();
		//m.put("Type", "Carrier");	
		
		boolean hasToExport=false;
		long time=getManager().getCurrentTime();
		
		//if(time%10000==0){
		if(time%localExportTime==0 || time==1000){
			hasToExport=true;
		}
		
		if(hasToExport){
			m.put("Type", "Carrier");
   
			float[] center=new float[3];
			float[] domainCenter=getDomain().getAbsCenter();

			center=getCenter();		

			m.put("ID", "TCPLike-Carrier-"+ID);	
			m.put("X", center[0]-domainCenter[0]);
			m.put("Y", center[1]-domainCenter[1]);
			m.put("Z", center[2]-domainCenter[2]);		
			
		
			m.put("angles", "F"+getFi()+"T"+getTheta());
			
			m.put("timestep", time);
		}

		return m;
	}

	@Override
	public void specializedDetach() {
		kill();		
	}
	
	@Override
	public void setMotionStrategy() {
		this.motionStrategy=BrownianMotion.getInstance();		
	}
	public String assignName(){		
		return "Carrier_A";		
	}	
}
