
package simulator;


import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;

import MainLibrary.AbstractDomain;
import MainLibrary.CarrierObj;
import MainLibrary.LigandObserver;
import MainLibrary.nIdle;

import MainLibrary.NoMotion;

import MainLibrary.Receptor;

import MainLibrary.nTransmit;


public class TCPLike_Node_RX_BER extends TCPLike_Node_RX{
	
	protected String patternBER="";

	private long timeStartSignal=-1;	// timesteps
	
	
	private HashMap<String,String> evaluateRTT=new HashMap<String,String>();
	
	private HashMap<String,String> sendSTART=new HashMap<String,String>();
	private HashMap<String,String> sendBER=new HashMap<String,String>();
	
	private Random rand=new Random();

	
	
	public TCPLike_Node_RX_BER(AbstractDomain domain, float x, float y, float z, int nodeNumberType, List<LigandObserver> observer){
		super(domain,x,y,z,nodeNumberType,observer);			
		patternBER=Integer.toString((domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-patternBER").intValue()));
	}
	
	
	public void sendStart(){
		setState(new nTransmit(this));
		getState().setExecutionTime(0);
		System.out.println("======   SEND START (RX)  ======");
		
		isStillEmitting=true;
		indexPattern=0;
		countdownForEmission=0;		
		emissionPattern=patternSTART;
		hasJustStopped=false;
		
		sendSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(burstEmission));
	}
	
	public void sendStop(){
		
	}
	
	public void sendCut(){
		
	}
	
	
	public void sendBER(){
		setState(new nTransmitBER(this));
		System.out.println("======   SEND BER PATTERN (RX)  ======");
		
		isStillEmitting=true;
		indexPattern=0;
		
		emissionPattern=patternBER;
		hasJustStopped=false;
		
		
		
	}
	
	public void sendRandomBER(){
		setState(new nTransmitRandomBER(this));
		
		System.out.println("======   SEND RANDOM BER PATTERN (RX)  ======");
		
		isStillEmitting=true;
		indexPattern=0;
		
		hasJustStopped=false;
	}
	
	public void transmitBER(){
		
		long now=getManager().getCurrentTime();
		
		if((now-timeStartSignal)%windowSize==0){
			
			if (indexPattern>=emissionPattern.length()){			
				indexPattern=0;
			}
			
			
			int created=0;
			
			char currentBIT=emissionPattern.charAt(indexPattern);
			
			if(currentBIT=='1'){
				
				created=createCarriers(burstEmission);				
				System.out.println(">>> RX Releasing CARRIERS!!! (Control Node) "+created);				
							
			}else{
				System.out.println(">>> RX Releasing CARRIERS!!! (Control Node) "+created);
			}
			
			sendBER.put(Long.toString(now), String.valueOf(currentBIT));
			
			indexPattern++;
			
		}		
	}
	
	public void transmitRandomBER(){
		
		long now=getManager().getCurrentTime();
		
		if((now-timeStartSignal)%windowSize==0){
			
			
			boolean currentBIT_rand;
			char currentBIT;
			
			if (indexPattern==0){			
				indexPattern=1;
				
				currentBIT_rand=true;
				
			}else{
				currentBIT_rand=rand.nextBoolean();
			}
			
			int created=0;
						
			
			if(currentBIT_rand){
				currentBIT='1';
				created=createCarriers(burstEmission);				
				System.out.println(">>> RX Releasing CARRIERS!!! (Control Node) "+created);				
							
			}else{
				currentBIT='0';
				System.out.println(">>> RX Releasing CARRIERS!!! (Control Node) "+created);
			}
			
			sendBER.put(Long.toString(now), String.valueOf(currentBIT));
			
			//indexPattern++;			
		}		
	}
	
	@Override
	public void transmit() {
		
		if (indexPattern<emissionPattern.length()){
			countdownForEmission--;
			if(countdownForEmission<=0){

				int created=0;
				if(emissionPattern.charAt(indexPattern)=='1'){
					
					created=createCarriers(burstEmission);				
					System.out.println(">>> RX Releasing CARRIERS!!! (Control Node) "+created);
					if(timeStartSignal<0) timeStartSignal=getManager().getCurrentTime();
								
				}
				
				//FIXME New RTT Estimation
				if(indexPattern==emissionPattern.length()-1 && isWaitingForRTT && timerRTT<0){
					// The pattern has to start with a 1, otherwise it NEVER monitor the RTT!
					timerRTT=1;
					emissionLastSimbol_RTT=getManager().getCurrentTime();
				}
				
				
				if(releaseTimeLog.length<=indexReleaseLog){
					enlargeReleaseTimeLog();
				}
				releaseTimeLog[indexReleaseLog]=getManager().getCurrentTime();
				releaseCarrierLog[indexReleaseLog]=created;

				float[] center=getCenter();
				float[] domainCenter=getDomain().getAbsCenter();					

				float[] currentRelativePosition={center[0]-domainCenter[0],center[1]-domainCenter[1],center[2]-domainCenter[2]};
				releasePositions.add(currentRelativePosition);
				indexReleaseLog++;

				indexPattern++;
				countdownForEmission=timeForEmission;
				
				
				
			}
		}else{			
				isStillEmitting=false;				
				
				setState(new nIdle(this));
				getState().setExecutionTime(10);
				indexPattern=0;
				countdownForEmission=timeForEmission;
						
		}		
	} 
	
	
	
	public void enlargeReleaseTimeLog(){
		long[] temp=releaseTimeLog;
		int[] tempCarrier=releaseCarrierLog;
		int size=temp.length;
		size=size+size/2;
		
		releaseTimeLog=new long[size];
		releaseCarrierLog=new int[size];
		
		for(int i=0;i<temp.length;i++){
			releaseTimeLog[i]=temp[i];
			releaseCarrierLog[i]=tempCarrier[i];
		}		
	}
	

	
		
	@Override
	public Map<Object, Object> specializedExport() {

		Map<Object, Object> m=new HashMap<Object,Object>();
		
		
		
		if( evaluateRTT.size()>0 || sendSTART.size()>0 || sendBER.size()>0){
			m.put("Type", assignName());

			float[] center=new float[3];
			float[] domainCenter=getDomain().getAbsCenter();

			center=getCenter();		

			m.put("ID",  assignName()+"-"+ID);	
			m.put("X", center[0]-domainCenter[0]);
			m.put("Y", center[1]-domainCenter[1]);
			m.put("Z", center[2]-domainCenter[2]);
			
			
			
			int i=0;
			
			Iterator it = sendSTART.entrySet().iterator();
		    while (it.hasNext()) {
		        Map.Entry pairs = (Map.Entry)it.next();		        
		        
		        m.put("START_TimeStep_"+i, ""+pairs.getKey()+"");	
				m.put("START_Value_"+i, pairs.getValue());	
				m.put("START_Action_"+i, "send START");
				i++;
				
		    }
		    m.put("START_TOTAL", i);
		    sendSTART.clear();
		    
		    
		    i=0;
			
			Iterator itCUT = sendBER.entrySet().iterator();
		    while (itCUT.hasNext()) {
		        Map.Entry pairs = (Map.Entry)itCUT.next();		        
		        
		        m.put("BER_TimeStep_"+i, ""+pairs.getKey()+"");	
				m.put("BER_Value_"+i, pairs.getValue());	
				m.put("BER_Action_"+i, "send BIT");
				i++;
				
				//itCUT.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("BER_TOTAL", i);
		    sendBER.clear();
		    
		   
		    
		    i=0;

		    Iterator itRTT = evaluateRTT.entrySet().iterator();
		    while (itRTT.hasNext()) {
		    	Map.Entry pairs = (Map.Entry)itRTT.next();		        

		    	m.put("RTT_TimeStep_"+i, ""+pairs.getKey()+"");	
		    	m.put("RTT_Value_"+i, pairs.getValue());	
		    	m.put("RTT_Action_"+i, "RTT");
		    	i++;

		    	//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("RTT_TOTAL", i);
		    evaluateRTT.clear();
		    
			
			m.putAll(getState().export());
		}
		return m;
	}	
	
	
	
	
	@Override
	public void setMotionStrategy() {		
		//this.motionStrategy=BrownianMotion.getInstance();
		this.motionStrategy=NoMotion.getInstance();
	}
	
	
	
	public String assignName(){		
		return "TCPLike_BER-RX Node";		
	}
	
	public void exec(){
		
		try {
			timestep=getManager().getCurrentTime();
			//int bufferSize=circularBufferAssimilations.length;
			pos=(int) (timestep%windowSize);
			
			currentAssimilation=0;
			circularBufferAssimilations[pos]=0;
			
			
			super.exec();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	public void downloadInfoFrom(CarrierObj c, Receptor r){		
		informationCount++;	
		
		currentAssimilation++;
		circularBufferAssimilations[pos]=currentAssimilation;
		
		if (timeFirstAssimilation<0) timeFirstAssimilation=getManager().getCurrentTime();
		
		if(isWaitingForRTT && informationCount>=RTTAssimilationThreshold && c instanceof TCPLike_Carrier_A){
			
			//FIXME OLD RTT
			//estimatedRTT=timerRTT+timeForEmission;		// Added timeForEmission. Otherwise the RTT starts from the end of the emitted signal and not from the start!	
			
			//FIXME New RTT
			estimatedRTT=(int) (getManager().getCurrentTime()-emissionLastSimbol_RTT);
			
			
			isWaitingForRTT=false;
			//windowSize=estimatedRTT;	// FIXME Should be equal to the duration of the symbol emitted by the other node?
			circularBufferAssimilations= new int[windowSize]; 
			timerRTT=0;
			//waitingWindow=estimatedRTT+windowSize;
			evaluateRTT.put(Long.toString(getManager().getCurrentTime()), Long.toString(estimatedRTT));
			
			if(patternBER.equals("0")){
				sendRandomBER();
			}else{
				sendBER();		// STATE SWITCH!
			}			
		}		
		c.destroy();		
	}
	
	
	public void standardBehavior() {
		
		if(isFirstStart){
			isFirstStart=false;
			sendStart();			
		}	
		
		// CHECK TIMEOUT
		if(!isStillEmitting && isWaitingForRTT && timerRTT>=0){

			if(timerRTT<waitingTimeRTT-1){

				timerRTT++;
			}else{
				
				burstEmission=burstEmission+1000;
				timerRTT=-1;
				sendStart();	// Sets the internal state to TRANSMIT, so on the next timestep will start the emission!
			}	
		}
		// END CHECK TIMEOUT
		

		try {
			emitsWithoutReceptors();
			//emitsWithoutReceptorsForDEBUG();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	public void standardBehavior_BAK() {
				
		
		if(isFirstStart){
			isFirstStart=false;
			sendStart();			
		}
		
		t_now=getManager().getCurrentTime();
		
		
		
		// ========================================
		// WAITS FOR THE RTT AFTER THE START SIGNAL
		// ========================================
		if(!isStillEmitting){
			if(isWaitingForRTT && timerRTT>=0){

				if(timerRTT<waitingTimeRTT-1){
					
					timerRTT++;
				}else{				
					//sendBER();					
				}	

			}else if (informationCount>0){

				// ====================================
				// MONITOR THE ASSIMILATIONS FOR THE RTT AFTER "START" SIGNAL
				// ====================================

				if (!estimationInitialized){					

					ta=timeFirstAssimilation;
					N_prev=informationCount;
					t_prev=ta;
					N_cut=informationCount;
					t_cut=ta;
					timeStop=(patternSTOP.length()-1)*timeForEmission;
					timeCut=(patternCUT.length()-1)*timeForEmission;

					estimationInitialized=true;					
				}



				if(wait2RTTAfterSTOP){
					if(waitAfterSTOP>=2*estimatedRTT){
						wait2RTTAfterSTOP=false;
						waitAfterSTOP=0;
					}else{
						waitAfterSTOP++;
					}
				}else{

					if(isScheduledNextCheck){					
						if(wait>=scheduledWindow){
							isScheduledNextCheck=false;
							wait=0;
						}else{
							wait++;
						}
					}


					if(estimator.equals("Q")){
						quadraticEstimation();
					}else{
						linearEstimation();
					}				
				}
			}
		}


		try {
			emitsWithoutReceptors();
			//emitsWithoutReceptorsForDEBUG();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}	
}