package simulator;


import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import MainLibrary.AbstractDomain;
import MainLibrary.CarrierObj;
import MainLibrary.LigandObserver;
import MainLibrary.NoMotion;
import MainLibrary.NodeObj;
import MainLibrary.Receptor;
import MainLibrary.InnerSphericalStrategy;
import MainLibrary.nEncode;
import MainLibrary.nIdle;
import MainLibrary.nTransmit;



public class TCPLike_Node_TX extends NodeObj{

	public int carrierCreated=0;
	
	public int lastPacketCreated=0;
	
	//private boolean hasExported=false;
	
	
	// === TCP parameters ===
	protected int currentEmission=0;
	private int currentAssimilation=0;		// for the circular buffer
	private int assimilationThreshold=1;
	

	protected int shutDown=10;
	
	/*
	private boolean isTheFirstAssimilation=true;
	private long firstAssimilationTime=0;
	*/

	// === New Sync ===
	protected int waitTemp=0;
	protected boolean waitCondition=false;
	protected int ii=0;
	protected int Tk=0;
	protected int Tstar=0;
	protected int Tsync;
	protected long dati_max=0;
	protected boolean tk_done=false;
	// === END new sync ===
	
	
	// Check Assimilation Pattern
	protected boolean isEmitting=false;
	private int assimilationPointer=0;
	protected int waitingWindow=0;
	private String patternSTART="";
	private String patternSTOP="";
	private String patternCUT="";
	private String assimilatedMessage="";
	
	protected String evaluatingMessage="";
	protected boolean waitAfterReceivedCommand=false;
	protected boolean sync=false;
	protected boolean syncTemp=false;
	
	
	public String currentEmissionStrategy="HALVE";
	public String timeForEmissionStrategy="NOCHANGE";
	
	private boolean hasTimeCome=false;
	
			
	private long timestep=0;
	protected int windowSize=100;
	private int pos=0;
	
	private int lastCount=0;
	private int[] circularBufferAssimilations= new int[windowSize]; 

	
	//private int[] circularBufferAssimilationsTemp= new int[Math.round(windowSize/1000)]; 
	
	
	protected boolean delayedShutdown=false;
	protected long waitForShutdown=0;
	

	long globalEmission=0;
	
	protected long timeForEmission=0;
	long countdownForEmission=0;
	
	long currentWindowAssimilation=0;
	
	public long emissionThresholdUpperBound=0;
	
	
	private HashMap<String,String> evaluateSTART=new HashMap<String,String>();
	private HashMap<String,String> evaluateCUT=new HashMap<String,String>();
	private HashMap<String,String> evaluateSTOP=new HashMap<String,String>();
	
	private HashMap<String,String> receivedSTART=new HashMap<String,String>();
	private HashMap<String,String> receivedCUT=new HashMap<String,String>();
	private HashMap<String,String> receivedSTOP=new HashMap<String,String>();
	
	private HashMap<String,String> totalEmissionAtSTOP=new HashMap<String,String>();
	
	private HashMap<String,String> tempReceivedSTART=new HashMap<String,String>();
	private HashMap<String,String> tempReceivedCUT=new HashMap<String,String>();
	private HashMap<String,String> tempReceivedSTOP=new HashMap<String,String>();
	
	public int firstEmission=1;
	
	public int transmittedPacketType=1;
	
	
	public TCPLike_Node_TX(AbstractDomain domain, float x, float y, float z, int nodeNumberType, long emissionThreshold, List<LigandObserver> observer){
		super(domain,x,y,z,nodeNumberType,observer);

		// You can set the internal state here!
		
		setState(new nIdle(this));
		getState().setExecutionTime(1);
		
		/*
		setState(new nTransmit(this));
		getState().setExecutionTime(1);
		*/
		getInnerDomain().setCollisionStrategy(new InnerSphericalStrategy(0));
		
		emissionThresholdUpperBound=emissionThreshold;
		
		// Load last configuration values...
		try{
			if(domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-timeForEmission") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-patternSTART") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-patternSTOP") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-patternCUT") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-assimilationThreshold") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-timeForAssimilation")){
				timeForEmission=domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-timeForEmission").longValue();
				assimilationThreshold=domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-assimilationThreshold").intValue();
				windowSize=domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-timeForAssimilation").intValue();	
				patternSTART=Integer.toString(domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-patternSTART").intValue());	
				patternSTOP=Integer.toString(domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-patternSTOP").intValue());	
				patternCUT=Integer.toString(domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-patternCUT").intValue());	
				firstEmission=(domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-firstEmission").intValue());	
				currentEmission=firstEmission;			
				
			}else{
				throw new Exception();
			}
		} catch (Exception e) {
			System.out.println();
			System.out.println(">>> WARNING! The NODES have not well configured! (Check config.xml)");
			System.out.println();
			System.out.println("    The simulation ends now");
			System.out.println();
			e.printStackTrace();
			System.exit(0);
		}			
		
		// Has to be configured by XML configuration file !
		circularBufferAssimilations= new int[windowSize]; 
	}	
	
	@Override
	public boolean mandatoryCreation(){
		return true;
	}

	@Override	
	public void standardBehavior() {
		/*
		if(informationCount>lastCount){
			//System.out.println("TX NODE ASSIMILATIONS: "+informationCount);
			lastCount=informationCount;
		}*/
		
		
		/*
		// Detects the pattern emitted by the other node! e.g. 1011
		if (getCircularBufferAssimilationSum()>=assimilationThreshold){
			setState(new nTransmit(this));
			getState().setExecutionTime(0);
		}*/
		
		/*
		if(hasTimeCome){
			setCurrentEmission(currentEmissionStrategy);
			setTimeForEmision(timeForEmissionStrategy);
			int ok=0;
		}else{
			
			System.out.println("currentEmissionStrategy: "+currentEmissionStrategy);
			System.out.println("timeForEmissionStrategy: "+timeForEmissionStrategy);
			hasTimeCome=true;
		}
		*/
		
		if(!delayedShutdown){
			checkAssimilationPattern();
		}else{
			if(waitForShutdown>=shutDown*windowSize){
				getManager().hasStopped=true;
			}else{
				waitForShutdown++;
			}
		}
		
		
		emitsWithoutReceptors();	
		//emitsWithoutReceptorsDEBUG2();	
		//emitsWithoutReceptorsForDEBUG();
	}
	
	public char getAssimilatedBit(){
		char result='0';
		
		currentWindowAssimilation=getCircularBufferAssimilationSum();
		
		if (currentWindowAssimilation>=assimilationThreshold){
			result='1';
			
		}
		/*
		if(assimilationPointer>0 || result=='1'){
			System.out.println();
			System.out.println("   ===TX===   ");
			System.out.println("   |   "+result+"  |   ");
			System.out.println("   ===TX===   ");
			System.out.println();
		}
		*/
		return result;
	}
	
	public void checkIncomingCarrier(CarrierObj c){				

		if (!(c instanceof TCPLike_Carrier_A)){
			
			boolean catched=false;
			float x,  y,  z,  r;
			r=(float) c.getRadius();
			float[] coords=null;

			// Verifies the reception of the ligand near receptors

			// FIXME DEBUG - RELOCATES THE CARRIER ON THE NODE SURFACE
			float dt=(float) getCollisionTime(c);
			float[] velocity=c.getVelocityComponent();
			// Carrier Coords on the Node External Surface
			x=c.getCenter()[0]-velocity[0]*dt;
			y=c.getCenter()[1]-velocity[1]*dt;
			z=c.getCenter()[2]-velocity[2]*dt;	
			// FINE FIXME


			// External Domain!
			for (int i=0;i<receptorList.size() && !catched;i++){
				if((receptorList.get(i).isFree() && receptorList.get(i).canDownload())){					
					coords=receptorList.get(i).getAbsoluteCoords();
					float dim=receptorList.get(i).radius;								
					float dx = (coords[0]-x), dy = (coords[1]-y), dz= (coords[2]-z);
					float distance =(float) Math.sqrt(dx*dx+dy*dy+dz*dz);									
					if (distance<((dim+r)) && (receptorList.get(i).checkCarrierCompatibility(c))){							
						catched=true;
						receptorList.get(i).configureForDownload(c);							
					}
				}
			}

			if(!catched){		
				getDomain().getMobilityModel().relocateObjs(c,this);
			}

		}else{			

			getDomain().getMobilityModel().relocateObjs(c,this);
		}
	}

	
	public void checkAssimilationPattern(){

		/*
		//FIXME OLD implementation
		String currentPattern="";
		if(!isEmitting){
			currentPattern=patternSTART;
		}else{
			currentPattern=patternSTOP;
		}*/
		
		
		//FIXME NEW implementation
		String[] currentPattern={patternSTART};
		if(isEmitting){			
			currentPattern=new String[]{patternCUT,patternSTOP};	
			//currentPattern=new String[]{patternSTOP};				// FIXME Disable CUT message
		}

		
		//if (assimilationPointer==0 && !waitAfterReceivedCommand){
		if (!sync && !waitAfterReceivedCommand){
			
			//FIXME OLD implementation
			evaluateBuffer(currentPattern);
			
			//FIXME NEW implementation
			//hasKnownMessage(currentPattern);

		}else if(waitingWindow<windowSize-1){
			
			//if (waitingWindow==0) System.out.println(" >>>  (TX) WINDOW STARTS: "+getManager().getCurrentTime());
			waitingWindow++;				
		}else{
			//System.out.println(" >>>  (TX) WINDOW ENDS: "+getManager().getCurrentTime());
			waitAfterReceivedCommand=false;
			
			//FIXME OLD implementation
			evaluateBuffer(currentPattern);
			
			//FIXME NEW implementation
			//hasKnownMessage(currentPattern);
		}
	}

	
	public void resetCircularBuffer(){
		//long count=getCircularBufferAssimilationSum();		
		circularBufferAssimilations=new int[windowSize];
	}	
	
	public void evaluateBuffer_BAK(String currentPattern){
		
		char currentAssimilation=getAssimilatedBit();
		char charOfPattern=currentPattern.charAt(assimilationPointer);

		//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
		
		if(!isEmitting){
			// ==========================
			// WAITS for the START message
			// ==========================
			
			if(charOfPattern==currentAssimilation){
				assimilatedMessage=assimilatedMessage+""+currentAssimilation;
				//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
				
				assimilationPointer++;
				waitingWindow=0;			// WAITS FOR THE NEXT BIT (THE BUFFER WILL BE EMPTY)
				// RESET the Circular Buffer
				//circularBufferAssimilations=new int[windowSize];
				//resetCircularBuffer();

				tempReceivedSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
				
				if(assimilatedMessage.equals(patternSTART)){
			
					
					System.out.println("===========================");
					System.out.println("TX - START MESSAGE RECEIVED!   Emits at: "+getManager().getCurrentTime());
					System.out.println("===========================");
					
					isEmitting=true;
					assimilationPointer=0;					
					assimilatedMessage="";

					resetCircularBuffer();					
					
					receivedSTART.putAll(tempReceivedSTART);
					tempReceivedSTART.clear();
					
					evaluateSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(burstEmission));
					
					setState(new nTransmit(this));
					getState().setExecutionTime(0);	

				}else if (assimilationPointer>=currentPattern.length()){
					
					tempReceivedSTART.clear();
					
					if(((byte)currentPattern.charAt(0))==currentAssimilation){
						assimilationPointer=1;
						waitingWindow=0;
						assimilatedMessage=""+currentAssimilation;
						
						
						tempReceivedSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
						
					}else{
						assimilationPointer=0;
						waitingWindow=0;
						assimilatedMessage="";
					}
				}			
				
			}else{
				// The received bits do not fit! anyway, if the current bit is equal to the first of the pattern, it will be kept and the following comparisons will start from the secondo bit
				
				//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
				tempReceivedSTART.clear();
				
				if(((byte)currentPattern.charAt(0))==currentAssimilation){
					assimilationPointer=1;
					waitingWindow=0;
					assimilatedMessage=""+currentAssimilation;
					
					tempReceivedSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
					
					//assimilatedMessageDEBUG=""+currentAssimilation;
					
					//resetCircularBuffer();
					
				}else{
					assimilationPointer=0;
					waitingWindow=0;
					assimilatedMessage="";
					//assimilatedMessageDEBUG="";
					
					//resetCircularBuffer();
				}					
			}
				
		}else{
			// ===============================
			// WAITS for STOP or CUT
			// ===============================
		
			// Highest priority on CUT message
			if(assimilationPointer<patternCUT.length()){
				char charOfPatternCUT=patternCUT.charAt(assimilationPointer);
				
				if(charOfPatternCUT==currentAssimilation){
					assimilatedMessage=assimilatedMessage+""+currentAssimilation;
					//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
					
					assimilationPointer++;
					waitingWindow=0;			// WAITS FOR THE NEXT BIT (THE BUFFER WILL BE EMPTY)
					// RESET the Circular Buffer
					//circularBufferAssimilations=new int[windowSize];
					//resetCircularBuffer();
					
					tempReceivedCUT.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
				
					if(assimilatedMessage.equals(patternCUT)){
						isEmitting=true;
						assimilationPointer=0;					
						assimilatedMessage="";

						currentEmission=currentEmission/2;
						
						
						System.out.println("===========================");
						System.out.println("TX - CUT MESSAGE RECEIVED! "+currentEmission);
						System.out.println("===========================");
						
						receivedCUT.putAll(tempReceivedCUT);
						tempReceivedCUT.clear();
						
						evaluateCUT.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentEmission));
						
						resetCircularBuffer();
					
					}					
				}else{
					// The received bits do not fit! anyway, if the current bit is equal to the first of the pattern, it will be kept and the following comparisons will start from the secondo bit
					
					int assLengthTemp=assimilatedMessage.length();
					//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
					
					if(currentPattern.substring(0, assLengthTemp).equals(assimilatedMessage) && currentPattern.charAt(assimilationPointer)==currentAssimilation){
						assimilationPointer++;
						waitingWindow=0;
						assimilatedMessage=assimilatedMessage+""+currentAssimilation;
						
						System.out.println();
						System.out.println(">>> -1-  I BIT NON COMBACIANO! LO APPOGGIO ALLO STOP! <<<");
						System.out.println();
						
						tempReceivedSTOP.putAll(tempReceivedCUT);
						//assimilatedMessageDEBUG=assimilatedMessageDEBUG+currentAssimilation;
						
						
						tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
						
						tempReceivedCUT.clear();
						//resetCircularBuffer();
						
					}else{
						assimilationPointer=0;
						waitingWindow=0;
						assimilatedMessage="";
						//assimilatedMessageDEBUG="";
						tempReceivedCUT.clear();
						tempReceivedSTOP.clear();
						//resetCircularBuffer();
					}					
				}
					
			}else {
				int assLength=assimilatedMessage.length();				
				if(assimilatedMessage.equals(patternSTOP.substring(0, assLength))){
					if(charOfPattern==currentAssimilation){
						assimilatedMessage=assimilatedMessage+""+currentAssimilation;
						//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
						
						assimilationPointer++;
						waitingWindow=0;			// WAITS FOR THE NEXT BIT (THE BUFFER WILL BE EMPTY)
						// RESET the Circular Buffer
						//circularBufferAssimilations=new int[windowSize];
						//resetCircularBuffer();
						
						tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
						
						if(assimilatedMessage.equals(patternSTOP)){

							isEmitting=false;
							assimilationPointer=0;					
							assimilatedMessage="";

							setState(new nIdle(this));
							getState().setExecutionTime(0);	
							
							resetCircularBuffer();
							
							receivedSTOP.putAll(tempReceivedSTOP);
							tempReceivedSTOP.clear();
							
							evaluateSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentEmission));
							
							totalEmissionAtSTOP.put(Long.toString(getManager().getCurrentTime()), Integer.toString(carrierCreated));
							
							// FIXME DEBUG
							//System.exit(0);
							saveAllAndExit();

						}else if (assimilationPointer>=currentPattern.length()){
							
							tempReceivedSTOP.clear();
							
							if(((byte)currentPattern.charAt(0))==currentAssimilation){
								assimilationPointer=1;
								waitingWindow=0;
								assimilatedMessage=""+currentAssimilation;
								
								tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
							}else{
								assimilationPointer=0;
								waitingWindow=0;
								assimilatedMessage="";
								
							}
						}	
					}else{
						// The received bits do not fit! anyway, if the current bit is equal to the first of the pattern, it will be kept and the following comparisons will start from the secondo bit
						
						//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
						tempReceivedSTOP.clear();
						
						if(((byte)currentPattern.charAt(0))==currentAssimilation){
							
							tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));							
						
							assimilationPointer=1;
							waitingWindow=0;
							assimilatedMessage=""+currentAssimilation;							
							
							//resetCircularBuffer();
							
						}else{
							assimilationPointer=0;
							waitingWindow=0;
							assimilatedMessage="";
							
							//resetCircularBuffer();
						}					
					}
				}
			}			
		}
	}
	
	/** Return true if the assimilated message contains the pattern and, in that case, cuts the pattern and all of the provious bits
	 * from the assimilated message, in order to be ready for the next evaluations!
	 * @param pattern - the command (START , STOP or CUT)
	 * @return true if the pattern is contained in the assimilated message
	 */	
	public String hasKnownMessage(String[] patterns){

		boolean isFound=false;
		String result="";
		
		String checkingMessage=evaluatingMessage;		
		
		int patternsLength=patterns.length;
		
		String[] cuttingMessage=new String[patternsLength];
		boolean[] syncGlobal=new boolean[patternsLength];		
		
		for(int k=0;k<patternsLength;k++){			
			cuttingMessage[k]=evaluatingMessage;
			syncGlobal[k]=true;
		}
		
		if (sync){

			for(int k=0;k<patterns.length && !isFound;k++){				
				
				String pattern=patterns[k];
				
				checkingMessage=evaluatingMessage;					
				
				boolean done=false;

				while(!done){

					int size=checkingMessage.length();
					int syncIndex=checkingMessage.indexOf('1');

					int sizePattern=pattern.length();
					int diff=(size-syncIndex);					

					if (diff<sizePattern){
						// Ancora non ha assimilato abbastanza per confrontarlo con tutto il pattern
						String subPattern=pattern.substring(0, diff);
						int firstIndex=checkingMessage.indexOf(subPattern);

						if(firstIndex>-1){
							done=true;
							sync=true;
							cuttingMessage[k]=checkingMessage;
						}else{
							// il messaggio  corto e non ci sono corrispondenze con il pattern parziale. 
							// Taglia fino all'ultimo bit (per vedere se  di sync)
							if(checkingMessage.length()>1){
								checkingMessage=checkingMessage.substring(1, checkingMessage.length());								
								cuttingMessage[k]=checkingMessage;
							}
							
							else if(checkingMessage.length()==1){
								done=true;
								if(checkingMessage.charAt(0)=='1'){
									sync=true;
									cuttingMessage[k]=checkingMessage;
								}else{
									sync=false;
									checkingMessage="";									
									cuttingMessage[k]=checkingMessage;									
									syncGlobal[k]=false;
								}						
							}
						}
					}else{
						// La stringa assimilata  lunga almeno quanto il pattern
						int firstIndex=checkingMessage.indexOf(pattern);

						if (firstIndex>-1){					
							// Ha trovato corrispondenze			
							checkingMessage=checkingMessage.substring(firstIndex, checkingMessage.length());
							checkingMessage=checkingMessage.substring(sizePattern, checkingMessage.length());							
											
							cuttingMessage[k]=checkingMessage;
							
							isFound=true;
							done=true;
							result=pattern;

						}else{
							// NON ha trovato corrispondenze			
							if(checkingMessage.length()>1){
								checkingMessage=checkingMessage.substring(1, checkingMessage.length());								
								cuttingMessage[k]=checkingMessage;
							}
							
							else if(checkingMessage.length()==1){
								done=true;
								if(checkingMessage.charAt(0)=='1'){
									sync=true;
									cuttingMessage[k]=checkingMessage;
								}else{
									sync=false;
									checkingMessage="";									
									cuttingMessage[k]=checkingMessage;								
									syncGlobal[k]=false;
								}						
							}				
						}			
					}
				}
			}
		}
		
		int max=0;
		int index=0;	
		boolean tempSync=sync;
		
		for(int c=0;c<cuttingMessage.length;c++){
			if(cuttingMessage[c]==null) cuttingMessage[c]="";
			if(cuttingMessage[c].length()>=max){
				max=cuttingMessage[c].length();
				index=c;
			}				
			//sync=syncGlobal[c]||sync;
			tempSync=syncGlobal[c]||tempSync;
		}		
		evaluatingMessage=cuttingMessage[index];
		if(isFound) evaluatingMessage="";	
		
		if(sync) sync=tempSync; 
		
		//return isFound;
		return result;
	}
	
	public void evaluateBuffer(String[] currentPattern){

		char currentAssimilation=getAssimilatedBit();

		
		
		if(sync){
			long now=getManager().getCurrentTime();
			evaluatingMessage=evaluatingMessage+""+currentAssimilation;
			System.out.println("synk ok - "+evaluatingMessage+"   @ "+now);
			

		}else{ 
			/*
			//FIXME OLD implementation for sync
		    if(!sync && currentAssimilation=='1'){			    	
		    	evaluatingMessage=""+currentAssimilation;
		    	sync=true;
		    	long now=getManager().getCurrentTime();
		    	System.out.println("synk ok - "+evaluatingMessage+"   @ "+now);
		    	}
			 */

			// FIXME New implementation for sync
			int kk=20;
			if(!syncTemp && currentAssimilation=='1'){

				syncTemp=true;
				waitCondition=true;
				waitTemp=0;

				ii=0;
				Tk=windowSize/kk;		// windowSize is Ts!
				Tstar=0;
				Tsync=Tstar;
				dati_max=getCircularBufferAssimilationSum();
				tk_done=false;
			}

			if(waitCondition){

				if(waitTemp<Tk){
					waitTemp++;
				}else{

					waitTemp=0;

					

					//while((ii<kk) && (!done)){
					if(ii<kk && !tk_done){
						long currentWindowAssimilation=getCircularBufferAssimilationSum();
						if (currentWindowAssimilation>=dati_max){
							Tsync=Tstar+ii*Tk;
							dati_max=currentWindowAssimilation;
							ii++;
						}else{
							tk_done=true;
						}
					}else{
						tk_done=true;
					}
					//} // end while

					if(tk_done){
						sync=true;
						syncTemp=false;
						waitCondition=false;
						waitTemp=0;
						waitingWindow=Tsync;

						evaluatingMessage="1";				    	
						long now=getManager().getCurrentTime();
						System.out.println("synk ok - "+evaluatingMessage+"   @ "+now);
					}
				}
			}
		}


		

		/*
		System.out.println("===========================");
		System.out.println("Evaluating Message: "+evaluatingMessage);
		System.out.println("===========================");
		*/
		String incomingMessage=hasKnownMessage(currentPattern);


		if(!isEmitting){
			// ==========================
			// Valuta il messaggio START
			// ==========================			

			if(incomingMessage.equals(patternSTART)){
				waitingWindow=0;	// WAITS for the next bit

				//tempReceivedSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
				tempReceivedSTART.put(Long.toString(getManager().getCurrentTime()), patternSTART);

				System.out.println("===========================");
				System.out.println("TX - START MESSAGE RECEIVED!   Emits at: "+getManager().getCurrentTime());
				System.out.println("===========================");


				isEmitting=true;
				//assimilationPointer=0;					
				//assimilatedMessage="";
				waitAfterReceivedCommand=true;
				sync=false;

				receivedSTART.putAll(tempReceivedSTART);
				tempReceivedSTART.clear();

				evaluateSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(burstEmission));

				setState(new nTransmit(this));
				getState().setExecutionTime(0);	
			}else{
				
				waitingWindow=0;
			}
		}		

		else{
			
			// ===============================
			// Valuta il messaggio CUT
			// ===============================
			if(incomingMessage.equals(patternCUT)){


				waitingWindow=0;	// WAITS for the next bit!

				//tempReceivedCUT.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
				tempReceivedCUT.put(Long.toString(getManager().getCurrentTime()), patternCUT);

				isEmitting=true;
				assimilationPointer=0;					
				waitAfterReceivedCommand=true;
				sync=false;

				// ================================================================
				// FIXME THE FOLLOWING LINE IS COMMENTED BECAUSE WE HAVE INTRODUCED 
				// THE setCurrentEmission() and setTimeForEmission() METHODS!
				//currentEmission=currentEmission/2;
				setCurrentEmission(currentEmissionStrategy);
				setTimeForEmision(timeForEmissionStrategy);
				// ================================================================
				
				

				System.out.println("===========================");
				System.out.println("TX - CUT MESSAGE RECEIVED! "+currentEmission);
				System.out.println("===========================");

				receivedCUT.putAll(tempReceivedCUT);
				tempReceivedCUT.clear();

				evaluateCUT.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentEmission));
				
			}else {

				// ===============================
				// EVALUATE STOP message
				// ===============================

				if(incomingMessage.equals(patternSTOP)){				



					waitingWindow=0;	// WAITS for the next bit 


					//tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
					tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), patternSTOP);
					

					isEmitting=false;
					assimilationPointer=0;	

					waitAfterReceivedCommand=true;
					sync=false;


					setState(new nIdle(this));
					getState().setExecutionTime(0);					


					System.out.println("===========================");
					System.out.println("TX - STOP MESSAGE RECEIVED!");
					System.out.println("===========================");

					receivedSTOP.putAll(tempReceivedSTOP);
					tempReceivedSTOP.clear();

					evaluateSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentEmission));

					totalEmissionAtSTOP.put(Long.toString(getManager().getCurrentTime()), Integer.toString(carrierCreated));


					saveAllAndExit();				
				}else{
					waitingWindow=0;
				}
			}
		}	
	}
	
	private enum Command {
	    RESTART, HALVE, NOCHANGE, DOUBLE;
	}
	
	public void setCurrentEmission(String value){

		Command cmd = Command.valueOf(value); // surround with try/catch

		switch (cmd) {
		case RESTART:  currentEmission=1;
		break;
		
		case HALVE:  currentEmission=currentEmission/2;
		break;
		
		case NOCHANGE:  //currentEmission=currentEmission;
		break;
		
		default: currentEmission=currentEmission/2;
		break;

		}
	}
	
	public void setTimeForEmision(String value){
		Command cmd = Command.valueOf(value); // surround with try/catch

		switch (cmd) {
		case DOUBLE:
			countdownForEmission=countdownForEmission+timeForEmission;
			timeForEmission=timeForEmission*2;			
		break;
		
		case NOCHANGE:  //timeForEmission=timeForEmission;
		break;
		
		default: //timeForEmission=timeForEmission;
		break;
		}
	}

	public long getCircularBufferAssimilationSum(){
		long sum=0;
		int size=circularBufferAssimilations.length;
		
		for(int i=0;i<size;i++){
			sum=sum+circularBufferAssimilations[i];
		}
		
		return sum;
	}
	
	public void emitsWithoutReceptorsForDEBUG(){
		
		float theta=0;
		float fi=0;			
		
		int undisposedCarriers=getInnerDomain().undisposedCarrierList.size();

		
		for(int i=undisposedCarriers-1;i>=0;i--){		
			
			
			if(getDomain()==null){
				System.out.println();
				System.out.println("*** TCP_NODE_TX: emitsWithoutReceptors() -> DOMINIOP DEL NODO = NULL!");
				System.out.println();
			}
		
			CarrierObj carrier=getInnerDomain().undisposedCarrierList.get(i);			
			carrier.removeFromActualDomain();
			//carrier.setDomain(getDomain());  


			float ffi=0;
			float ttheta=1;
			
			fi=(float) (2*Math.PI*(ffi)); //fi
			theta=(float) ((Math.acos((2*ttheta)-1))); //theta

			double radius=getRadius();	
			radius=radius+2*carrier.getRadius();
			float[] coords=new float[3];
			coords[0]=(float) (radius*Math.sin((double)theta)*Math.cos((double)fi));
			coords[1]=(float) (radius*Math.sin((double)theta)*Math.sin((double)fi));
			coords[2]=(float) (radius*Math.cos((double)theta));		


			float[] nodeCenter=getCenter();			
			float x=coords[0]+nodeCenter[0];
			float y=coords[1]+nodeCenter[1];
			float z=coords[2]+nodeCenter[2];		



			//if (getDomain().isFreeSpace(carrier)){			
			getDomain().attachNanoObj(carrier);
			carrier.disposeOnMedium();
			//getInnerDomain().undisposedCarrierList.remove(carrier);	

			//}else{			
			//	System.out.println(">>> Delayed Upload: "+getProcessingTime());
			//}	

			carrier.setCenter(x, y, z);
			carrier.setVelocityComponent(carrier.getVelocityModule(), fi, theta);	
	
		}
		
		/*
		for (int i=0;i<undisposedCarriers;i++){				
			

		}*/
		getInnerDomain().undisposedCarrierList.clear();		
	}
	
	public void emitsWithoutReceptors(){
			
		float theta=0;
		float fi=0;			
		
		int undisposedCarriers=getInnerDomain().undisposedCarrierList.size();

		for(int i=undisposedCarriers-1;i>=0;i--){		
		
		//for (int i=0;i<undisposedCarriers;i++){				
			
			if(getDomain()==null){
				System.out.println();
				System.out.println("*** TCP_NODE_TX: emitsWithoutReceptors() -> DOMINIOP DEL NODO = NULL!");
				System.out.println();
			}
		
			CarrierObj carrier=getInnerDomain().undisposedCarrierList.get(i);	
			carrier.removeFromActualDomain();
			//carrier.setDomain(getDomain());  
			
			
			fi=(float) (2*Math.PI*(rand.nextFloat())); //fi
			theta=(float) ((Math.acos((2*rand.nextFloat())-1))); //theta

			double radius=getRadius();	
			radius=radius+2*carrier.getRadius();
			float[] coords=new float[3];
			coords[0]=(float) (radius*Math.sin((double)theta)*Math.cos((double)fi));
			coords[1]=(float) (radius*Math.sin((double)theta)*Math.sin((double)fi));
			coords[2]=(float) (radius*Math.cos((double)theta));		
			

			float[] nodeCenter=getCenter();			
			float x=coords[0]+nodeCenter[0];
			float y=coords[1]+nodeCenter[1];
			float z=coords[2]+nodeCenter[2];		




			//if (getDomain().isFreeSpace(carrier)){			
			getDomain().attachNanoObj(carrier);
			carrier.disposeOnMedium();
			//getInnerDomain().undisposedCarrierList.remove(carrier);	

			//}else{			
			//	System.out.println(">>> Delayed Upload: "+getProcessingTime());
			//}	

			carrier.setCenter(x, y, z);
			carrier.setVelocityComponent(carrier.getVelocityModule(), fi, theta);	
		}
		getInnerDomain().undisposedCarrierList.clear();		
	}
	
	
	public void emitsWithoutReceptorsDEBUG2(){
		
		float theta=0;
		float fi=0;			
		
		int undisposedCarriers=getInnerDomain().undisposedCarrierList.size();

		for(int i=undisposedCarriers-1;i>=0;i--){		
		
		//for (int i=0;i<undisposedCarriers;i++){				
			
			if(getDomain()==null){
				System.out.println();
				System.out.println("*** TCP_NODE_TX: emitsWithoutReceptors() -> DOMINIOP DEL NODO = NULL!");
				System.out.println();
			}
		
			CarrierObj carrier=getInnerDomain().undisposedCarrierList.get(i);	
			carrier.removeFromActualDomain();
			//carrier.setDomain(getDomain());  
			
			
			fi=(float) (1*Math.PI*(rand.nextFloat())); //fi
			theta=(float) ((Math.acos((0*rand.nextFloat())-1))); //theta

			double radius=getRadius();	
			radius=radius+2*carrier.getRadius();
			float[] coords=new float[3];
			coords[0]=(float) (radius*Math.sin((double)theta)*Math.cos((double)fi));
			coords[1]=(float) (radius*Math.sin((double)theta)*Math.sin((double)fi));
			coords[2]=(float) (radius*Math.cos((double)theta));		
			

			float[] nodeCenter=getCenter();			
			float x=coords[0]+nodeCenter[0];
			float y=coords[1]+nodeCenter[1];
			float z=coords[2]+nodeCenter[2];		




			//if (getDomain().isFreeSpace(carrier)){			
			getDomain().attachNanoObj(carrier);
			carrier.disposeOnMedium();
			//getInnerDomain().undisposedCarrierList.remove(carrier);	

			//}else{			
			//	System.out.println(">>> Delayed Upload: "+getProcessingTime());
			//}	

			carrier.setCenter(x, y, z);
			carrier.setVelocityComponent(carrier.getVelocityModule(), fi, theta);	
		}
		getInnerDomain().undisposedCarrierList.clear();		
	}
	
	@Override
	public void idle() {	
		
		/* OLD BEFORE PATTERN - SEE standardBehaviour()!!!
		if (carrierCreated==0 && burstEmission>0){
			activateCell();
		} */
		getState().setExecutionTime(10);	
		
	}

	@Override
	public void decode() {
		setState(new nIdle(this));
	}

	@Override
	public void encode() {
		/* OLD BEFORE PATTERN - SEE standardBehaviour()!!!
		createCarriers(burstEmission);
		setState(new nTransmit(this));
		*/
		setState(new nIdle(this));
	}

	@Override
	public void searchNeighbor() {

	}

	@Override
	public void transmit() {		

		countdownForEmission--;
		if(countdownForEmission<=0){
			/*
			int created=0;
			created=createCarriers(currentEmission);		
			System.out.println(">>> TX Releasing CARRIERS!!!  "+created);
			*/
			
			createCarriers(currentEmission);	
			
			countdownForEmission=timeForEmission;
			
			if(emissionThresholdUpperBound>0 && currentEmission>=emissionThresholdUpperBound){
				
				// No further increments on the next emissions...
				/**/
				setState(new nIdle(this));
				getState().setExecutionTime(10);
								
				isEmitting=false;
				currentEmission=0;
				
			}else{
				currentEmission=currentEmission+burstEmission;		
			}			
			//globalEmission=globalEmission+currentEmission;
		}
	}
	
	public int getNextPacketType(){
		
		if(lastPacketCreated>=transmittedPacketType-1){
			lastPacketCreated=0;			
		}else{			
			lastPacketCreated=lastPacketCreated+1;
		}
		return lastPacketCreated;
	}

	public int createCarriers(int n){
		int createdNow=0;
		
		
		while (n>0){				
			TCPLike_Carrier_A cc=new TCPLike_Carrier_A(getInnerDomain(), this, getCenter()[0], getCenter()[1], getCenter()[2],3);			
			cc.setMotionStrategy(BrownianMotion.getInstance());
			
			/* LINEAR FOR DEBUG ONLY! 
			cc.setMotionStrategy(LinearMotion.getInstance());
			cc.setVelocityModule(5);
			*/
			
			
			n--;
			createdNow++;	
			cc.packetType=getNextPacketType();
		}
		carrierCreated=carrierCreated+createdNow;
		
		// RESET the Circular Buffer
		//circularBufferAssimilations=new int[windowSize];
		//resetCircularBuffer();		// PERCH c'era questo comando???
		
		return createdNow;
	}
		
	@Override
	public Map<Object, Object> specializedExport() {

		Map<Object, Object> m=new HashMap<Object,Object>();
		
		
		if(receivedSTART.size()>0 || receivedCUT.size()>0 || receivedSTOP.size()>0 || evaluateSTART.size()>0 || evaluateCUT.size()>0 || evaluateSTOP.size()>0){
			m.put("Type", "TCPLike-TX-Node");

			float[] center=new float[3];
			float[] domainCenter=getDomain().getAbsCenter();

			center=getCenter();		

			m.put("ID", "TCPLike-TX-Node-"+ID);	
			m.put("X", center[0]-domainCenter[0]);
			m.put("Y", center[1]-domainCenter[1]);
			m.put("Z", center[2]-domainCenter[2]);
			
			int i=0;
			
			Iterator it = receivedSTART.entrySet().iterator();
		    while (it.hasNext()) {
		        Map.Entry pairs = (Map.Entry)it.next();		        
		        
		        m.put("START_TimeStep_"+i, ""+pairs.getKey()+"");	
				m.put("START_Value_"+i, pairs.getValue());	
				m.put("START_Action_"+i, "receive START");
				i++;
				
				//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("START_TOTAL", i);
		    receivedSTART.clear();
		    
		    i=0;
			
			Iterator itCUT = receivedCUT.entrySet().iterator();
		    while (itCUT.hasNext()) {
		        Map.Entry pairs = (Map.Entry)itCUT.next();		        
		        
		        m.put("CUT_TimeStep_"+i, ""+pairs.getKey()+"");	
				m.put("CUT_Value_"+i, pairs.getValue());	
				m.put("CUT_Action_"+i, "receive CUT");
				i++;
				
				//itCUT.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("CUT_TOTAL", i);
		    receivedCUT.clear();
		    
		    i=0;
			
			Iterator itSTOP = receivedSTOP.entrySet().iterator();
		    while (itSTOP.hasNext()) {
		        Map.Entry pairs = (Map.Entry)itSTOP.next();		        
		        
		        m.put("STOP_TimeStep_"+i, ""+pairs.getKey()+"");	
				m.put("STOP_Value_"+i, pairs.getValue());	
				m.put("STOP_Action_"+i, "receive STOP");
				i++;
				
				//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("STOP_TOTAL", i);
		    receivedSTOP.clear();
		    
		    
		    i=0;
			
			Iterator itCarrierSTOP = totalEmissionAtSTOP.entrySet().iterator();
		    while (itCarrierSTOP.hasNext()) {
		        Map.Entry pairs = (Map.Entry)itCarrierSTOP.next();		        
		        
		        m.put("STOP_TotalCarrier_TimeStep_"+i, ""+pairs.getKey()+"");	
				m.put("STOP_TotalCarrier_Value_"+i, pairs.getValue());	
				m.put("STOP_TotalCarrier_Action_"+i, "Total emitted carrier at STOP");
				i++;
				
				//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("STOP_TotalCarrier_TOTAL", i);
		    totalEmissionAtSTOP.clear();
			

		    i=0;

		    Iterator itSTART2 = evaluateSTART.entrySet().iterator();
		    while (itSTART2.hasNext()) {
		    	Map.Entry pairs = (Map.Entry)itSTART2.next();		        

		    	m.put("START_Release_TimeStep_"+i, ""+pairs.getKey()+"");	
		    	m.put("START_Release_Value_"+i, pairs.getValue());	
		    	m.put("START_Release_Action_"+i, "release after START");
		    	i++;

		    	//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("START_Release_TOTAL", i);
		    evaluateSTART.clear();
		    
		  
		    
		    i=0;

		    Iterator itCUT2 = evaluateCUT.entrySet().iterator();
		    while (itCUT2.hasNext()) {
		    	Map.Entry pairs = (Map.Entry)itCUT2.next();		        

		    	m.put("CUT_Release_TimeStep_"+i, ""+pairs.getKey()+"");	
		    	m.put("CUT_Release_Value_"+i, pairs.getValue());	
		    	m.put("CUT_Release_Action_"+i, "after CUT");
		    	i++;

		    	//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("CUT_Release_TOTAL", i);
		    evaluateCUT.clear();
		    
		    
		    i=0;

		    Iterator itSTOP2 = evaluateSTOP.entrySet().iterator();
		    while (itSTOP2.hasNext()) {
		    	Map.Entry pairs = (Map.Entry)itSTOP2.next();		        

		    	m.put("STOP_Release_TimeStep_"+i, ""+pairs.getKey()+"");	
		    	m.put("STOP_Release_Value_"+i, pairs.getValue());	
		    	m.put("STOP_Release_Action_"+i, "after STOP");
		    	i++;

		    	//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("STOP_Release_TOTAL", i);
		    evaluateSTOP.clear();
		    
			
			m.putAll(getState().export());
		}
		return m;
	}	
		
	@Override
	public void createSingleReceptor(float[] cdCenter, float radius, short receptorRadius, int receptorType) {
		float[] angles=convertSphericalAngles(cdCenter[0],cdCenter[1],cdCenter[2], radius);
		float theta=angles[1];
		float fi=angles[0];

		
		Receptor r=new TCPLike_ReceptorB(this, true, cdCenter, theta, fi, receptorRadius, receptorType, this.eventHandler);
		receptorList.add(r);
		receptorSetup(r); 

		/** Draw each Receptor */
		/*
		for(int i=0; i<receptorList.size(); i++){
			((CD40UniversalReceptor) receptorList.get(i)).drawSmallPoint(receptorList.get(i).getParent());
		}
		*/		
	}
	
	public void createReceptor(int n){		

		Receptor r = null;		
		float theta=0;
		float fi=0;			

		for (int i=0;i<n;i++){
			theta=getDomain().getMobilityModel().getRandomAngles()[0];
			fi=getDomain().getMobilityModel().getRandomAngles()[1];		

			double radius=getRadius();			
			float[] coords=new float[3];
			coords[0]=(float) (radius*Math.sin((double)theta)*Math.cos((double)fi));
			coords[1]=(float) (radius*Math.sin((double)theta)*Math.sin((double)fi));
			coords[2]=(float) (radius*Math.cos((double)theta));			

			r=new TCPLike_ReceptorB(this, true, coords, theta, fi, getManager().configWrapper.receptorStateConfig.get(receptorNumberType+"-radius").shortValue(),receptorNumberType, this.eventHandler);
			receptorList.add(r);
			//receptorSetup(r);
			r.attachObs(r.getMyObserver());
		}
	}	

	@Override
	public void receptorSetup(Receptor r) {
		List<LigandObserver> obsList=getObsList();
		int index=rand.nextInt(obsList.size());
		r.attachObs(obsList.get(index));
	}

	@Override
	public void setMotionStrategy() {		
		this.motionStrategy=NoMotion.getInstance();
	}

	public float getAbsDistancePlusRadius(){
		float distance=0;
		if(receptorList.size()>0){
			distance=getAbsDistance()+getRadius()+receptorList.get(0).radius/2;
		}else{
			distance=getAbsDistance()+getRadius();
		}
		return distance;
	}

	public float getAbsDistanceMinusRadius(){
		float distance=0;
		if(receptorList.size()>0){
			distance=getAbsDistance()-getRadius()-receptorList.get(0).radius/2;
		}else{
			distance=getAbsDistance()-getRadius();
		}
		return distance;
	}

	public void activateCell() {
		//releaseTime=getManager().getCurrentTime();
		setState(new nEncode(this));
		getState().setExecutionTime(0);	
	}
	
	public void transmitNow() {
		//releaseTime=getManager().getCurrentTime();
		setState(new nTransmit(this));
		getState().setExecutionTime(0);	
	}

	public String assignName(){		
		return "TCPLike-TX Node";		
	}

	@Override
	public void processInfo() {
		// TODO Auto-generated method stub
		
	}
	
	public void exec(){
		
		timestep=getManager().getCurrentTime();
		//int bufferSize=circularBufferAssimilations.length;
		pos=(int) (timestep%windowSize);
		
		currentAssimilation=0;
		circularBufferAssimilations[pos]=0;
		
		
		super.exec();
	}
	
	public void downloadInfoFrom(CarrierObj c, Receptor r){		
		informationCount++;	
		currentAssimilation++;
		
		/** CIRCULAR BUFFER */
		/*
		long timestep=getManager().getCurrentTime();
		int size=circularBufferAssimilations.length;
		int pos=(int) (timestep%size);
		*/
		
		circularBufferAssimilations[pos]=currentAssimilation;
		/** END OF CIRCULAR BUFFER */
		
		/*
		if(isTheFirstAssimilation){
			isTheFirstAssimilation=false;
			firstAssimilationTime=getManager().getCurrentTime();			
		}*/
		
		c.destroy();		
	}
	
	public void saveAllAndExit(){		
		delayedShutdown=true;		
	}
}