package simulator;


import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import MainLibrary.AbstractDomain;
import MainLibrary.CarrierObj;
import MainLibrary.LigandObserver;
import MainLibrary.NoMotion;
import MainLibrary.NodeObj;
import MainLibrary.Receptor;
import MainLibrary.InnerSphericalStrategy;
import MainLibrary.nEncode;
import MainLibrary.nIdle;
import MainLibrary.nTransmit;



public class TCPLike_Node_TX_OnlyCUT extends NodeObj{

	public int carrierCreated=0;	
	
	//private boolean hasExported=false;
	
	
	// === TCP parameters ===
	private int currentEmission=0;
	private int currentAssimilation=0;		// for the circular buffer
	private int assimilationThreshold=1;
	
	// Check Assimilation Pattern
	private boolean isEmitting=false;
	private int assimilationPointer=0;
	private int waitingWindow=0;
	private String patternSTART="";
	private String patternSTOP="";
	private String patternCUT="";
	private String assimilatedMessage="";
	
	/*
	private byte[] totalAssimilationList=new byte[100000];
	private int listPos=0;
	*/
	//private String assimilatedMessageDEBUG="";
		
	long timestep=0;
	int windowSize=100;
	int pos=0;
	
	int lastCount=0;
	private int[] circularBufferAssimilations= new int[windowSize]; 

	private boolean synch=false;
	
	//int tempTx=1;
	//int globalEmission=0;
	
	private int timeForEmission=0;
	int countdownForEmission=0;
	
	long currentWindowAssimilation=0;
	
	public long emissionThresholdUpperBound=0;
	
	
	private HashMap<String,String> evaluateSTART=new HashMap<String,String>();
	private HashMap<String,String> evaluateCUT=new HashMap<String,String>();
	private HashMap<String,String> evaluateSTOP=new HashMap<String,String>();
	
	private HashMap<String,String> receivedSTART=new HashMap<String,String>();
	private HashMap<String,String> receivedCUT=new HashMap<String,String>();
	private HashMap<String,String> receivedSTOP=new HashMap<String,String>();
	
	private HashMap<String,String> tempReceivedSTART=new HashMap<String,String>();
	private HashMap<String,String> tempReceivedCUT=new HashMap<String,String>();
	private HashMap<String,String> tempReceivedSTOP=new HashMap<String,String>();
	
	
	public TCPLike_Node_TX_OnlyCUT(AbstractDomain domain, float x, float y, float z, int nodeNumberType, long emissionThreshold, List<LigandObserver> observer){
		super(domain,x,y,z,nodeNumberType,observer);

		// You can set the internal state here!
		/*
		setState(new nIdle(this));
		getState().setExecutionTime(1);
		*/
		
		setState(new nTransmit(this));
		getState().setExecutionTime(1);
		isEmitting=true;
		
		//FIXME DEBUG
		//isEmitting=true;
		
		
		getInnerDomain().setCollisionStrategy(new InnerSphericalStrategy(0));
		
		emissionThresholdUpperBound=emissionThreshold;
		
		// Load last configuration values...
		try{
			if(domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-timeForEmission") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-patternSTART") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-patternSTOP") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-patternCUT") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-assimilationThreshold") && domain.getManager().configWrapper.nodeConfig.containsKey(nodeNumberType+"-timeForAssimilation")){
				timeForEmission=domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-timeForEmission").intValue();
				assimilationThreshold=domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-assimilationThreshold").intValue();
				windowSize=domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-timeForAssimilation").intValue();	
				patternSTART=Integer.toString(domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-patternSTART").intValue());	
				patternSTOP=Integer.toString(domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-patternSTOP").intValue());	
				patternCUT=Integer.toString(domain.getManager().configWrapper.nodeConfig.get(nodeNumberType+"-patternCUT").intValue());	
				
				currentEmission=burstEmission;
				
			}else{
				throw new Exception();
			}
		} catch (Exception e) {
			System.out.println();
			System.out.println(">>> WARNING! The NODES have not well configured! (Check config.xml)");
			System.out.println();
			System.out.println("    The simulation ends now");
			System.out.println();
			e.printStackTrace();
			System.exit(0);
		}			
		
		// Has to be configured by XML configuration file !
		circularBufferAssimilations= new int[windowSize]; 
	}	
	
	@Override
	public boolean mandatoryCreation(){
		return true;
	}

	@Override	
	public void standardBehavior() {
		if(informationCount>lastCount){
			//System.out.println("TX NODE ASSIMILATIONS: "+informationCount);
			lastCount=informationCount;
		}
		
		
		/*
		// Detects the pattern emitted by the other node! e.g. 1011
		if (getCircularBufferAssimilationSum()>=assimilationThreshold){
			setState(new nTransmit(this));
			getState().setExecutionTime(0);
		}*/
		
		checkAssimilationPattern();
		
		emitsWithoutReceptors();	
		//emitsWithoutReceptorsForDEBUG();
	}
	
	public char getAssimilatedBit(){
		char result='0';
		
		currentWindowAssimilation=getCircularBufferAssimilationSum();
		
		if (currentWindowAssimilation>=assimilationThreshold){
			result='1';
			
		}

		if(assimilationPointer>0 || result=='1'){
			System.out.println();
			System.out.println("   ===TX===   ");
			System.out.println("   |   "+result+"  |   ");
			System.out.println("   ===TX===   ");
			System.out.println();
		}
		
		return result;
	}
	
	public void checkIncomingCarrier(CarrierObj c){				

		if (!(c instanceof TCPLike_Carrier_A)){
			
			boolean catched=false;
			float x,  y,  z,  r;
			r=(float) c.getRadius();
			float[] coords=null;

			// Verifies the reception of the ligand near receptors

			// FIXME DEBUG Relocate the carrier on the node surface
			float dt=(float) getCollisionTime(c);
			float[] velocity=c.getVelocityComponent();
			// Carrier Coords on the Node External Surface
			x=c.getCenter()[0]-velocity[0]*dt;
			y=c.getCenter()[1]-velocity[1]*dt;
			z=c.getCenter()[2]-velocity[2]*dt;	
			// FINE FIXME


			// External Domain!
			for (int i=0;i<receptorList.size() && !catched;i++){
				if((receptorList.get(i).isFree() && receptorList.get(i).canDownload())){					
					coords=receptorList.get(i).getAbsoluteCoords();
					float dim=receptorList.get(i).radius;								
					float dx = (coords[0]-x), dy = (coords[1]-y), dz= (coords[2]-z);
					float distance =(float) Math.sqrt(dx*dx+dy*dy+dz*dz);									
					if (distance<((dim+r)) && (receptorList.get(i).checkCarrierCompatibility(c))){							
						catched=true;
						receptorList.get(i).configureForDownload(c);							
					}
				}
			}

			if(!catched){	
				
				getDomain().getMobilityModel().relocateObjs(c,this);
			}

		}else{			

			getDomain().getMobilityModel().relocateObjs(c,this);
		}
	}

	
	public void checkAssimilationPattern(){

		String currentPattern="";

		if(!isEmitting){
			currentPattern=patternSTART;
		}else{
			currentPattern=patternSTOP;
		}

		currentPattern=patternCUT;
		
		if (assimilationPointer==0){
			
			evaluateBuffer(currentPattern);

		}else if(waitingWindow<windowSize-1){
			
			if (waitingWindow==0) System.out.println(" >>>  (TX) WINDOW STARTS: "+getManager().getCurrentTime());
			waitingWindow++;				
		}else{
			System.out.println(" >>>  (TX) WINDOW ENDS: "+getManager().getCurrentTime());
			evaluateBuffer(currentPattern);
			System.out.println(" >>>  (TX) ASSIMILATED FROM START: "+assimilatedMessage);			 			
			System.out.println();
		}
	}

	
	public void resetCircularBuffer(){
		//long count=getCircularBufferAssimilationSum();		
		circularBufferAssimilations=new int[windowSize];
	}
	
	public void evaluateBuffer(String currentPattern){
		
		char currentAssimilation=getAssimilatedBit();
		char charOfPattern=currentPattern.charAt(assimilationPointer);

		//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
		
		if(!isEmitting){
			// ==========================
			// WAITS FOR START MESSAGE
			// ==========================
			
			if(charOfPattern==currentAssimilation){
				assimilatedMessage=assimilatedMessage+""+currentAssimilation;
				//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
				
				assimilationPointer++;
				waitingWindow=0;			// WAITS FOR THE NEXT BIT (THE BUFFER WILL BE EMPTY)
				// RESET the Circular Buffer
				//circularBufferAssimilations=new int[windowSize];
				//resetCircularBuffer();

				tempReceivedSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
				
				if(assimilatedMessage.equals(patternSTART)){
			
					
					System.out.println("===========================");
					System.out.println("TX - START MESSAGE RECEIVED!   Emits at: "+getManager().getCurrentTime());
					System.out.println("===========================");
					
					isEmitting=true;
					assimilationPointer=0;					
					assimilatedMessage="";

					resetCircularBuffer();					
					
					receivedSTART.putAll(tempReceivedSTART);
					tempReceivedSTART.clear();
					
					evaluateSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(burstEmission));
					
					setState(new nTransmit(this));
					getState().setExecutionTime(0);	

				}else if (assimilationPointer>=currentPattern.length()){
					
					tempReceivedSTART.clear();
					
					if(((byte)currentPattern.charAt(0))==currentAssimilation){
						assimilationPointer=1;
						waitingWindow=0;
						assimilatedMessage=""+currentAssimilation;
						
						
						tempReceivedSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
						
					}else{
						assimilationPointer=0;
						waitingWindow=0;
						assimilatedMessage="";
					}
				}			
				
			}else{
				// Received bits do not fit! Anyway, if the actual value is equal to the 1 of the pattern, it will be kept and on the next control it will be compared with the second
								
				//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
				tempReceivedSTART.clear();
				
				if(((byte)currentPattern.charAt(0))==currentAssimilation){
					assimilationPointer=1;
					waitingWindow=0;
					assimilatedMessage=""+currentAssimilation;
					
					tempReceivedSTART.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
					
					//assimilatedMessageDEBUG=""+currentAssimilation;
					
					//resetCircularBuffer();
					
				}else{
					assimilationPointer=0;
					waitingWindow=0;
					assimilatedMessage="";
					//assimilatedMessageDEBUG="";
					
					//resetCircularBuffer();
				}					
			}
				
		}else{
			// ===============================
			// WAITS FOR STOP or CUT
			// ===============================
		
			// CUT message has the highest priority
			if(assimilationPointer<patternCUT.length()){
				char charOfPatternCUT=patternCUT.charAt(assimilationPointer);
				
				if(charOfPatternCUT==currentAssimilation){
					assimilatedMessage=assimilatedMessage+""+currentAssimilation;
					//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
					
					assimilationPointer++;
					waitingWindow=0;			// WAITS FOR THE NEXT BIT (THE BUFFER WILL BE EMPTY)
					// RESET the Circular Buffer
					//circularBufferAssimilations=new int[windowSize];
					//resetCircularBuffer();
					
					tempReceivedCUT.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
				
					if(assimilatedMessage.equals(patternCUT)){
						isEmitting=true;
						assimilationPointer=0;					
						assimilatedMessage="";

						currentEmission=currentEmission/2;
						
						
						System.out.println("===========================");
						System.out.println("TX - CUT MESSAGE RECEIVED! "+currentEmission);
						System.out.println("===========================");
						
						receivedCUT.putAll(tempReceivedCUT);
						tempReceivedCUT.clear();
						
						evaluateCUT.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentEmission));
						
						resetCircularBuffer();
					
					}					
				}else{
					// Received bits do not fit! Anyway, if the actual value is equal to the 1 of the pattern (STOP), it will be kept and on the next control it will be compared with the second
					
					int assLengthTemp=assimilatedMessage.length();
					//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
					
					if(currentPattern.substring(0, assLengthTemp).equals(assimilatedMessage) && currentPattern.charAt(assimilationPointer)==currentAssimilation){
						assimilationPointer++;
						waitingWindow=0;
						assimilatedMessage=assimilatedMessage+""+currentAssimilation;
												
						tempReceivedSTOP.putAll(tempReceivedCUT);
						//assimilatedMessageDEBUG=assimilatedMessageDEBUG+currentAssimilation;
						
						
						tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
						
						tempReceivedCUT.clear();
						//resetCircularBuffer();
						
					}else{
						assimilationPointer=0;
						waitingWindow=0;
						assimilatedMessage="";
						//assimilatedMessageDEBUG="";
						tempReceivedCUT.clear();
						tempReceivedSTOP.clear();
						//resetCircularBuffer();
					}					
				}
					
			}else {
				int assLength=assimilatedMessage.length();				
				if(assimilatedMessage.equals(patternSTOP.substring(0, assLength))){
					if(charOfPattern==currentAssimilation){
						assimilatedMessage=assimilatedMessage+""+currentAssimilation;
						//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
						
						assimilationPointer++;
						waitingWindow=0;				// WAITS FOR THE NEXT BIT (THE BUFFER WILL BE EMPTY)
						// RESET the Circular Buffer
						//circularBufferAssimilations=new int[windowSize];
						//resetCircularBuffer();
						
						tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
						
						if(assimilatedMessage.equals(patternSTOP)){

							isEmitting=false;
							assimilationPointer=0;					
							assimilatedMessage="";

							setState(new nIdle(this));
							getState().setExecutionTime(0);	
							
							resetCircularBuffer();
							
							System.out.println("===========================");
							System.out.println("TX - STOP MESSAGE RECEIVED!");
							System.out.println("===========================");
							
							receivedSTOP.putAll(tempReceivedSTOP);
							tempReceivedSTOP.clear();
							
							evaluateSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentEmission));
							
							// FIXME DEBUG
							//System.exit(0);
							saveAllAndExit();

						}else if (assimilationPointer>=currentPattern.length()){
							
							tempReceivedSTOP.clear();
							
							if(((byte)currentPattern.charAt(0))==currentAssimilation){
								assimilationPointer=1;
								waitingWindow=0;
								assimilatedMessage=""+currentAssimilation;
								
								tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
							}else{
								assimilationPointer=0;
								waitingWindow=0;
								assimilatedMessage="";
								
							}
						}	
					}else{
						// Received bits do not fit! Anyway, if the actual value is equal to the 1 of the pattern, it will be kept and on the next control it will be compared with the second
						
						//assimilatedMessageDEBUG=assimilatedMessageDEBUG+""+currentAssimilation;
						tempReceivedSTOP.clear();
						
						if(((byte)currentPattern.charAt(0))==currentAssimilation){
							
							tempReceivedSTOP.put(Long.toString(getManager().getCurrentTime()), Long.toString(currentWindowAssimilation));
							
							assimilationPointer=1;
							waitingWindow=0;
							assimilatedMessage=""+currentAssimilation;							
							
							//resetCircularBuffer();
							
						}else{
							assimilationPointer=0;
							waitingWindow=0;
							assimilatedMessage="";
							
							//resetCircularBuffer();
						}					
					}
				}
			}			
		}
	}
	
	public long getCircularBufferAssimilationSum(){
		long sum=0;
		int size=circularBufferAssimilations.length;
		
		for(int i=0;i<size;i++){
			sum=sum+circularBufferAssimilations[i];
		}
		
		return sum;
	}
	
	public void emitsWithoutReceptorsForDEBUG(){
		
		float theta=0;
		float fi=0;			
		
		int undisposedCarriers=getInnerDomain().undisposedCarrierList.size();

		
		for(int i=undisposedCarriers-1;i>=0;i--){		
			
			
			if(getDomain()==null){
				System.out.println();
				System.out.println("*** TCP_NODE_TX: emitsWithoutReceptors() -> DOMINIOP OF THE NODE = NULL!");
				System.out.println();
			}
		
			CarrierObj carrier=getInnerDomain().undisposedCarrierList.get(i);			
			carrier.removeFromActualDomain();
			//carrier.setDomain(getDomain());  


			float ffi=0;
			float ttheta=1;
			
			fi=(float) (2*Math.PI*(ffi)); //fi
			theta=(float) ((Math.acos((2*ttheta)-1))); //theta

			double radius=getRadius();	
			radius=radius+2*carrier.getRadius();
			float[] coords=new float[3];
			coords[0]=(float) (radius*Math.sin((double)theta)*Math.cos((double)fi));
			coords[1]=(float) (radius*Math.sin((double)theta)*Math.sin((double)fi));
			coords[2]=(float) (radius*Math.cos((double)theta));		


			float[] nodeCenter=getCenter();			
			float x=coords[0]+nodeCenter[0];
			float y=coords[1]+nodeCenter[1];
			float z=coords[2]+nodeCenter[2];		



			//if (getDomain().isFreeSpace(carrier)){			
			getDomain().attachNanoObj(carrier);
			carrier.disposeOnMedium();
			//getInnerDomain().undisposedCarrierList.remove(carrier);	

			//}else{			
			//	System.out.println(">>> Delayed Upload: "+getProcessingTime());
			//}	

			carrier.setCenter(x, y, z);
			carrier.setVelocityComponent(carrier.getVelocityModule(), fi, theta);	
	
		}
		
		/*
		for (int i=0;i<undisposedCarriers;i++){				
			

		}*/
		getInnerDomain().undisposedCarrierList.clear();		
	}
	
	public void emitsWithoutReceptors(){
			
		float theta=0;
		float fi=0;			
		
		int undisposedCarriers=getInnerDomain().undisposedCarrierList.size();

		for(int i=undisposedCarriers-1;i>=0;i--){		
		
		//for (int i=0;i<undisposedCarriers;i++){				
			
			if(getDomain()==null){
				System.out.println();
				System.out.println("*** TCP_NODE_TX: emitsWithoutReceptors() -> DOMINIOP OF THE NODE = NULL!");
				System.out.println();
			}
		
			CarrierObj carrier=getInnerDomain().undisposedCarrierList.get(i);	
			carrier.removeFromActualDomain();
			//carrier.setDomain(getDomain());  
			
			
			fi=(float) (2*Math.PI*(rand.nextFloat())); //fi
			theta=(float) ((Math.acos((2*rand.nextFloat())-1))); //theta

			double radius=getRadius();	
			radius=radius+2*carrier.getRadius();
			float[] coords=new float[3];
			coords[0]=(float) (radius*Math.sin((double)theta)*Math.cos((double)fi));
			coords[1]=(float) (radius*Math.sin((double)theta)*Math.sin((double)fi));
			coords[2]=(float) (radius*Math.cos((double)theta));		
			

			float[] nodeCenter=getCenter();			
			float x=coords[0]+nodeCenter[0];
			float y=coords[1]+nodeCenter[1];
			float z=coords[2]+nodeCenter[2];		




			//if (getDomain().isFreeSpace(carrier)){			
			getDomain().attachNanoObj(carrier);
			carrier.disposeOnMedium();
			//getInnerDomain().undisposedCarrierList.remove(carrier);	

			//}else{			
			//	System.out.println(">>> Delayed Upload: "+getProcessingTime());
			//}	

			carrier.setCenter(x, y, z);
			carrier.setVelocityComponent(carrier.getVelocityModule(), fi, theta);	
		}
		getInnerDomain().undisposedCarrierList.clear();		
	}
	
	@Override
	public void idle() {	
		
		/* OLD BEFORE PATTERN - SEE standardBehaviour()!!!
		if (carrierCreated==0 && burstEmission>0){
			activateCell();
		} */
		getState().setExecutionTime(10);	
		
	}

	@Override
	public void decode() {
		setState(new nIdle(this));
	}

	@Override
	public void encode() {
		/* OLD BEFORE PATTERN - SEE standardBehaviour()!!!
		createCarriers(burstEmission);
		setState(new nTransmit(this));
		*/
		setState(new nIdle(this));
	}

	@Override
	public void searchNeighbor() {

	}

	@Override
	public void transmit() {		

		countdownForEmission--;
		if(countdownForEmission<=0){
			/*
			int created=0;
			created=createCarriers(currentEmission);		
			System.out.println(">>> TX Releasing CARRIERS!!!  "+created);
			*/
			
			createCarriers(currentEmission);	
			
			countdownForEmission=timeForEmission;
			
			if(emissionThresholdUpperBound>0 && currentEmission>=emissionThresholdUpperBound){
				
				// No further increments on the next emissions...
				
			}else{
				currentEmission=currentEmission+1;		
			}
			
			//globalEmission=globalEmission+currentEmission;
		}
	
		//---
				
		//currentEmission=createCarriers(tempTx);
		
	}

	public int createCarriers(int n){
		int createdNow=0;
		while (n>0){				
			TCPLike_Carrier_A cc=new TCPLike_Carrier_A(getInnerDomain(), this, getCenter()[0], getCenter()[1], getCenter()[2],3);			
			cc.setMotionStrategy(BrownianMotion.getInstance());
			n--;
			createdNow++;			
		}
		carrierCreated=carrierCreated+createdNow;
		
		// RESET the Circular Buffer
		//circularBufferAssimilations=new int[windowSize];
		//resetCircularBuffer();
		
		return createdNow;
	}
		
	@Override
	public Map<Object, Object> specializedExport() {

		Map<Object, Object> m=new HashMap<Object,Object>();
		
		boolean hasToExport=false;
		long time=getManager().getCurrentTime();
		if(time%10000==0){
			hasToExport=true;
		}
		
		
		if(hasToExport || receivedSTART.size()>0 || receivedCUT.size()>0 || receivedSTOP.size()>0 || evaluateSTART.size()>0 || evaluateCUT.size()>0 || evaluateSTOP.size()>0){
			m.put("Type", "TCPLike-TX-Node");

			float[] center=new float[3];
			float[] domainCenter=getDomain().getAbsCenter();

			center=getCenter();		

			m.put("ID", "TCPLike-TX-Node-"+ID);	
			m.put("X", center[0]-domainCenter[0]);
			m.put("Y", center[1]-domainCenter[1]);
			m.put("Z", center[2]-domainCenter[2]);
			
			
			if(hasToExport){
				m.put("CRON_TimeStep", time+"");	
				m.put("CRON_Value", informationCount+"");	
				m.put("CRON_Action", "TX assimilation");		
			}
			
			
			int i=0;
			
			Iterator it = receivedSTART.entrySet().iterator();
		    while (it.hasNext()) {
		        Map.Entry pairs = (Map.Entry)it.next();		        
		        
		        m.put("START_TimeStep_"+i, ""+pairs.getKey()+"");	
				m.put("START_Value_"+i, pairs.getValue());	
				m.put("START_Action_"+i, "receive START");
				i++;
				
				//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("START_TOTAL", i);
		    receivedSTART.clear();
		    
		    i=0;
			
			Iterator itCUT = receivedCUT.entrySet().iterator();
		    while (itCUT.hasNext()) {
		        Map.Entry pairs = (Map.Entry)itCUT.next();		        
		        
		        m.put("CUT_TimeStep_"+i, ""+pairs.getKey()+"");	
				m.put("CUT_Value_"+i, pairs.getValue());	
				m.put("CUT_Action_"+i, "receive CUT");
				i++;
				
				//itCUT.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("CUT_TOTAL", i);
		    receivedCUT.clear();
		    
		    i=0;
			
			Iterator itSTOP = receivedSTOP.entrySet().iterator();
		    while (itSTOP.hasNext()) {
		        Map.Entry pairs = (Map.Entry)itSTOP.next();		        
		        
		        m.put("STOP_TimeStep_"+i, ""+pairs.getKey()+"");	
				m.put("STOP_Value_"+i, pairs.getValue());	
				m.put("STOP_Action_"+i, "receive STOP");
				i++;
				
				//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("STOP_TOTAL", i);
		    receivedSTOP.clear();
			

		    i=0;

		    Iterator itSTART2 = evaluateSTART.entrySet().iterator();
		    while (itSTART2.hasNext()) {
		    	Map.Entry pairs = (Map.Entry)itSTART2.next();		        

		    	m.put("START_Release_TimeStep_"+i, ""+pairs.getKey()+"");	
		    	m.put("START_Release_Value_"+i, pairs.getValue());	
		    	m.put("START_Release_Action_"+i, "release after START");
		    	i++;

		    	//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("START_Release_TOTAL", i);
		    evaluateSTART.clear();
		    
		  
		    
		    i=0;

		    Iterator itCUT2 = evaluateCUT.entrySet().iterator();
		    while (itCUT2.hasNext()) {
		    	Map.Entry pairs = (Map.Entry)itCUT2.next();		        

		    	m.put("CUT_Release_TimeStep_"+i, ""+pairs.getKey()+"");	
		    	m.put("CUT_Release_Value_"+i, pairs.getValue());	
		    	m.put("CUT_Release_Action_"+i, "after CUT");
		    	i++;

		    	//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("CUT_Release_TOTAL", i);
		    evaluateCUT.clear();
		    
		    
		    i=0;

		    Iterator itSTOP2 = evaluateSTOP.entrySet().iterator();
		    while (itSTOP2.hasNext()) {
		    	Map.Entry pairs = (Map.Entry)itSTOP2.next();		        

		    	m.put("STOP_Release_TimeStep_"+i, ""+pairs.getKey()+"");	
		    	m.put("STOP_Release_Value_"+i, pairs.getValue());	
		    	m.put("STOP_Release_Action_"+i, "after STOP");
		    	i++;

		    	//it.remove(); // avoids a ConcurrentModificationException
		    }
		    m.put("STOP_Release_TOTAL", i);
		    evaluateSTOP.clear();
		    
			
			m.putAll(getState().export());
		}
		return m;
	}	
	

	/*
	public Map<Object, Object> specializedExport_BAK() {

		Map<Object, Object> m=new HashMap<Object,Object>();
		if(carrierCreated>0 && !hasExported){
			m.put("Typev", "PlateletVessel");

			float[] center=new float[3];
			float[] domainCenter=getDomain().getAbsCenter();

			center=getCenter();		
			
			if(Float.isNaN(center[0]) || Float.isNaN(center[1]) || Float.isNaN(center[2])){
				System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> NaN NaN NaN");
			}
			
			m.put("IDv", "Platelet-"+ID);	
			m.put("Xv", center[0]-domainCenter[0]);
			m.put("Yv", center[1]-domainCenter[1]);
			m.put("Zv", center[2]-domainCenter[2]);
			//m.put("TimeStepv", ""+releaseTime+"");	
			m.put("Emissionv", carrierCreated);
			m.put("Actionv", "emission");
			m.putAll(getState().export());

			hasExported=true;
		}
		return m;
	}
	*/
	
	
	
	/*
	public void setCenter(float x, float y, float z){
		if(Float.isNaN(x) || Float.isNaN(y) || Float.isNaN(z)){
			System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> NaN NaN NaN");
			try {
				throw new Exception();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		super.setCenter(x,y,z);
	}
	*/
	
	@Override
	public void createSingleReceptor(float[] cdCenter, float radius, short receptorRadius, int receptorType) {
		float[] angles=convertSphericalAngles(cdCenter[0],cdCenter[1],cdCenter[2], radius);
		float theta=angles[1];
		float fi=angles[0];

		
		Receptor r=new TCPLike_ReceptorB(this, true, cdCenter, theta, fi, receptorRadius, receptorType, this.eventHandler);
		receptorList.add(r);
		receptorSetup(r); 

		/** Draw each Receptor */
		/*
		for(int i=0; i<receptorList.size(); i++){
			((CD40UniversalReceptor) receptorList.get(i)).drawSmallPoint(receptorList.get(i).getParent());
		}
		*/		
	}
	
	public void createReceptor(int n){		

		Receptor r = null;		
		float theta=0;
		float fi=0;			

		for (int i=0;i<n;i++){
			theta=getDomain().getMobilityModel().getRandomAngles()[0];
			fi=getDomain().getMobilityModel().getRandomAngles()[1];		

			double radius=getRadius();			
			float[] coords=new float[3];
			coords[0]=(float) (radius*Math.sin((double)theta)*Math.cos((double)fi));
			coords[1]=(float) (radius*Math.sin((double)theta)*Math.sin((double)fi));
			coords[2]=(float) (radius*Math.cos((double)theta));			

			r=new TCPLike_ReceptorB(this, true, coords, theta, fi, getManager().configWrapper.receptorStateConfig.get(receptorNumberType+"-radius").shortValue(),receptorNumberType, this.eventHandler);
			receptorList.add(r);
			//receptorSetup(r);
			r.attachObs(r.getMyObserver());
		}
	}	

	@Override
	public void receptorSetup(Receptor r) {
		List<LigandObserver> obsList=getObsList();
		int index=rand.nextInt(obsList.size());
		r.attachObs(obsList.get(index));
	}

	@Override
	public void setMotionStrategy() {		
		this.motionStrategy=NoMotion.getInstance();
	}

	public float getAbsDistancePlusRadius(){
		float distance=0;
		if(receptorList.size()>0){
			distance=getAbsDistance()+getRadius()+receptorList.get(0).radius/2;
		}else{
			distance=getAbsDistance()+getRadius();
		}
		return distance;
	}

	public float getAbsDistanceMinusRadius(){
		float distance=0;
		if(receptorList.size()>0){
			distance=getAbsDistance()-getRadius()-receptorList.get(0).radius/2;
		}else{
			distance=getAbsDistance()-getRadius();
		}
		return distance;
	}

	public void activateCell() {
		//releaseTime=getManager().getCurrentTime();
		setState(new nEncode(this));
		getState().setExecutionTime(0);	
	}

	public String assignName(){		
		return "TCPLike-TX Node";		
	}

	@Override
	public void processInfo() {
		// TODO Auto-generated method stub
		
	}
	
	public void exec(){
		
		timestep=getManager().getCurrentTime();
		//int bufferSize=circularBufferAssimilations.length;
		pos=(int) (timestep%windowSize);
		
		currentAssimilation=0;
		circularBufferAssimilations[pos]=0;
		
		
		super.exec();
	}
	
	public void downloadInfoFrom(CarrierObj c, Receptor r){		
		informationCount++;	
		currentAssimilation++;
		
		/** CIRCULAR BUFFER */
		/*
		long timestep=getManager().getCurrentTime();
		int size=circularBufferAssimilations.length;
		int pos=(int) (timestep%size);
		*/
		
		circularBufferAssimilations[pos]=currentAssimilation;
		/** END OF CIRCULAR BUFFER */
		c.destroy();
		
	}
	
	public void saveAllAndExit(){
		getManager().hasStopped=true;
		//getManager().specializedExport();
	}
}