package simulator;

import java.util.List;

import MainLibrary.AbstractDomain;
import MainLibrary.CarrierObj;
import MainLibrary.LigandObserver;
import MainLibrary.nIdle;

public class TCPLike_Node_TX_Punctiform extends TCPLike_Node_TX {
	
	public boolean hasTransmit=false;

	public TCPLike_Node_TX_Punctiform(AbstractDomain domain, float x, float y,
			float z, int nodeNumberType, long emissionThreshold,
			List<LigandObserver> observer) {
		super(domain, x, y, z, nodeNumberType, emissionThreshold, observer);
		// TODO Auto-generated constructor stub
	}

	public int createCarriers(int n){
		int createdNow=0;		
		
		while (n>0){				
			TCPLike_Carrier_A cc=new TCPLike_Carrier_A(getInnerDomain(), this, getCenter()[0], getCenter()[1], getCenter()[2],5);			
			cc.setMotionStrategy(BrownianMotion.getInstance());	
						
			n--;
			createdNow++;	
			cc.packetType=getNextPacketType();
		}
		carrierCreated=carrierCreated+createdNow;
		
		return createdNow;
	}
	
	
	public void emitsWithoutReceptors(){
		
		float theta=0;
		float fi=0;			
		
		int undisposedCarriers=getInnerDomain().undisposedCarrierList.size();

		for(int i=undisposedCarriers-1;i>=0;i--){		
		
		//for (int i=0;i<undisposedCarriers;i++){				
			
			if(getDomain()==null){
				System.out.println();
				System.out.println("*** TCP_NODE_TX_Punctiform: emitsWithoutReceptors() -> DOMINIOP DEL NODO = NULL!");
				System.out.println();
			}
		
			CarrierObj carrier=getInnerDomain().undisposedCarrierList.get(i);	
			carrier.removeFromActualDomain();
			//carrier.setDomain(getDomain());  			
			
			fi=(float) (2*Math.PI*(rand.nextFloat())); //fi
			theta=(float) ((Math.acos((2*rand.nextFloat())-1))); //theta

			double radius=getRadius();	
			radius=radius+2*carrier.getRadius();
			float[] coords=new float[3];
			coords[0]=(float) (radius*Math.sin((double)theta)*Math.cos((double)fi));
			coords[1]=(float) (radius*Math.sin((double)theta)*Math.sin((double)fi));
			coords[2]=(float) (radius*Math.cos((double)theta));					

			float[] nodeCenter=getCenter();			
			float x=coords[0]+nodeCenter[0];
			float y=coords[1]+nodeCenter[1];
			float z=coords[2]+nodeCenter[2];

			//if (getDomain().isFreeSpace(carrier)){			
			getDomain().attachNanoObj(carrier);
			carrier.disposeOnMedium();
			//getInnerDomain().undisposedCarrierList.remove(carrier);	

			//}else{			
			//	System.out.println(">>> Delayed Upload: "+getProcessingTime());
			//}	

			carrier.setCenter(x, y, z);
			carrier.setVelocityComponent(carrier.getVelocityModule(), fi, theta);	
			
			hasTransmit=true;
		}
		getInnerDomain().undisposedCarrierList.clear();		
	}
	
	
	public void exec(){
		super.exec();
		if(hasTransmit) {
			kill();
		}
	}	
}
