
package simulator;

import java.util.HashMap;
import java.util.Map;

import MainLibrary.CarrierObj;
import MainLibrary.EventHandlerForReceptors;
import MainLibrary.LigandObserver;
import MainLibrary.NodeObj;
import MainLibrary.Receptor;
import MainLibrary.rDownloading;
import MainLibrary.rRandomDownloading;

public class TCPLike_ReceptorA extends Receptor{
	
	public int totalAssimilations=0;
	public int ID=-1;
	protected Map<Object, Object> m=new HashMap<Object,Object>();		
	
	public TCPLike_ReceptorA(NodeObj node, boolean canDownload, float[] center, float theta, float fi, short r, int type, EventHandlerForReceptors e, int ID) {
		super(node, canDownload, center, theta, fi, r, type, e);
		this.ID=ID;
	}
	
	public TCPLike_ReceptorA(NodeObj node, boolean canDownload, float[] center, float theta, float fi, short r, int type, EventHandlerForReceptors e) {
		super(node, canDownload, center, theta, fi, r, type, e);		
	}


	@Override
	public void downloadCarrier(CarrierObj c) {
		node.downloadInfoFrom(c,this);
	}

	@Override
	public Map<Object,Object> export() {
		
		String dd="0";
		if(canDownload) dd="1";
		
		m.put("Receptor_"+ID, ID+" "+dd+" "+theta+" "+fi+" "+totalAssimilations);

	    //m.put("ID_Receptor", ID );	
	    //m.put("theta_"+ID, theta);	
	    //m.put("fi_"+ID, fi);	    
	    //m.put("assimilations_"+ID, totalAssimilations);			
		
		return m;		
	}
	
	// Creates the Receptor Assimilation Map
	@Override
	public void configureForDownload(CarrierObj c){		
		totalAssimilations++;			
		super.configureForDownload(c);
	}
		
	// NEW FEATURE
	public void configureForDownload(CarrierObj c, boolean isRandomDownload){		
		totalAssimilations++;			
		super.configureForDownload(c, isRandomDownload);
	}

	@Override
	public LigandObserver getMyObserver() {		
		return TCPLike_CarrierA_Observer.getInstance();
	}
	
	public String assignName(){
		return "TCPLike_CarrierA_Receptor";	
	}
}
