package simulator;

import java.io.*;
import java.util.*;
import MainLibrary.OutputStrategy;
import MainLibrary.UniversalReceptor;


public class WriteReceptorsFile {

	private static WriteReceptorsFile instance=null;
	private static String fileName=null;
	private static FileOutputStream file;
	private static PrintStream Output;
	private WriteReceptorsFile(){

	}

	public static WriteReceptorsFile getInstance(){
		if (instance==null) instance=new WriteReceptorsFile();

		try {
			file = new FileOutputStream(instance.getFileName(),true);
			Output = new PrintStream(file);

		} catch (IOException e) {
			System.out.println("Output Error: " + e);
		}
		return instance;
	}

	public void initialize(){
		try {

			file = new FileOutputStream(getFileName(),true);
			Output = new PrintStream(file);		
			Output.println("ID x y z");

		} catch (IOException e) {
			System.out.println("Initialize Output Error: " + e);

		} finally {
			// Close resource.
			if (file!= null) try { 
				file.close();
			} catch (IOException logOrIgnore) {
				System.out.println("Output Error [closing file]: " + logOrIgnore);
			}
		}
	}

	public void export(ArrayList<UniversalReceptor> receptorList) {

		try {

			file = new FileOutputStream(getFileName(),true);
			Output = new PrintStream(file);

			int size=receptorList.size();
			for(int j=0;j<size;j++){

				Output.print(receptorList.get(j).getID()+" ");
				Output.println(receptorList.get(j).getRelativeCoords()[0]+" "+receptorList.get(j).getRelativeCoords()[1]+" "+receptorList.get(j).getRelativeCoords()[2]);	
			}			

		} catch (IOException e) {
			System.out.println("Output Error: " + e);

		} finally {
			// Close resource.
			if (file!= null) try { 
				file.close();
			} catch (IOException logOrIgnore) {
				System.out.println("Output Error [closing file]: " + logOrIgnore);
			}
		}
	} 	

	public void close(){

	}

	public String getFileName(){		
		fileName="Receptors"+OutputStrategy.getRandomFileName()+".txt";
		return fileName;
	}	   
}
